PROMPT Creacin de las Tablas AB60

CREATE TABLE AB6101T00
(
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	ID_DIRECCION         NUMBER(8) NOT NULL ,
	ID_AREA              NUMBER(8) NOT NULL ,
	COD_PROCEDURE_ID     VARCHAR2(20 CHAR) NULL ,
	FOLDER_ID            VARCHAR2(64 CHAR) NULL ,
	FOLDER_NUMBER        VARCHAR2(24 CHAR) NULL ,
	CAMPOS_TITULO_EXPEDIENTE VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6101T00 IS 'Tabla de Procediminetos de las ayudas, es decir, las convocatorias de las ayudas';
COMMENT ON COLUMN AB6101T00.ID_PROCEDIMIENTO IS 'Identificador interno del Procedimiento (secuencia)';
COMMENT ON COLUMN AB6101T00.COD_PROCEDURE_ID IS 'Identificador del Procedimiento en PLATEA';
COMMENT ON COLUMN AB6101T00.FOLDER_ID IS 'Identificador del Expediente en PLATEA';
COMMENT ON COLUMN AB6101T00.FOLDER_NUMBER IS 'Nmero de Expediente en PLATEA';
COMMENT ON COLUMN AB6101T00.ID_DIRECCION IS 'Identificador de la Direccin del Departamento (Comercio/Turismo)';
COMMENT ON COLUMN AB6101T00.ID_AREA IS 'Identificador del rea (Ordenacin/Promocin)';
COMMENT ON COLUMN AB6101T00.CAMPOS_TITULO_EXPEDIENTE IS 'Campos del Toolkit de Formularios que se utilizarn para generar el Ttulo del Expediente.';
COMMENT ON COLUMN AB6101T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6101T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6001T00

CREATE TABLE AB6102T00
(
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	ID_TERRITORIO_HISTORICO NUMBER(2) NULL ,
	FOLDER_ID            VARCHAR2(64 CHAR) NULL ,
	FOLDER_NUMBER        VARCHAR2(24 CHAR) NULL ,
	TITULO               VARCHAR2(1024 CHAR) NULL ,
	FECHA_ENTRADA        DATE NULL ,
	FECHA_DOC_FOR        DATE NULL ,
	FECHA_ULT_APOR       DATE NULL ,
	FECHA_ENV_ULT_REQ    DATE NULL ,
	FECHA_ACU_ULT_REQ    DATE NULL ,
	FECHA_DOC_COM        DATE NULL ,
	FECHA_RESOLUCION     DATE NULL ,
	FECHA_ACU_RES        DATE NULL ,
	FECHA_INCOACION      DATE NULL ,
	FECHA_INCUMPLIMIENTO DATE NULL ,
	FECHA_RENUNCIA       DATE NULL ,
	FECHA_DESISTIMIENTO  DATE NULL ,
	FECHA_CIERRE         DATE NULL ,
	FECHA_RECURSO        DATE NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6102T00 IS 'Tabla de Expedientes';
COMMENT ON COLUMN AB6102T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente (secuencia)';
COMMENT ON COLUMN AB6102T00.FOLDER_NUMBER IS 'Nmero de Expediente en PLATEA';
COMMENT ON COLUMN AB6102T00.FOLDER_ID IS 'Identificador del Expediente en PLATEA';
COMMENT ON COLUMN AB6102T00.TITULO IS 'Titulo del Expediente. Los valores de este campo se generarn a partir de ciertos campos del Toolkit de Formularios';
COMMENT ON COLUMN AB6102T00.ID_PROCEDIMIENTO IS 'Identificador del procedimiento';
COMMENT ON COLUMN AB6102T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6102T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6102T00.ID_TERRITORIO_HISTORICO IS 'Identificador del Territorio Histrico, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6102T00.FECHA_ENTRADA IS 'Fecha cuando se ha presentado la Solicitud, Fecha de Solicitud';
COMMENT ON COLUMN AB6102T00.FECHA_DOC_FOR IS 'Fecha de Documentacin Formal';
COMMENT ON COLUMN AB6102T00.FECHA_ULT_APOR IS 'Fecha de ltima Aportacin';
COMMENT ON COLUMN AB6102T00.FECHA_ENV_ULT_REQ IS 'Fecha de Envo de ltimo Requerimiento';
COMMENT ON COLUMN AB6102T00.FECHA_ACU_ULT_REQ IS 'Fecha de Acuse de ltimo Requerimiento';
COMMENT ON COLUMN AB6102T00.FECHA_DOC_COM IS 'Fecha de la Documentacin Completa';
COMMENT ON COLUMN AB6102T00.FECHA_RESOLUCION IS 'Fecha de Resolucin';
COMMENT ON COLUMN AB6102T00.FECHA_ACU_RES IS 'Fecha de Acuse de Resolucin';
COMMENT ON COLUMN AB6102T00.FECHA_INCOACION IS 'Fecha de Incoacin';
COMMENT ON COLUMN AB6102T00.FECHA_INCUMPLIMIENTO IS 'Fecha de Incumplimiento';
COMMENT ON COLUMN AB6102T00.FECHA_RENUNCIA IS 'Fecha de Renuncia';
COMMENT ON COLUMN AB6102T00.FECHA_DESISTIMIENTO IS 'Fecha de Desistimiento';
COMMENT ON COLUMN AB6102T00.FECHA_CIERRE IS 'Fecha de Cierre';
COMMENT ON COLUMN AB6102T00.FECHA_RECURSO IS 'Fecha de Recurso/Alegacin';


PROMPT Creacin de la Tabla AB6102T00

CREATE TABLE AB6103T00
(
	ID_REL_EXP_TER_EMP   NUMBER(8) NOT NULL ,
	ID_TERCERO           NUMBER(8) NULL ,
	ID_EMPRESA           NUMBER(8) NULL ,
	ID_TIPO_TERCERO      NUMBER(2) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6103T00 IS 'Relacin de Terceros o Empresas con el Expediente';
COMMENT ON COLUMN AB6103T00.ID_EXPEDIENTE IS 'Identificador del Expediente';
COMMENT ON COLUMN AB6103T00.ID_REL_EXP_TER_EMP IS 'Identificador interno del Tercero o Empresa del Expediente (secuencia)';
COMMENT ON COLUMN AB6103T00.ID_TERCERO IS 'Identificador del Tercero';
COMMENT ON COLUMN AB6103T00.ID_EMPRESA IS 'Identificador de Empresa';
COMMENT ON COLUMN AB6103T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6103T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6103T00.ID_TIPO_TERCERO IS 'Identificador interno de Tipo de Tercero';


PROMPT Creacin de la Tabla AB6103T00

CREATE TABLE AB6104T00
(
	ID_TERCERO           NUMBER(8) NOT NULL ,
	DOCUMENTO            VARCHAR2(65 CHAR) NULL ,
	ID_TIPO_DOCUMENTO    NUMBER(2) NULL ,
	NOMBRE               VARCHAR2(260 CHAR) NULL ,
	APELLIDO1            VARCHAR2(260 CHAR) NULL ,
	APELLIDO2            VARCHAR2(260 CHAR) NULL ,
	ID_SEXO              NUMBER(2) NULL ,
	TELEFONO             NUMBER(10) NULL ,
	EMAIL                VARCHAR2(100 CHAR) NULL ,
	DIRECCION            VARCHAR2(100 CHAR) NULL ,
	NUMERO               VARCHAR2(10 CHAR) NULL ,
	ESCALERA             VARCHAR2(4 CHAR) NULL ,
	PISO                 VARCHAR2(4 CHAR) NULL ,
	LETRA                VARCHAR2(4 CHAR) NULL ,
	CODIGO_POSTAL        VARCHAR2(5 CHAR) NULL ,
	ID_PROVINCIA         NUMBER(2) NULL ,
	ID_MUNICIPIO         NUMBER(3) NULL ,
	ID_LOCALIDAD         NUMBER(15) NULL ,
	FECHA_NACIMIENTO     DATE NULL ,
	ID_PAIS_NACIMIENTO   NUMBER(8) NULL ,
	ID_PROVINCIA_NACIMIENTO NUMBER(2) NULL ,
	ID_MUNICIPIO_NACIMIENTO NUMBER(3) NULL ,
	TERRITORIO_NACIMIENTO VARCHAR2(200 CHAR) NULL ,
	LOCALIDAD_NACIMIENTO VARCHAR2(200 CHAR) NULL ,
	NUM_SEG_SOCIAL       VARCHAR2(14 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6104T00 IS 'Tabla de Terceros';
COMMENT ON COLUMN AB6104T00.ID_TERCERO IS 'Identificador interno del Tercero (secuencia)';
COMMENT ON COLUMN AB6104T00.DOCUMENTO IS 'DNI, NIF o Pasaporte del tercero';
COMMENT ON COLUMN AB6104T00.NOMBRE IS 'Nombre del Tercero';
COMMENT ON COLUMN AB6104T00.APELLIDO1 IS 'Primer Apellido del Tercero';
COMMENT ON COLUMN AB6104T00.APELLIDO2 IS 'Segundo Apellido del Tercero';
COMMENT ON COLUMN AB6104T00.FECHA_NACIMIENTO IS 'Fecha de Nacimiento del Tercero (BEC)';
COMMENT ON COLUMN AB6104T00.ID_TIPO_DOCUMENTO IS 'Tipo de Documento: DNI, NIE, Pasaporte u Otro';
COMMENT ON COLUMN AB6104T00.NUM_SEG_SOCIAL IS 'Nmero de la Serguridad Social del tercero (BEC)';
COMMENT ON COLUMN AB6104T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6104T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6104T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6104T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6104T00.ID_PAIS_NACIMIENTO IS 'Identificador del Pis de Nacimiento del Tercero (BEC), mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.ID_PROVINCIA_NACIMIENTO IS 'Identificador del Territorio histrico, Comunidad  Provincia de Nacimiento del Tercero cuyo pas es Espaa (BEC), mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.ID_MUNICIPIO_NACIMIENTO IS 'Identificador del Municipio de Nacimiento del Tercero cuyo pas es Espaa (BEC), mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.TERRITORIO_NACIMIENTO IS 'Territorio o Provincia de Nacimiento de un Tercero de Otro Pis que no sea Espaa (BEC)';
COMMENT ON COLUMN AB6104T00.LOCALIDAD_NACIMIENTO IS 'Localidad de Nacimiento de un Tercero de Otro Pis que no sea Espaa (BEC)';
COMMENT ON COLUMN AB6104T00.ID_SEXO IS 'Identificador interno de Sexo del Tercero';
COMMENT ON COLUMN AB6104T00.TELEFONO IS 'Telfono del Tercero';
COMMENT ON COLUMN AB6104T00.EMAIL IS 'Email del Tercero';
COMMENT ON COLUMN AB6104T00.DIRECCION IS 'Direccin del Domicilio del Titular';
COMMENT ON COLUMN AB6104T00.NUMERO IS 'Nmero de la Direccin del Domicilio del Titular';
COMMENT ON COLUMN AB6104T00.PISO IS 'Piso de la Direccin del Domicilio del Titular';
COMMENT ON COLUMN AB6104T00.LETRA IS 'Letra de la Direccin del Domicilio del Titular';
COMMENT ON COLUMN AB6104T00.CODIGO_POSTAL IS 'Cdigo de Postal de la Direccin del Domicilio del Titular';
COMMENT ON COLUMN AB6104T00.ID_PROVINCIA IS 'Identificador de la Provincia del Domicilio del Titular, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.ID_MUNICIPIO IS 'Identificador del Municipio del Domicilio del Titular, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.ID_LOCALIDAD IS 'Identificador de la Localidad del Domicilio del Titular, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6104T00.ESCALERA IS 'Escalera de la Direccin del Domicilio del Titular';


PROMPT Creacin de la Tabla AB6104T00

CREATE TABLE AB6105T00
(
	ID_EMPRESA           NUMBER(8) NOT NULL ,
	NOMBRE               VARCHAR2(260 CHAR) NULL ,
	NIF                  VARCHAR2(65 CHAR) NULL ,
	DIRECCION            VARCHAR2(100 CHAR) NULL ,
	NUMERO               VARCHAR2(10 CHAR) NULL ,
	ESCALERA             VARCHAR2(4 CHAR) NULL ,
	PISO                 VARCHAR2(4 CHAR) NULL ,
	LETRA                VARCHAR2(4 CHAR) NULL ,
	CODIGO_POSTAL        VARCHAR2(5 CHAR) NULL ,
	PAGINA_WEB           VARCHAR2(50 CHAR) NULL ,
	ID_PROVINCIA         NUMBER(2) NULL ,
	ID_MUNICIPIO         NUMBER(3) NULL ,
	ID_LOCALIDAD         NUMBER(15) NULL ,
	ID_IAE               VARCHAR2(10 CHAR) NULL ,
	FECHA_ALTA_EMPRESA   DATE NULL ,
	FECHA_ALTA_ESTABL    DATE NULL ,
	NUMERO_SOCIOS        NUMBER(4) NULL ,
	NUMERO_SOCIAS        NUMBER(4) NULL ,
	PLANTILLA_HOMBRES    NUMBER(4) NULL ,
	PLANTILLA_MUJERES    NUMBER(4) NULL ,
	TELEFONO             NUMBER(10) NULL ,
	FAX                  NUMBER(10) NULL ,
	EMAIL                VARCHAR2(100 CHAR) NULL ,
	HORARIO_ATENCION     VARCHAR2(100 CHAR) NULL ,
	EQUIPAMIENTO         VARCHAR2(500 CHAR) NULL ,
	NUMERO_REGISTRO      VARCHAR2(50 CHAR) NULL ,
	ID_TIPO_EMPRESA      NUMBER(2) NULL ,
	ID_DATO_EMPLEO       NUMBER(2) NULL ,
	DAT_EMP_MES_ANT      NUMBER(8) NULL ,
	DAT_EMP_ANYO_ANT     NUMBER(8) NULL ,
	DAT_EMP_EJE_ANT      NUMBER(8) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6105T00 IS 'Tabla de Empresas  / Establecimientos';
COMMENT ON COLUMN AB6105T00.ID_EMPRESA IS 'Identificador de Empresa / Establecimiento (secuencia)';
COMMENT ON COLUMN AB6105T00.NOMBRE IS 'Nombre de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.DIRECCION IS 'Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.NUMERO IS 'Nmero de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.PISO IS 'Pisode la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.LETRA IS 'Letra de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.CODIGO_POSTAL IS 'Cdigo Postal de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.ID_PROVINCIA IS 'Identificador de la Provincia, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6105T00.PAGINA_WEB IS 'Pgina Web de la Empresa';
COMMENT ON COLUMN AB6105T00.FECHA_ALTA_EMPRESA IS 'Fecha de Alta de la Empresa en el I.A.E. (MEC)';
COMMENT ON COLUMN AB6105T00.FECHA_ALTA_ESTABL IS 'Fecha de Alta del Establecimiento en el I.A.E. (MEC)';
COMMENT ON COLUMN AB6105T00.NUMERO_SOCIOS IS 'Nmero de Socios en la Empresa (MEC)';
COMMENT ON COLUMN AB6105T00.NUMERO_SOCIAS IS 'Nmero de Socias en la Empresa (MEC)';
COMMENT ON COLUMN AB6105T00.NIF IS 'NIF de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6105T00.ID_MUNICIPIO IS 'Identificador del Municipio, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6105T00.ID_LOCALIDAD IS 'Identificador de la Localidad, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6105T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6105T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6105T00.TELEFONO IS 'Telfono de la Sede Social (OTC)';
COMMENT ON COLUMN AB6105T00.FAX IS 'Fax de la Sede Social (OTC)';
COMMENT ON COLUMN AB6105T00.EMAIL IS 'Email de la Sede Social (OTC)';
COMMENT ON COLUMN AB6105T00.HORARIO_ATENCION IS 'Horario de atencin al pblico de la Sede Social (OTC)';
COMMENT ON COLUMN AB6105T00.EQUIPAMIENTO IS 'Equipamiento oficina de la Sede Social (OTC)';
COMMENT ON COLUMN AB6105T00.PLANTILLA_HOMBRES IS 'Nmero de Hombres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado';
COMMENT ON COLUMN AB6105T00.PLANTILLA_MUJERES IS 'Nmero de Mujeres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado';
COMMENT ON COLUMN AB6105T00.ID_IAE IS 'Identificador nico del Impuestos sobre Actividades Econmicas (I.A.E) (MEC)';
COMMENT ON COLUMN AB6105T00.ID_TIPO_EMPRESA IS 'Identificador del Tipo de Empresa (EMET)';
COMMENT ON COLUMN AB6105T00.ID_DATO_EMPLEO IS 'Identificador interno de Dato de Empleo (EMET)';
COMMENT ON COLUMN AB6105T00.NUMERO_REGISTRO IS 'Nmero de Registro (EMET)';
COMMENT ON COLUMN AB6105T00.DAT_EMP_MES_ANT IS 'Dato de empleo que figure en el TC2 ms el del personal no asalariado, correspondientes al mes anterior al de la solicitud';
COMMENT ON COLUMN AB6105T00.DAT_EMP_ANYO_ANT IS '-Dato de empleo que figure en el TC2 ms el del personal no asalariado, correspondientes al mismo mes que en el caso anterior pero del ao anterior a la presente convocatoria
-Dato de empleo de las plantillas medias de trabajadores ms el de los trabajadores no asalariados del ejercicio correspondiente a 2 aos anteriores a la presente convocatoria:';
COMMENT ON COLUMN AB6105T00.DAT_EMP_EJE_ANT IS 'Dato de empleo de las plantillas medias de trabajadores ms el de los trabajadores no asalariados del ejercicio anterior a la presente convocatoria';
COMMENT ON COLUMN AB6105T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro (en este caso esta modificacin se realizar con el PL/SQL de carga)';
COMMENT ON COLUMN AB6105T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro (en este caso esta modificacin se realizar con el PL/SQL de carga)';
COMMENT ON COLUMN AB6105T00.ESCALERA IS 'Escalera de la Direccin de la Empresa / Establecimiento';

PROMPT Creacin de la Tabla AB6105T00

CREATE TABLE AB6106T00
(
	ID_TIPO_TERCERO      NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(50 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(50 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6106T00 IS 'Catlogo de Tipos de Terceros: Solicitante, Persona de Contacto, Representante, Interesado, Ubicacin de la inversin y Representante Legal';
COMMENT ON COLUMN AB6106T00.ID_TIPO_TERCERO IS 'Identificador interno de Tipo de Tercero';
COMMENT ON COLUMN AB6106T00.DESCRIPCION_CASTELLANO IS 'Descripcin del Tipo de Tercero en Castellano';
COMMENT ON COLUMN AB6106T00.DESCRIPCION_EUSKERA IS 'Descripcin del Tipo de Tercero en Euskera';
COMMENT ON COLUMN AB6106T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6106T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6106T00

CREATE TABLE AB6107T00
(
	ID_TIPO_DOCUMENTO    NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(20 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(20 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6107T00 IS 'Catlogo de los Tipos de Documento: DNI, CIF, NIE, Pasaporte, Otros.';
COMMENT ON COLUMN AB6107T00.ID_TIPO_DOCUMENTO IS 'Identicador del Tipo de Documento';
COMMENT ON COLUMN AB6107T00.DESCRIPCION_CASTELLANO IS 'Descripcin del Tipo de Documento en Castellano';
COMMENT ON COLUMN AB6107T00.DESCRIPCION_EUSKERA IS 'Descripcin del Tipo de Documento en Euskera';
COMMENT ON COLUMN AB6107T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6107T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6107T00

CREATE TABLE AB6108T00
(
	ID_LISTADO           NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	NOMBRE               VARCHAR2(50 CHAR) NULL ,
	SQL_LISTADO          VARCHAR2(2000 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6108T00 IS 'Tabla de Listados por Procedimiento';
COMMENT ON COLUMN AB6108T00.ID_LISTADO IS 'Identificador interno del Listado (secuencia)';
COMMENT ON COLUMN AB6108T00.NOMBRE IS 'Nombre del Listado';
COMMENT ON COLUMN AB6108T00.SQL_LISTADO IS 'Sentencia SQL a ejecutar para obtener el resultado del listado';
COMMENT ON COLUMN AB6108T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6108T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6108T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6108T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6108T00.ID_PROCEDIMIENTO IS 'Identificador interno del Procedimiento';


PROMPT Creacin de la Tabla AB6108T00

CREATE TABLE AB6109T00
(
	ID_PARAMETRO         NUMBER(8) NOT NULL ,
	ID_LISTADO           NUMBER(8) NOT NULL ,
	NOMBRE               VARCHAR2(50 CHAR) NULL ,
	VALOR                VARCHAR2(50 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6109T00 IS 'Tabla de Parmetros del Listado de un Procedimiento';
COMMENT ON COLUMN AB6109T00.ID_PARAMETRO IS 'Identificador interno del Parmtero del Listado(secuencia)';
COMMENT ON COLUMN AB6109T00.NOMBRE IS 'Nombre del parmetro del listado que tiene que coincidir con el nombre de la Columna de la tabla';
COMMENT ON COLUMN AB6109T00.VALOR IS 'Texto a mostrar para que el usuario pueda determinar el parmetro';
COMMENT ON COLUMN AB6109T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6109T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6109T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6109T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6109T00.ID_LISTADO IS 'Identificador interno del Listado';


PROMPT Creacin de la Tabla AB6109T00

CREATE TABLE AB6110T00
(
	ID_PLANTILLA         NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	ID_TIPO_PLANTILLA    NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(100 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(100 CHAR) NULL ,
	DOCUMENTO            VARCHAR2(20 CHAR) NULL ,
	OBSERVACIONES        VARCHAR2(500 CHAR) NULL ,
	DOC_PLANTILLA        BLOB NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6110T00 IS 'Tabla de Plantillas por Procedimiento';
COMMENT ON COLUMN AB6110T00.ID_PLANTILLA IS 'Identificador interno de Plantilla (secuencia)';
COMMENT ON COLUMN AB6110T00.ID_PROCEDIMIENTO IS 'Identificador del Procedimiento';
COMMENT ON COLUMN AB6110T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano de la Plantilla';
COMMENT ON COLUMN AB6110T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera de la Plantilla';
COMMENT ON COLUMN AB6110T00.OBSERVACIONES IS 'Observaciones de la Plantilla';
COMMENT ON COLUMN AB6110T00.DOC_PLANTILLA IS 'Documento de la plantilla: archivo RTF para combinar';
COMMENT ON COLUMN AB6110T00.ID_TIPO_PLANTILLA IS 'Identificador del Tipo de Plantilla';
COMMENT ON COLUMN AB6110T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6110T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6110T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6110T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6110T00.DOCUMENTO IS 'Nombre del Documento de la Plantilla';


PROMPT Creacin de la Tabla AB6110T00

CREATE TABLE AB6111T00
(
	ID_TIPO_PLANTILLA    NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(100 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6111T00 IS 'Catlogo de Tipos de Plantillas';
COMMENT ON COLUMN AB6111T00.ID_TIPO_PLANTILLA IS 'Identificador interno del Tipo de Plantilla';
COMMENT ON COLUMN AB6111T00.DESCRIPCION_CASTELLANO IS 'Nombre del Tipo de Plantilla en Castellano';
COMMENT ON COLUMN AB6111T00.DESCRIPCION_EUSKERA IS 'Nombre del Tipo de Plantilla en Euskera';
COMMENT ON COLUMN AB6111T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6111T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6111T00

CREATE TABLE AB6112T00
(
	ID_DEPARTAMENTO      NUMBER(8) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(255 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(255 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6112T00 IS 'Catlogo de Departamentos';
COMMENT ON COLUMN AB6112T00.ID_DEPARTAMENTO IS 'Identificador interno del Departamento';
COMMENT ON COLUMN AB6112T00.DESCRIPCION_CASTELLANO IS 'Nombre del Departamento en Castellano';
COMMENT ON COLUMN AB6112T00.DESCRIPCION_EUSKERA IS 'Nombre del Departamento en Euskera';
COMMENT ON COLUMN AB6112T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6112T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6112T00

CREATE TABLE AB6113T00
(
	ID_DIRECCION         NUMBER(8) NOT NULL ,
	ID_DEPARTAMENTO      NUMBER(8) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(255 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(255 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6113T00 IS 'Catlogo de Direcciones';
COMMENT ON COLUMN AB6113T00.ID_DIRECCION IS 'Identificador interno de Direccin';
COMMENT ON COLUMN AB6113T00.DESCRIPCION_CASTELLANO IS 'Nombre de la Direccin en Castellano';
COMMENT ON COLUMN AB6113T00.DESCRIPCION_EUSKERA IS 'Nombre de la Direccin en Euskera';
COMMENT ON COLUMN AB6113T00.ID_DEPARTAMENTO IS 'Identificador del Departamento';
COMMENT ON COLUMN AB6113T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6113T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6113T00

CREATE TABLE AB6114T00
(
	ID_AREA              NUMBER(8) NOT NULL ,
	ID_DIRECCION         NUMBER(8) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(255 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(255 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6114T00 IS 'Catlogo de reas';
COMMENT ON COLUMN AB6114T00.ID_AREA IS 'Identificador interno del rea';
COMMENT ON COLUMN AB6114T00.DESCRIPCION_CASTELLANO IS 'Nombre del rea en Castellano';
COMMENT ON COLUMN AB6114T00.DESCRIPCION_EUSKERA IS 'Nombre del rea en Euskera';
COMMENT ON COLUMN AB6114T00.ID_DIRECCION IS 'Identificador de Direccin';
COMMENT ON COLUMN AB6114T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6114T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6114T00

CREATE TABLE AB6115T00
(
	ID_TIPO_CANAL_AVISO  NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(50 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(50 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6115T00 IS 'Catlogo de Tipos de Canales de Aviso: Telfono / Correo electrnico';
COMMENT ON COLUMN AB6115T00.ID_TIPO_CANAL_AVISO IS 'Identificador dle Tipo de Canal de Aviso';
COMMENT ON COLUMN AB6115T00.DESCRIPCION_CASTELLANO IS 'Descripcin del Tipo de Canal de Aviso en Castellano';
COMMENT ON COLUMN AB6115T00.DESCRIPCION_EUSKERA IS 'Descripcin del Tipo de Canal de Aviso en Euskera';
COMMENT ON COLUMN AB6115T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6115T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6115T00

CREATE TABLE AB6116T00
(
	ID_CANAL_AVISO       NUMBER(8) NOT NULL ,
	ID_TERCERO           NUMBER(8) NULL ,
	ID_EMPRESA           NUMBER(8) NULL ,
	ID_TIPO_CANAL_AVISO  NUMBER(2) NOT NULL ,
	CANAL_AVISO          VARCHAR2(50 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6116T00 IS 'Tabla de Canales de aviso por Tercero / Empresa';
COMMENT ON COLUMN AB6116T00.ID_CANAL_AVISO IS 'Identificador del Canal de Aviso (secuencia)';
COMMENT ON COLUMN AB6116T00.CANAL_AVISO IS 'Datos del Canal de Aviso: Telfono o Correo Electrnico del Tercero.';
COMMENT ON COLUMN AB6116T00.ID_TERCERO IS 'Identificador del Tercero';
COMMENT ON COLUMN AB6116T00.ID_TIPO_CANAL_AVISO IS 'Identificador del Tipo de Canal de Aviso';
COMMENT ON COLUMN AB6116T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6116T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6116T00.ID_EMPRESA IS 'Identificador de Empresa / Establecimiento';


PROMPT Creacin de la Tabla AB6116T00

CREATE TABLE AB6117T00
(
	ID_MENSAJE           NUMBER(8) NOT NULL ,
	COD_PROCEDURE_ID     VARCHAR2(20 CHAR) NULL ,
	TIPOMENSAJE          VARCHAR2(255 CHAR) NULL ,
	MENSAJE              CLOB NULL ,
	FECHA_REGISTRO       DATE NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6117T00 IS 'Tabla de mensajes. Esta tabla guarda los datos de los mensajes que llegan a la cola JMS';
COMMENT ON COLUMN AB6117T00.TIPOMENSAJE IS 'Tipo de Mensaje que llega a la cola JMS';
COMMENT ON COLUMN AB6117T00.MENSAJE IS 'Mensaje que llega a la cola JMS';
COMMENT ON COLUMN AB6117T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6117T00.ID_MENSAJE IS 'Identificador interno del Mensaje';
COMMENT ON COLUMN AB6117T00.COD_PROCEDURE_ID IS 'Identificador del Procedimiento en PLATEA';


PROMPT Creacin de la Tabla AB6117T00

CREATE TABLE AB6118T00
(
	ID_SOLICITUD         NUMBER(8) NOT NULL ,
	ID_MENSAJE           NUMBER(8) NOT NULL ,
	COD_PROCEDURE_ID     VARCHAR2(20 CHAR) NULL ,
	SOLICITUD            CLOB NULL ,
	FOLDER_ID            VARCHAR2(64 CHAR) NULL ,
	FECHA_ENTRADA        DATE NULL ,
	FECHA_REGISTRO       DATE NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6118T00 IS 'Tabla de Solicitudes, donde se almacenarn las Solicitudes que llegarn a la aplicacin.';
COMMENT ON COLUMN AB6118T00.ID_SOLICITUD IS 'Identificador interno de la Solicitud';
COMMENT ON COLUMN AB6118T00.SOLICITUD IS 'Solicitud (XML) que llega para cargar su informacin en las tablas de la aplicacin';
COMMENT ON COLUMN AB6118T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6118T00.ID_MENSAJE IS 'Identificador interno del Mensaje';
COMMENT ON COLUMN AB6118T00.FOLDER_ID IS 'Identificador del Expediente en PLATEA';
COMMENT ON COLUMN AB6118T00.FECHA_ENTRADA IS 'Fecha cuando se ha presentado la Solicitud';
COMMENT ON COLUMN AB6118T00.COD_PROCEDURE_ID IS 'Identificador del Procedimiento en PLATEA';


PROMPT Creacin de la Tabla AB6118T00

CREATE TABLE AB6119T00
(
	ID_CONFIGURACION     NUMERIC(8) NOT NULL ,
	COD_PROCEDURE_ID     VARCHAR2(20 CHAR) NULL ,
	TIPO_EVENTO          VARCHAR2(20 CHAR) NULL ,
	PLSQL_CARGA          VARCHAR2(250 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6119T00 IS 'Tabla de Configuracin. Tabla donde almacenaremos los PL-SQL de carga para cada Cdigo de Procedimiento';
COMMENT ON COLUMN AB6119T00.ID_CONFIGURACION IS 'Identificador interno de Configuracin';
COMMENT ON COLUMN AB6119T00.COD_PROCEDURE_ID IS 'Identificador de Procedimiento (de PLATEA) al que pertenece la configuracin';
COMMENT ON COLUMN AB6119T00.TIPO_EVENTO IS 'Tipo de Evento de Procedimiento (de PLATEA) al que pertenece la configuracin';
COMMENT ON COLUMN AB6119T00.PLSQL_CARGA IS 'PL/SQL que tenemos que llamar para cargar la informacin secibida segn el Identificador de Proceso (de PLATEA)';
COMMENT ON COLUMN AB6119T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6119T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6119T00

CREATE TABLE AB6120T00
(
	ID_SEXO              NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(20 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(20 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6120T00 IS 'Ctalogo de Sexo. Los valores que vamos a tener aqu son:
H: Hombre
M: Mujer';
COMMENT ON COLUMN AB6120T00.ID_SEXO IS 'Identificador interno de Sexo';
COMMENT ON COLUMN AB6120T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano del Sexo';
COMMENT ON COLUMN AB6120T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera del Sexo';
COMMENT ON COLUMN AB6120T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6120T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6120T00

CREATE TABLE AB6121T00
(
	ID_TRAZA             NUMBER(8) NOT NULL ,
	ID_SOLICITUD         NUMBER(8) NULL ,
	ID_EXPEDIENTE        NUMBER(8) NULL ,
	COD_PROCEDURE_ID     VARCHAR2(20 CHAR) NULL ,
	EXCEPCION            VARCHAR2(2000 CHAR) NULL ,
	METODO               VARCHAR2(100 CHAR) NULL ,
	ESTADO_SOLICITUD     NUMBER(1) NULL ,
	TAREAS               CLOB NULL ,
	FECHA_REGISTRO       DATE NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6121T00 IS 'Tabla de Trazas, tabla donde almacenaremos el Estado de las Solicitudes recibidas';
COMMENT ON COLUMN AB6121T00.ID_TRAZA IS 'Identificador interno de la Traza';
COMMENT ON COLUMN AB6121T00.ID_SOLICITUD IS 'Identificador interno de la Solicitud';
COMMENT ON COLUMN AB6121T00.EXCEPCION IS 'Excepcin recibida en caso de Error, el Estado de la Solicitud ser igual a 2';
COMMENT ON COLUMN AB6121T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6121T00.ESTADO_SOLICITUD IS 'Estado de la Solicitud:
1: La Solicitud se ha tramitado correctamente, es decir, hemos almacenado toda la informacin en las tablas de la aplicacin
2: Ha habido algn error a la hora de tramitar la Solicitud';
COMMENT ON COLUMN AB6121T00.TAREAS IS 'Tareas de la carga de la Solicitud que se han desarrollado';
COMMENT ON COLUMN AB6121T00.METODO IS 'Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin';
COMMENT ON COLUMN AB6121T00.COD_PROCEDURE_ID IS 'Identificador del Procedimiento en PLATEA';
COMMENT ON COLUMN AB6121T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente';


PROMPT Creacin de la Tabla AB6121T00

CREATE TABLE AB6122T00
(
	ID_CAMPO             NUMBER(8) NOT NULL ,
	ID_TIPO_CAMPO        NUMBER(2) NOT NULL ,
	NOMBRE_CAMPO         VARCHAR2(100 CHAR) NULL ,
	SELECT_CAMPO         VARCHAR2(1000 CHAR) NULL ,
	NOMBRE_XML           VARCHAR2(500 CHAR) NULL ,
	DESCRIPCION          VARCHAR2(2000 CHAR) NULL ,
	IDIOMA               NUMBER(1) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6122T00 IS 'Tabla que contiene los Campos que se van a permitir utilizar en las Plantillas';
COMMENT ON COLUMN AB6122T00.ID_CAMPO IS 'Identificador interno del Campo';
COMMENT ON COLUMN AB6122T00.NOMBRE_CAMPO IS 'Nombre que determinamos al campo, nombre que utilizaremos en el Documento RTF';
COMMENT ON COLUMN AB6122T00.SELECT_CAMPO IS 'Sentencia que nos permitir obtener la informacin del campo a partir del Indetificador correspondiente (Convocatoria / Expediente)';
COMMENT ON COLUMN AB6122T00.NOMBRE_XML IS 'Nombre de la Etiqueta en el XML que nos permitir identificar el dato a cargar en el Documento RTF';
COMMENT ON COLUMN AB6122T00.DESCRIPCION IS 'Descripcin del Campo';
COMMENT ON COLUMN AB6122T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6122T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6122T00.IDIOMA IS 'Idioma del Campo, idioma en la que se va a almacenar el dato del campo:
0: Castellano
1: Euskera
NULL: Sin idioma, por ejemplo para los nmeros';
COMMENT ON COLUMN AB6122T00.ID_TIPO_CAMPO IS 'Identificador del Tipo de Campo que podemos utilizar en las Platillas';


PROMPT Creacin de la Tabla AB6122T00

CREATE TABLE AB6123T00
(
	ID_REL_PLA_CAM       NUMBER(8) NOT NULL ,
	ID_PLANTILLA         NUMBER(8) NOT NULL ,
	ID_CAMPO             NUMBER(8) NOT NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6123T00 IS 'Tabla que almacena la Relacin entre las Plantillas y los Campos que el usuario ha aadido a la plantilla';
COMMENT ON COLUMN AB6123T00.ID_REL_PLA_CAM IS 'Identificador de la Relacin de la Plantilla y los Campos a utilizar en la plantilla';
COMMENT ON COLUMN AB6123T00.ID_CAMPO IS 'Identificador interno del Campo';
COMMENT ON COLUMN AB6123T00.ID_PLANTILLA IS 'Identificador interno de Plantilla';
COMMENT ON COLUMN AB6123T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6123T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6123T00

CREATE TABLE AB6124T00
(
	ID_TIPO_EMPRESA      NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(100 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6124T00 IS 'Catlogo de Tipos de Empresa (EMET)';
COMMENT ON COLUMN AB6124T00.ID_TIPO_EMPRESA IS 'Identificador del Tipo de Empresa (EMET)';
COMMENT ON COLUMN AB6124T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano del Tipo de Empresa (EMET)';
COMMENT ON COLUMN AB6124T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera del Tipo de Empresa (EMET)';
COMMENT ON COLUMN AB6124T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6124T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6124T00

CREATE TABLE AB6125T00
(
	ID_DATO_EMPLEO       NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(100 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6125T00 IS 'Catlogo de Datos de empleo de la empresa (EMET): 
- Empresas con una antigedad igual o inferior a 12 meses
- Empresas entre 12 meses y un da y 24 meses de antigedad
- Empresas de ms de 24 meses de antigedad';
COMMENT ON COLUMN AB6125T00.ID_DATO_EMPLEO IS 'Identificador interno de Dato de Empleo (EMET)';
COMMENT ON COLUMN AB6125T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano de Dato de Empleo (EMET)';
COMMENT ON COLUMN AB6125T00.DESCRIPCION_EUSKERA IS 'Descripcin en Eukera de Dato de Empleo (EMET)';
COMMENT ON COLUMN AB6125T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6125T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6125T00

CREATE TABLE AB6126T00
(
	ID_TIPO_CAMPO        NUMBER(2) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(50 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(50 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;
	
COMMENT ON TABLE AB6126T00 IS 'Catlogo de los Tipos de Campo que podemos utilizar en las Plantillas';
COMMENT ON COLUMN AB6126T00.ID_TIPO_CAMPO IS 'Identificador del Tipo de Campo que podemos utilizar en las Platillas';
COMMENT ON COLUMN AB6126T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano del Tipo de Campo que podemos utilizar en las Platillas';
COMMENT ON COLUMN AB6126T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera del Tipo de Campo que podemos utilizar en las Platillas';
COMMENT ON COLUMN AB6126T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6126T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


PROMPT Creacin de la Tabla AB6126T00