PROMPT Lanzar Procedimiento ALMACENAR_DOMICILIO_TITULAR

create or replace PROCEDURE ALMACENAR_DOMICILIO_TITULAR (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_TERCERO IN OUT AB6104T00.ID_TERCERO%TYPE, IN_ID_EMPRESA IN OUT AB6105T00.ID_EMPRESA%TYPE, 
                                                         OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS 

v_DIRECCION_TERCERO         AB6104T00.DIRECCION%TYPE;                       -- Direccin del Titular
v_NUMERO_TERCERO            AB6104T00.NUMERO%TYPE;                          -- Nmero de la Direccin del Titular
v_ESCALERA_TERCERO          AB6104T00.ESCALERA%TYPE;                        -- Escalera de la Direccin del Titular
v_PISO_TERCERO              AB6104T00.PISO%TYPE;                            -- Piso de la Direccin del Titular
v_LETRA_TERCERO             AB6104T00.LETRA%TYPE;                           -- Letra de la Direccin del Titular
v_CODIGO_POSTAL_TERCERO     AB6104T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin del Titular
n_ID_PROVINCIA_TERCERO      AB6104T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin del Titular
n_ID_MUNICIPIO_TERCERO      AB6104T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin del Titular
n_ID_LOCALIDAD_TERCERO      AB6104T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin del Titular

v_DIRECCION_EMPRESA         AB6105T00.DIRECCION%TYPE;                       -- Direccin del Titular (Empresa)
v_NUMERO_EMPRESA            AB6105T00.NUMERO%TYPE;                          -- Nmero de la Direccin del Titular (Empresa)
v_ESCALERA_EMPRESA          AB6105T00.ESCALERA%TYPE;                        -- Escalera de la Direccin del Titular (Empresa)
v_PISO_EMPRESA              AB6105T00.PISO%TYPE;                            -- Piso de la Direccin del Titular (Empresa)
v_LETRA_EMPRESA             AB6105T00.LETRA%TYPE;                           -- Letra de la Direccin del Titular (Empresa)
v_CODIGO_POSTAL_EMPRESA     AB6105T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin del Titular (Empresa)
n_ID_PROVINCIA_EMPRESA      AB6105T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin del Titular (Empresa)
n_ID_MUNICIPIO_EMPRESA      AB6105T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin del Titular (Empresa)
n_ID_LOCALIDAD_EMPRESA      AB6105T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin del Titular (Empresa)

BEGIN

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//domicilioTitular') =  1) THEN

    IF (IN_ID_TERCERO IS NOT NULL) THEN
    
        v_DIRECCION_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularDomicilio/text()').getStringVal();
        v_NUMERO_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPortal/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()') > 0) THEN
            v_ESCALERA_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()') > 0) THEN
            v_PISO_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()') > 0) THEN
            v_LETRA_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()').getStringVal();
        END IF;
        v_CODIGO_POSTAL_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularCP/text()').getStringVal();
        n_ID_PROVINCIA_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularProvince/text()').getStringVal();
        n_ID_MUNICIPIO_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularMunicipio/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()') > 0) THEN
            n_ID_LOCALIDAD_TERCERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()').getStringVal();
        END IF;
        
        UPDATE AB6104T00 SET DIRECCION = v_DIRECCION_TERCERO, 
                            NUMERO = v_NUMERO_TERCERO,
                            ESCALERA = v_ESCALERA_TERCERO,
                            PISO = v_PISO_TERCERO,
                            LETRA = v_LETRA_TERCERO,
                            CODIGO_POSTAL = v_CODIGO_POSTAL_TERCERO,
                            ID_PROVINCIA = n_ID_PROVINCIA_TERCERO,
                            ID_MUNICIPIO = n_ID_MUNICIPIO_TERCERO,
                            ID_LOCALIDAD = n_ID_LOCALIDAD_TERCERO
                        WHERE ID_TERCERO = IN_ID_TERCERO;
    
        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Domicilio del Titular Actualizado (' || v_DIRECCION_TERCERO || ')';
    
    ELSIF (IN_ID_EMPRESA IS NOT NULL) THEN
    
        v_DIRECCION_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularDomicilio/text()').getStringVal();
        v_NUMERO_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPortal/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()') > 0) THEN
            v_ESCALERA_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()') > 0) THEN
            v_PISO_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()') > 0) THEN
            v_LETRA_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()').getStringVal();
        END IF;
        v_CODIGO_POSTAL_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularCP/text()').getStringVal();
        n_ID_PROVINCIA_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularProvince/text()').getStringVal();
        n_ID_MUNICIPIO_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularMunicipio/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()') > 0) THEN
            n_ID_LOCALIDAD_EMPRESA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()').getStringVal();
        END IF;
    
         UPDATE AB6105T00 SET DIRECCION = v_DIRECCION_EMPRESA, 
                            NUMERO = v_NUMERO_EMPRESA,
                            ESCALERA = v_ESCALERA_EMPRESA,
                            PISO = v_PISO_EMPRESA,
                            LETRA = v_LETRA_EMPRESA,
                            CODIGO_POSTAL = v_CODIGO_POSTAL_EMPRESA,
                            ID_PROVINCIA = n_ID_PROVINCIA_EMPRESA,
                            ID_MUNICIPIO = n_ID_MUNICIPIO_EMPRESA,
                            ID_LOCALIDAD = n_ID_LOCALIDAD_EMPRESA
                        WHERE ID_EMPRESA = IN_ID_EMPRESA;
    
        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Domicilio del Titular Actualizado (' || v_DIRECCION_EMPRESA || ')';
        
    END IF;

END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;
    
    RAISE;
    
    END;  
    
END ALMACENAR_DOMICILIO_TITULAR;

/