PROMPT Lanzar Procedimiento ALMACENAR_PLANTILLA

create or replace PROCEDURE ALMACENAR_PLANTILLA(IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EMPRESA IN AB6105T00.ID_EMPRESA%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS 

n_PLANTILLA_HOMBRES            AB6105T00.PLANTILLA_HOMBRES%TYPE;                         -- Nmero de Hombres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado
n_PLANTILLA_MUJERES            AB6105T00.PLANTILLA_MUJERES%TYPE;                         -- Nmero de Mujeres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado

BEGIN

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//datosPlantilla') =  1) THEN

    n_PLANTILLA_HOMBRES := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillahombres/text()').getStringVal();
    n_PLANTILLA_MUJERES := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillamujeres/text()').getStringVal();

    UPDATE AB6105T00 SET PLANTILLA_HOMBRES = n_PLANTILLA_HOMBRES, PLANTILLA_MUJERES = n_PLANTILLA_MUJERES, FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = 'SCRIPT'
                          WHERE ID_EMPRESA = IN_ID_EMPRESA;
    
    OUT_TAREAS := OUT_TAREAS || chr(13) || '-Plantilla Actualizada (Hombres: ' || n_PLANTILLA_HOMBRES || ' / Mujeres: ' || n_PLANTILLA_MUJERES || ')';
    
END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;
    
    RAISE;
    
    END;  
    
END ALMACENAR_PLANTILLA;

/