PROMPT Lanzar Procedimiento ALMACENAR_TITULO_EXP

create or replace FUNCTION ALMACENAR_TITULO_EXP (IN_xmltype_SOLICITUD IN XMLTYPE, IN_COD_PROCEDURE_ID IN AB6101T00.COD_PROCEDURE_ID%TYPE, 
                                                        IN_FOLDER_ID AB6118T00.FOLDER_ID%TYPE, IN_FECHA_ENTRADA AB6118T00.FECHA_ENTRADA%TYPE, 
                                                        OUT_TITULO IN OUT AB6102T00.TITULO%TYPE) RETURN AB6102T00.ID_EXPEDIENTE%TYPE AS 

v_CAMPOS_TITULO_EXPEDIENTE  AB6101T00.CAMPOS_TITULO_EXPEDIENTE%TYPE;        -- Campos del Toolkit de Formularios que se utilizarn para generar el Ttulo del Expediente
n_ID_PROCEDIMIENTO          AB6101T00.ID_PROCEDIMIENTO%TYPE;                -- Identificador del Procedimiento

n_ID_EXPEDIENTE             AB6102T00.ID_EXPEDIENTE%TYPE;                   -- Identificador del Expediente
n_ID_TERRITORIO_HISTORICO   AB6102T00.ID_TERRITORIO_HISTORICO%TYPE;         -- Identificador del Territorio Histrico

n_PosicionInicial NUMBER;           -- Variable que utilizaremos para obtner la posicin inicial a la hora de generar el Ttulo del Expediente
n_PosicionFinal NUMBER;             -- Variable que utilizaremos para obtner la posicin final a la hora de generar el Ttulo del Expediente
v_Campo VARCHAR2(50);               -- Variable que utilizaremoa para obtner el campo a buscar en el XML de Solicitud a la hora de generar el Ttulo del Expediente
v_ValorCampo VARCHAR2(1200);        -- Variable que utilizaremoa para obtner el valor del campo obtenido del XML de Solicitud a la hora de generar el Ttulo del Expediente

n_TH NUMBER;                        -- Variable para controlar el primer campo del TH

BEGIN

SELECT ID_PROCEDIMIENTO, CAMPOS_TITULO_EXPEDIENTE INTO n_ID_PROCEDIMIENTO, v_CAMPOS_TITULO_EXPEDIENTE FROM AB6101T00 WHERE COD_PROCEDURE_ID = IN_COD_PROCEDURE_ID;
-- Obtenemos el Territorio Histrico del Expediente a partir de <body><detailInfo><datosBasicos><datosOtrosDatos><ComboProvincia>
--n_ID_TERRITORIO_HISTORICO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosBasicos/datosOtrosDatos/ComboProvincia/text()').getStringVal();

-- Obtenemos el ttulo del Expediente (TITULO) a partir de los campos determinados en la columna CAMPOS_TITULO_EXPEDIENTE de la Tabla de Procedimientos
n_PosicionInicial := 1;
n_PosicionFinal := 0;

-- Igualamos el ttulo con los Campos del Ttulo, para ir obteniendo la informacin de estos campos en la XML de Solicitud e ir reemplazando
OUT_TITULO := v_CAMPOS_TITULO_EXPEDIENTE;

n_TH := 1;

-- Recorremos la variable v_TITULO mientras tengamos la etiqueta {{, ya que el campo a buscar en el XML tiene que estar entre {{ ... }}
WHILE  INSTR(OUT_TITULO,'{{', 1, 1) != 0 LOOP
    -- Obtenemos la posicin inicial de la etiqueta {{
    n_PosicionInicial := INSTR(OUT_TITULO,'{{', n_PosicionInicial, 1);
    -- Obtenemos la posicin inicial de la etiqueta }}
    n_PosicionFinal := INSTR(OUT_TITULO,'}}', n_PosicionInicial, 1);
    -- Obtenemos el campos que viene entre las dos etiquetas {{ ... }} (tenemos que sumar y restar 2 para no obtener las etiquetas {{ ... }}
    v_Campo := SUBSTR(OUT_TITULO, n_PosicionInicial + 2, n_PosicionFinal - n_PosicionInicial - 2);

    -- Buscamos en el XML de Solicitud el campo a sustituir para generar el Ttulo, primero miramos si esta campo existe
    IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//' || v_campo ||'/text()') > 0) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//' || v_campo ||'/text()').getStringVal();
    END IF;

    IF (v_campo ='radioTipoSolicitudDEC') THEN
      v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//' || v_campo ||'/text()').getStringVal();
      IF (v_ValorCampo = 1) THEN
        v_ValorCampo := '[AYU-UDAL]';
      ELSE
        v_ValorCampo := '[ASO-ERAK]';
      END IF;      
    END IF;

    IF (v_campo ='holderchoicedatosDomicilioUbiProvince') THEN
      v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//radio_ubiTitular/text()').getStringVal();
      IF (v_ValorCampo = 1) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//holderchoicedatosDomicilioUbiProvince/text()').getStringVal();
      ELSE
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//holderchoicedatosDomicilioTitularProvince/text()').getStringVal();
      END IF;
    END IF;

    -- Cualquier dato que no sea 20-Gipuzkoa o 48-Bizkaia, ser 01-Araba-lava
    IF (n_TH=1) THEN
      IF (v_ValorCampo != '48' AND v_ValorCampo != '20') THEN
        v_ValorCampo := '01';
      END IF;
      n_ID_TERRITORIO_HISTORICO := v_ValorCampo;
    END IF;

    -- Reemplazamos el campo por el valor obtenido del XML de Solicitud
    OUT_TITULO := REPLACE (OUT_TITULO, '{{' || v_Campo || '}}', v_ValorCampo);
    
    n_TH := n_TH + 1;
END LOOP;

-- Obtenemos el Identificador del Expediente a partir de la secuencia S_AB6102T00
SELECT S_AB6102T00.NEXTVAL INTO n_ID_EXPEDIENTE FROM DUAL;

-- Almacenamos la informacin relacionada con el Expediente en la tabla AB6102T00. Aqu el FOLDER_NUMBER lo almacenamos como NULL porque no lo tenemos todava.
INSERT INTO AB6102T00 (ID_EXPEDIENTE, ID_PROCEDIMIENTO, ID_TERRITORIO_HISTORICO, FOLDER_ID, TITULO, FECHA_ENTRADA, FECHA_REGISTRO, USUARIO_REGISTRO) 
VALUES (n_ID_EXPEDIENTE,n_ID_PROCEDIMIENTO,n_ID_TERRITORIO_HISTORICO, IN_FOLDER_ID, OUT_TITULO, IN_FECHA_ENTRADA, SYSDATE, 'PL/SQL');

RETURN n_ID_EXPEDIENTE;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;
    
    RAISE;
    
    END;  
             
END ALMACENAR_TITULO_EXP;

/