PROMPT Lanzar Procedimiento ALMACENAR_PLANTILLA

create or replace PROCEDURE ALMACENAR_PLANTILLA(IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EMPRESA IN AB6105T00.ID_EMPRESA%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_PLANTILLA_HOMBRES            AB6105T00.PLANTILLA_HOMBRES%TYPE;      -- Nmero de Hombres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado
n_PLANTILLA_MUJERES            AB6105T00.PLANTILLA_MUJERES%TYPE;      -- Nmero de Mujeres del total de la plantilla a la fecha del ltimo ejercicio contable cerrado

n_NUMERO_SOCIOS	              AB6105T00.NUMERO_SOCIOS%TYPE;           -- (DEC) Composicin del rgano directivo (Hombres)
n_NUMERO_SOCIAS	              AB6105T00.NUMERO_SOCIAS%TYPE;	          -- (DEC) Composicin del rgano directivo (Mujeres)
v_EQUIPAMIENTO                AB6105T00.EQUIPAMIENTO%TYPE;            -- (DEC) La entidad est exenta de declaracin de IVA
BEGIN

n_NUMERO_SOCIOS := null;
n_NUMERO_SOCIAS := null;	   
v_EQUIPAMIENTO := null;     

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//datosPlantilla') =  1) THEN

    IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillahombres/text()') >  0) THEN
      n_PLANTILLA_HOMBRES := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillahombres/text()').getStringVal();
    END IF;
    IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillamujeres/text()') >  0) THEN
      n_PLANTILLA_MUJERES := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosPlantilla/plantillamujeres/text()').getStringVal();
    END IF;

    IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/codhombres/text()') >  0) THEN
      n_NUMERO_SOCIOS := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/codhombres/text()').getStringVal();
    END IF;
    IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/codmujeres/text()') >  0) THEN
      n_NUMERO_SOCIAS := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/codmujeres/text()').getStringVal();
    END IF;
    IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/exentoIVA/text()') >  0) THEN
      v_EQUIPAMIENTO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/datosAsocMunicipio/exentoIVA/text()').getStringVal();
    END IF;


    UPDATE AB6105T00 SET PLANTILLA_HOMBRES = n_PLANTILLA_HOMBRES, PLANTILLA_MUJERES = n_PLANTILLA_MUJERES, NUMERO_SOCIOS = n_NUMERO_SOCIOS, NUMERO_SOCIAS = n_NUMERO_SOCIAS, EQUIPAMIENTO = v_EQUIPAMIENTO, FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = 'SCRIPT'
                          WHERE ID_EMPRESA = IN_ID_EMPRESA;

    OUT_TAREAS := OUT_TAREAS || chr(13) || '-Plantilla Actualizada (Hombres: ' || n_PLANTILLA_HOMBRES || ' / Mujeres: ' || n_PLANTILLA_MUJERES || ')';

END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_PLANTILLA;

/
