PROMPT Lanzar Procedimiento TRATAMIENTO_TAREAS

create or replace PROCEDURE TRATAMIENTO_TAREAS (IN_ID_MENSAJE AB61.AB6117T00.ID_MENSAJE%TYPE) AS 

n_COD_PROCEDURE_ID          AB61.AB6101T00.COD_PROCEDURE_ID%TYPE;               -- Cdigo de Procedimiento de PLATEA

n_ID_EXPEDIENTE             AB61.AB6102T00.ID_EXPEDIENTE%TYPE;                  -- Cdigo de Identificador del Expediente

clob_MENSAJE                AB61.AB6117T00.MENSAJE%TYPE;                        -- Mensaje (XML) de la TAREA

v_FOLDER_ID                 AB61.AB6118T00.FOLDER_ID%TYPE;                      -- Identificador del Expediente en PLATEA

n_ID_TRAZA                  AB61.AB6121T00.ID_TRAZA%TYPE;                       -- Identificador de la Traza
v_EXCEPCION                 AB61.AB6121T00.EXCEPCION%TYPE;                      -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_METODO                    AB61.AB6121T00.METODO%TYPE;                         -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin

xmltype_MENSAJE XMLTYPE;
n_NumeroNodos NUMBER;               -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
f_FECHA_TAREA DATE;
v_FECHA_TAREA VARCHAR(50);
v_TASK_ID VARCHAR(100);
v_PLATEA_TYPE VARCHAR(50); -- Tareas que PLATEA dispone: APERTURA
                                                      -- SOLDOCU
                                                      -- NOTIFICACION
                                                      -- APORDOCU
                                                      -- ESTDOCU
                                                      -- RECINOTI
                                                      -- CERREXP
                                                      -- REGISTRANOTI
                                                      -- LIQTASA
                                                      -- COMUNICACION 
                                                      -- REGISTRDOC
                                                      -- TRASPASOEXPEDIENTES
                                                      -- GENERICA
n_STATUS NUMBER;           -- Estado del evento: 1 - Tarea Sugerida
                                              -- 3 - Tarea Rechazada
                                              -- 4 - Tarea Ejecutada
                                              -- 6 - Tarea Anulada
                                              -- 7 - Tarea Reasignada a otro usuario y en estado pendiente
v_SITUACION_ID VARCHAR(100);

BEGIN

-- Obtenemos el XML (CLOB) de la tabla AB6118T00 a partir del Identificador del Solicitud
SELECT MENSAJE INTO clob_MENSAJE FROM AB61.AB6117T00 WHERE ID_MENSAJE = IN_ID_MENSAJE;
-- Convertimos el CLOB (que tiene el XML de la Tarea) en el tipo XMLTYPE
xmltype_MENSAJE := XMLTYPE.createXML(clob_MENSAJE);

IF (xmltype_MENSAJE.EXISTSNODE('.//folderID/text()') > 0) THEN
    v_FOLDER_ID := xmltype_MENSAJE.EXTRACT('.//folderID/text()').getStringVal();
END IF;

-- Una vez que tenemos el FOLDERID obtenemos el Identificador de Expediente (ID_EXPEDIENTE) para as poder guardar este valor en las trazas
SELECT ID_EXPEDIENTE INTO n_ID_EXPEDIENTE FROM AB61.AB6102T00 WHERE FOLDER_ID = v_FOLDER_ID;


IF ((xmltype_MENSAJE.EXISTSNODE('.//doTimestamp/text()') > 0) AND (xmltype_MENSAJE.EXISTSNODE('.//taskLanguage/text()') > 0)) THEN
    f_FECHA_TAREA := FORMATEAR_FECHA(xmltype_MENSAJE.EXTRACT('.//doTimestamp/text()').getStringVal(), xmltype_MENSAJE.EXTRACT('.//taskLanguage/text()').getStringVal());
END IF;

IF (xmltype_MENSAJE.EXISTSNODE('.//taskID/text()') > 0) THEN
    v_TASK_ID := xmltype_MENSAJE.EXTRACT('.//taskID/text()').getStringVal();
END IF;

n_NumeroNodos := 1;

WHILE xmltype_MENSAJE.EXISTSNODE('NotificationBody/Property[' || n_NumeroNodos || ']') = 1 LOOP

    IF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'PlateaType') THEN
    
        v_PLATEA_TYPE := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();
    
    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'Status') THEN
    
        n_STATUS := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();
    
    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'ProcedureID') THEN
     
        n_COD_PROCEDURE_ID := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();
    
    END IF;
		
    n_NumeroNodos :=  n_NumeroNodos + 1;

END LOOP;

IF (xmltype_MENSAJE.EXISTSNODE('.//situacionID/text()') > 0) THEN
    v_SITUACION_ID := xmltype_MENSAJE.EXTRACT('.//situacionID/text()').getStringVal();
END IF;

-- FECHA de ENTRADA
IF ((v_TASK_ID = 'APERTURA') AND (v_PLATEA_TYPE = 'APERTURA') AND (n_STATUS = 4)) THEN

    UPDATE AB6102T00 SET FECHA_ENTRADA = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de ENTRADA';

-- FECHA de la DOCUMENTACIN COMPLETA
ELSIF ((v_TASK_ID = 'estudio') AND (v_PLATEA_TYPE = 'ESTDOCU') AND (v_SITUACION_ID = 'Estudio Tcnico/Ikasketa Teknikoa') AND (n_STATUS = 4)) THEN

    UPDATE AB6102T00 SET FECHA_DOC_COM = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de la DOCUMENTACIN COMPLETA';
    
-- FECHA de ENVO de LTIMO REQUERIMIENTO
ELSIF ((v_TASK_ID = 'creanoti_subsana') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) THEN

    UPDATE AB6102T00 SET FECHA_ENV_ULT_REQ = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de ENVO de LTIMO REQUERIMIENTO';

-- FECHA de ACUSE de LTIMO REQUERIMIENTO
ELSIF ((v_TASK_ID = 'acusenotificacion_subsana_telematica') AND (v_PLATEA_TYPE = 'RECINOTI') AND (n_STATUS = 1)) THEN

    UPDATE AB6102T00 SET FECHA_ACU_ULT_REQ = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de ACUSE de LTIMO REQUERIMIENTO';

-- FECHA de RESOLUCIN
ELSIF (((v_TASK_ID = 'creanoti_resol_fav') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) 
        OR ((v_TASK_ID = 'creanoti_resol_den') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1))
        OR ((v_TASK_ID = 'comunicacion_resol') AND (v_PLATEA_TYPE = 'COMUNICACION') AND (n_STATUS = 1))) THEN

    UPDATE AB6102T00 SET FECHA_RESOLUCION = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de RESOLUCIN';
			
-- FECHA de ACUSE de RESOLUCIN
ELSIF (((v_TASK_ID = 'acusenotificacion_resol_fav_telematica') AND (v_PLATEA_TYPE = 'RECINOTI') AND (n_STATUS = 1)) 
        OR ((v_TASK_ID = 'acusenotificacion_resol_den_telematica') AND (v_PLATEA_TYPE = 'RECINOTI') AND (n_STATUS = 1))) THEN

		UPDATE AB6102T00 SET FECHA_ACU_RES = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
        v_FECHA_TAREA := 'FECHA de ACUSE de RESOLUCIN';

-- FECHA de INCUMPLIMIENTO
ELSIF (((v_TASK_ID = 'creanoti_resolucion_modificacion') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) 
        OR ((v_TASK_ID = 'creanoti_resolucion_rev_total') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1))
        OR ((v_TASK_ID = 'creanoti_resolucion_rev_parcial') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1))
        OR ((v_TASK_ID = 'creanoti_reintegro') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1))) THEN

        UPDATE AB6102T00 SET FECHA_INCUMPLIMIENTO = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
        v_FECHA_TAREA := 'FECHA de INCUMPLIMIENTO';
        
-- FECHA de RENUNCIA
ELSIF ((v_TASK_ID = 'creanoti_renuncia') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) THEN

    UPDATE AB6102T00 SET FECHA_RENUNCIA = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de RENUNCIA';
    
-- FECHA de DESISTIMIENTO
ELSIF ((v_TASK_ID = 'creanoti_desistimiento') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) THEN

    UPDATE AB6102T00 SET FECHA_DESISTIMIENTO = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de DESISTIMIENTO';
    
-- FECHA de CIERRE
ELSIF ((v_TASK_ID = 'cierre') AND (v_PLATEA_TYPE = 'CERREXP') AND (n_STATUS = 4)) THEN

    UPDATE AB6102T00 SET FECHA_CIERRE = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de CIERRE';
    
-- FECHA de RECURSO
ELSIF ((v_TASK_ID = 'creanoti_recurso_den') AND (v_PLATEA_TYPE = 'NOTIFICACION') AND (n_STATUS = 1)) THEN

    UPDATE AB6102T00 SET FECHA_RECURSO = f_FECHA_TAREA WHERE FOLDER_ID = v_FOLDER_ID;
    v_FECHA_TAREA := 'FECHA de RECURSO';

END IF;

 SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  
 
-- En este caso el Estado ser igual a 1 ya que todo ha ido bien
v_METODO := 'TRATAMIENTO_TAREAS';

IF v_FECHA_TAREA IS NULL THEN
    v_EXCEPCION:= 'No se ha actualizado ninguna fecha';
ELSE
    v_EXCEPCION:= 'Fecha actualizada (' || v_FECHA_TAREA ||'): ' || TO_CHAR(f_FECHA_TAREA) || ' - Folder ID: ' || v_FOLDER_ID;
    
END IF;

INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO) 
VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID,v_EXCEPCION , v_METODO, 1, null, SYSDATE);

COMMIT;

EXCEPTION
WHEN NO_DATA_FOUND THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

     v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000) || ' (ID_MENSAJE: ' || IN_ID_MENSAJE || ')';
    
    v_METODO:= 'TRATAMIENTO_TAREAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, null, SYSDATE);

    COMMIT;

END;  

WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);
    
    v_METODO:= 'TRATAMIENTO_TAREAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, null, SYSDATE);

    COMMIT;

END;  

END TRATAMIENTO_TAREAS;

/