PROMPT Creacion de 	Tabla (AB6139T00)


CREATE TABLE AB6139T00
(
	ID_DOCUMENTO         NUMBER(8) NOT NULL ,
	NOMBRE_DOCUMENTO     VARCHAR2(200 CHAR) NULL ,
	NOMBRE_ARCHIVO       VARCHAR2(200 CHAR) NULL ,
	ARCHIVO              BLOB NULL ,
	OBSERVACIONES        VARCHAR2(2000 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6139T00 IS 'Tabla para almacenar los Documentos (RTFs) de las Plantillas';
COMMENT ON COLUMN AB6139T00.ID_DOCUMENTO IS 'Identificador interno del Documento';
COMMENT ON COLUMN AB6139T00.NOMBRE_DOCUMENTO IS 'Nombre que le van a dar al Documento';
COMMENT ON COLUMN AB6139T00.NOMBRE_ARCHIVO IS 'Nombre del archivo (RTF) del Documento';
COMMENT ON COLUMN AB6139T00.ARCHIVO IS 'Archivo del Documento';
COMMENT ON COLUMN AB6139T00.OBSERVACIONES IS 'Onservaciones del Documento';
COMMENT ON COLUMN AB6139T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6139T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6139T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6139T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';


CREATE SYNONYM DOCUMENTOS	 FOR AB6139T00;


CREATE UNIQUE INDEX PK_AB6139T00 ON AB6139T00(ID_DOCUMENTO   ASC);
ALTER TABLE AB6139T00	ADD CONSTRAINT  PK_AB6139T00 PRIMARY KEY (ID_DOCUMENTO);