PROMPT Procedimiento TRATAMIENTO_FECHAS

create or replace PROCEDURE TRATAMIENTO_FECHAS (IN_ID_MENSAJE AB61.AB6117T00.ID_MENSAJE%TYPE) AS 

n_COD_PROCEDURE_ID          AB61.AB6101T00.COD_PROCEDURE_ID%TYPE;               -- Cdigo de Procedimiento de PLATEA

n_ID_EXPEDIENTE             AB61.AB6102T00.ID_EXPEDIENTE%TYPE;                  -- Cdigo de Identificador del Expediente

clob_MENSAJE                AB61.AB6117T00.MENSAJE%TYPE;                        -- Mensaje (XML) de la TAREA

v_FOLDER_ID                 AB61.AB6118T00.FOLDER_ID%TYPE;                      -- Identificador del Expediente en PLATEA

n_ID_TRAZA                  AB61.AB6121T00.ID_TRAZA%TYPE;                       -- Identificador de la Traza
v_EXCEPCION                 AB61.AB6121T00.EXCEPCION%TYPE;                      -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_METODO                    AB61.AB6121T00.METODO%TYPE;                         -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin
v_TAREAS                     AB61.AB6121T00.TAREAS%TYPE;


xmltype_MENSAJE XMLTYPE;
xmltype_AUXILIAR XMLTYPE;
n_NumeroNodos NUMBER;               -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
n_PosicionTipoDokusi NUMBER;
n_PosicionSubTipoDokusi NUMBER;
n_FechaInsertada NUMBER;


f_FECHA_TAREA DATE;

v_PLATEA_TYPE               AB61.AB6144T00.PLATEA_TYPE%TYPE; -- Tareas que PLATEA dispone: APERTURA
                                                            -- SOLDOCU
                                                            -- NOTIFICACION
                                                            -- APORDOCU
                                                            -- ESTDOCU
                                                            -- RECINOTI
                                                            -- CERREXP
                                                            -- REGISTRANOTI
                                                            -- LIQTASA
                                                            -- COMUNICACION 
                                                            -- REGISTRDOC
                                                            -- TRASPASOEXPEDIENTES
                                                            -- GENERICA
v_PLATEA_SUBTYPE            AB61.AB6144T00.PLATEA_SUBTYPE%TYPE;
v_TIPO_DOKUSI               AB61.AB6144T00.TIPO_DOKUSI%TYPE;
v_SUBTIPO_DOKUSI            AB61.AB6144T00.SUBTIPO_DOKUSI%TYPE;
v_ASUNTO_DOCUMENTAL         AB61.AB6144T00.ASUNTO_DOCUMENTAL%TYPE;

v_ROLE_DOCUMENTO VARCHAR2(500);

BEGIN

-- Obtenemos el XML (CLOB) de la tabla AB6117T00 a partir del Identificador del Solicitud
SELECT MENSAJE INTO clob_MENSAJE FROM AB61.AB6117T00 WHERE ID_MENSAJE = IN_ID_MENSAJE;

-- Convertimos el CLOB (que tiene el XML de la Tarea) en el tipo XMLTYPE
xmltype_MENSAJE := XMLTYPE.createXML(clob_MENSAJE);

IF (xmltype_MENSAJE.EXISTSNODE('.//folderID/text()') > 0) THEN
    v_FOLDER_ID := xmltype_MENSAJE.EXTRACT('.//folderID/text()').getStringVal();
END IF;

    BEGIN
        -- Una vez que tenemos el FOLDERID obtenemos el Identificador de Expediente (ID_EXPEDIENTE)
SELECT ID_EXPEDIENTE INTO n_ID_EXPEDIENTE FROM AB61.AB6102T00 WHERE FOLDER_ID = v_FOLDER_ID;
    EXCEPTION WHEN NO_DATA_FOUND THEN

        BEGIN
            v_TAREAS := v_FOLDER_ID;
            RAISE;
        END;

    END;


IF (xmltype_MENSAJE.EXISTSNODE('.//registryTimestamp/text()') > 0)  THEN
    f_FECHA_TAREA := FORMATEAR_FECHA(xmltype_MENSAJE.EXTRACT('.//registryTimestamp/text()').getStringVal(), 'ES');
END IF;

n_NumeroNodos := 1;


WHILE xmltype_MENSAJE.EXISTSNODE('NotificationBody/Property[' || n_NumeroNodos || ']') = 1 LOOP

    IF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'PlateaType') THEN

        v_PLATEA_TYPE := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'PlateaSubType') THEN

        v_PLATEA_SUBTYPE := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'ProcedureID') THEN

        n_COD_PROCEDURE_ID := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    END IF;

    n_NumeroNodos :=  n_NumeroNodos + 1;

END LOOP;

n_FechaInsertada := 0;

IF (xmltype_MENSAJE.EXISTSNODE('.//documentsEvent') >  0) THEN

    xmltype_AUXILIAR := xmltype_MENSAJE.EXTRACT('.//documentsEvent');

    n_NumeroNodos := 1;
    
    WHILE xmltype_AUXILIAR.EXISTSNODE('documentsEvent/documentEvent[' || n_NumeroNodos || ']') = 1 LOOP

        v_ROLE_DOCUMENTO := NULL;
        v_TIPO_DOKUSI := NULL;
        v_SUBTIPO_DOKUSI := NULL;
        v_ASUNTO_DOCUMENTAL := NULL;

        IF (xmltype_AUXILIAR.EXISTSNODE('documentsEvent/documentEvent[' || n_NumeroNodos || ']/oid/text()') > 0) THEN

            v_ROLE_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('documentsEvent/documentEvent[' || n_NumeroNodos || ']/roleId/text()').getStringVal(); 
        
            n_PosicionTipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.');
        
            v_TIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, 0, n_PosicionTipoDokusi - 1);
        
            n_PosicionSubtipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.', n_PosicionTipoDokusi + 1);
        
            v_SUBTIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, n_PosicionTipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - (LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi + 1) - n_PosicionTipoDokusi);
        
            v_ASUNTO_DOCUMENTAL := SUBSTR(v_ROLE_DOCUMENTO,n_PosicionSubtipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi);
        
    
            AB61.ALMACENAR_FECHA (IN_ID_MENSAJE, 'R02_REQUEST', NULL, v_PLATEA_TYPE, v_PLATEA_SUBTYPE, NULL, NULL, v_TIPO_DOKUSI, v_SUBTIPO_DOKUSI, v_ASUNTO_DOCUMENTAL,
                                    f_FECHA_TAREA, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID);
        
            n_FechaInsertada := 1;
        END IF;
                                             
    n_NumeroNodos :=  n_NumeroNodos + 1;

    END LOOP;
    
    IF (n_FechaInsertada = 0) THEN
    
        AB61.ALMACENAR_FECHA (IN_ID_MENSAJE, 'R02_REQUEST', NULL, v_PLATEA_TYPE, v_PLATEA_SUBTYPE, NULL, NULL, v_TIPO_DOKUSI, v_SUBTIPO_DOKUSI, v_ASUNTO_DOCUMENTAL,
                                    f_FECHA_TAREA, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID);
    END IF;

END IF;

EXCEPTION
WHEN NO_DATA_FOUND THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

     v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000) || ' (ID_MENSAJE: ' || IN_ID_MENSAJE || ')';

    v_METODO:= 'TRATAMIENTO_FECHAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, NULL, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

END;  

WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    v_METODO:= 'TRATAMIENTO_FECHAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

END;  

END TRATAMIENTO_FECHAS;

/