PROMPT Procedimiento (ALMACENAR_COMUNICACIONES)

create or replace PROCEDURE ALMACENAR_COMUNICACIONES (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB61.AB6102T00.ID_EXPEDIENTE%TYPE, IN_ID_TERCERO IN AB61.AB6135T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB61.AB6121T00.TAREAS%TYPE) AS

n_ID_DIRECCION              AB61.AB6136T00.ID_DIRECCION%TYPE;                      -- Identificador de la Empresa
n_ID_TIPO_DIRECCION         AB61.AB6136T00.ID_TIPO_DIRECCION%TYPE;
v_ESTABLECIMIENTO           AB61.AB6136T00.ESTABLECIMIENTO%TYPE;                 -- Nombre de la Empresa / Establecimiento
v_DIRECCION                 AB61.AB6136T00.DIRECCION%TYPE;                       -- Dirección de la Empresa / Establecimiento
v_NUMERO                    AB61.AB6136T00.NUMERO%TYPE;                          -- Número de la Dirección de la Empresa / Establecimiento
v_ESCALERA                  AB61.AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Dirección de la Empresa / Establecimiento
v_PISO                      AB61.AB6136T00.PISO%TYPE;                            -- Piso de la Dirección de la Empresa / Establecimiento
v_LETRA                     AB61.AB6136T00.LETRA%TYPE;                           -- Letra de la Dirección de la Empresa / Establecimiento
v_CODIGO_POSTAL             AB61.AB6136T00.CODIGO_POSTAL%TYPE;                   -- Código Postal de la Dirección de la Empresa / Establecimiento
n_ID_PROVINCIA              AB61.AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Dirección de la Empresa / Establecimiento
n_ID_MUNICIPIO              AB61.AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Dirección de la Empresa / Establecimiento
n_ID_LOCALIDAD              AB61.AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Dirección de la Empresa / Establecimiento

n_ID_FEC_COM_COM            AB61.AB6145T00.ID_FEC_COM_COM%TYPE;                 -- Identificador interno de la Fecha de Comunicación de Comercio
d_FECHA_INI	                AB61.AB6102T00.FECHA_INCOACION%TYPE;                -- Fecha de inicio
d_FECHA_FIN	                AB61.AB6102T00.FECHA_INCUMPLIMIENTO%TYPE;           -- Fecha de fin

xmltype_AUXILIAR XMLTYPE;           -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
ubi number;

BEGIN
-- FECHAS

  d_FECHA_INI := null;
  d_FECHA_FIN := null;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaDesde/text()') > 0) THEN
    d_FECHA_INI := AB61.FORMATEAR_FECHA(IN_xmltype_SOLICITUD.EXTRACT('.//fechaDesde/text()').getStringVal()
              ,IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfo/language/text()').getStringVal());
  END IF;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaHasta/text()') > 0) THEN
    d_FECHA_FIN := AB61.FORMATEAR_FECHA(IN_xmltype_SOLICITUD.EXTRACT('.//fechaHasta/text()').getStringVal()
              ,IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfo/language/text()').getStringVal());
  END IF;

-- Almacenamos la información relacionada con las fechas en la tabla AB6102T00
--UPDATE AB61.AB6102T00 SET FECHA_INCOACION=d_FECHA_INI, FECHA_INCUMPLIMIENTO=d_FECHA_FIN WHERE ID_EXPEDIENTE=IN_ID_EXPEDIENTE;

 -- Obtenemos el Identificador de la fecha a partir de la secuencia S_AB6145T00
      SELECT AB61.S_AB6145T00.NEXTVAL INTO n_ID_FEC_COM_COM FROM DUAL;

      -- Almacenamos la información relacionada con la Empresa en la tabla AB6105T00
      INSERT INTO AB61.AB6145T00 (ID_FEC_COM_COM,ID_EXPEDIENTE,FECHA_INICIO,FECHA_FIN,FECHA_REGISTRO,USUARIO_REGISTRO)
      VALUES(n_ID_FEC_COM_COM, IN_ID_EXPEDIENTE, d_FECHA_INI, d_FECHA_FIN, SYSDATE, 'PL/SQL');

-- UBICACIONES
    n_ID_TIPO_DIRECCION := 2;
    v_ESTABLECIMIENTO := null;
    v_DIRECCION := null;
    v_NUMERO := null;
    v_ESCALERA := null;
    v_PISO := null;
    v_LETRA := null;
    v_CODIGO_POSTAL := null;
    n_ID_PROVINCIA := null;
    n_ID_MUNICIPIO := null;
    n_ID_LOCALIDAD := null;
    ubi := 0;

    IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//estableComercial') >  0) THEN
      xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//estableComercial');
      ubi := 1;
    END IF;

    IF ubi = 1 THEN

      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//CampoBasicoNom/text()') > 0) THEN
        v_ESTABLECIMIENTO := IN_xmltype_SOLICITUD.EXTRACT('.//CampoBasicoNom/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//CampoBasicoCalle/text()') > 0) THEN
        v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//CampoBasicoCalle/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//CampoBasicoPortal/text()') > 0) THEN
        v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//CampoBasicoPortal/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//CampoBasicoPiso/text()') > 0) THEN
        v_PISO := xmltype_AUXILIAR.EXTRACT('.//CampoBasicoPiso/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//CampoBasicoLetra/text()') > 0) THEN
        v_LETRA := xmltype_AUXILIAR.EXTRACT('.//CampoBasicoLetra/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//CampoBasicoCp/text()') > 0) THEN
        v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//CampoBasicoCp/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//listaProvincia/text()') > 0) THEN
        n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//listaProvincia/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//listaMunicipio/text()') > 0) THEN
        n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//listaMunicipio/text()').getStringVal();
      END IF;
      
      -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6136T00
      SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

      -- Almacenamos la información relacionada con la Empresa en la tabla AB6136T00
      INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, ESTABLECIMIENTO, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
      VALUES(n_ID_DIRECCION, IN_ID_TERCERO, n_ID_TIPO_DIRECCION, v_ESTABLECIMIENTO, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'PL/SQL');

      OUT_TAREAS := OUT_TAREAS || chr(13) || '-Datos de la Empresa / Ubicación Almacenada (' || v_ESTABLECIMIENTO || ')';

    END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_COMUNICACIONES;

/