PROMPT Creacion de 	Tabla (AB6144T00)


CREATE TABLE AB6144T00
(
	ID_FECHA_EXPEDIENTE  NUMBER(8) NOT NULL ,
	TIPO_EVENTO          VARCHAR2(20 CHAR) NULL ,
	PLATEA_TYPE          VARCHAR2(50 CHAR) NULL ,
	PLATEA_SUBTYPE       VARCHAR2(64 CHAR) NULL ,
	TIPO_DOKUSI          VARCHAR2(64 CHAR) NULL ,
	SUBTIPO_DOKUSI       VARCHAR2(64 CHAR) NULL ,
	ASUNTO_DOCUMENTAL    VARCHAR2(64 CHAR) NULL ,
	TASK_ID              VARCHAR2(150 CHAR) NULL ,
	SITUACION_ID         VARCHAR2(200 CHAR) NULL ,
	STATUS               NUMBER(38,0) NULL ,
	ETIQUETA_FECHA    VARCHAR2(100 CHAR) NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(200 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(200 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6144T00 IS 'Catlogo para almacenar las Fechas existentes en el Expediente';
COMMENT ON COLUMN AB6144T00.ID_FECHA_EXPEDIENTE IS 'Identificador interno de la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.TASK_ID IS 'Identificador de TASK_ID (de PLATEA) al que pertenece la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.PLATEA_TYPE IS 'Identificador de PLATEATYPE (de PLATEA) al que pertenece la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.SITUACION_ID IS 'Identificador de SITUACION_ID (de PLATEA) al que pertenece la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.STATUS IS 'Identificador de STATUS (de PLATEA) al que pertenece la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6144T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6144T00.ETIQUETA_FECHA IS 'Descripcin de la Fecha del Expediente, utilizado para obtener la Fecha para los informes';
COMMENT ON COLUMN AB6144T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano de la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera de la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.PLATEA_SUBTYPE IS 'Identificador de PLATEASUBTYPE (de PLATEA) al que pertenece la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.TIPO_EVENTO IS 'Tipo de Evento de Procedimiento (de PLATEA) al que pertenece la configuracin';
COMMENT ON COLUMN AB6144T00.TIPO_DOKUSI IS 'Tipo DOKUSI del Documento de la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.SUBTIPO_DOKUSI IS 'Subtipo DOKUSI del Documento de la Fecha del Expediente';
COMMENT ON COLUMN AB6144T00.ASUNTO_DOCUMENTAL IS 'Asunto Documental DOKUSI del Documento de la Fecha del Expediente';


CREATE SYNONYM FECHAS_EXPEDIENTE	 FOR AB6144T00;


CREATE UNIQUE INDEX PK_AB6144T00 ON AB6144T00(ID_FECHA_EXPEDIENTE   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6144T00	ADD CONSTRAINT  PK_AB6144T00 PRIMARY KEY (ID_FECHA_EXPEDIENTE);