PROMPT Procedimiento ALMACENAR_FECHA

create or replace PROCEDURE ALMACENAR_FECHA (IN_ID_MENSAJE AB61.AB6117T00.ID_MENSAJE%TYPE,
                                             IN_TIPO_EVENTO AB61.AB6144T00.TIPO_EVENTO%TYPE,
                                             IN_TASK_ID AB61.AB6144T00.TASK_ID%TYPE,
                                             IN_PLATEA_TYPE AB61.AB6144T00.PLATEA_TYPE%TYPE,
                                             IN_PLATEA_SUBTYPE AB61.AB6144T00.PLATEA_SUBTYPE%TYPE,
                                             IN_SITUACION_ID AB61.AB6144T00.SITUACION_ID%TYPE,
                                             IN_STATUS AB61.AB6144T00.STATUS%TYPE,
                                             IN_TIPO_DOKUSI AB61.AB6144T00.TIPO_DOKUSI%TYPE,
                                             IN_SUBTIPO_DOKUSI AB61.AB6144T00.SUBTIPO_DOKUSI%TYPE,
                                             IN_ASUNTO_DOCUMENTAL AB61.AB6144T00.ASUNTO_DOCUMENTAL%TYPE,
                                             IN_FECHA_EXPEDIENTE AB61.AB6142T00.FECHA_EXPEDIENTE%TYPE,
                                             IN_ID_EXPEDIENTE AB61.AB6102T00.ID_EXPEDIENTE%TYPE,
                                             IN_COD_PROCEDURE_ID AB61.AB6101T00.COD_PROCEDURE_ID%TYPE) AS 

n_ID_TRAZA                  AB61.AB6121T00.ID_TRAZA%TYPE; 
v_EXCEPCION                 AB61.AB6121T00.EXCEPCION%TYPE;

n_ID_REL_EXP_FECH           AB61.AB6142T00.ID_REL_EXP_FECH%TYPE;
n_ID_FECHA_EXPEDIENTE       AB61.AB6142T00.ID_FECHA_EXPEDIENTE%TYPE;

v_ETIQUETA_FECHA            AB61.AB6144T00.ETIQUETA_FECHA%TYPE;

BEGIN

BEGIN
       

SELECT ID_FECHA_EXPEDIENTE, ETIQUETA_FECHA INTO n_ID_FECHA_EXPEDIENTE, v_ETIQUETA_FECHA FROM AB6144T00 WHERE  
                                                                            NVL(TASK_ID,'@@@') = NVL(IN_TASK_ID,'@@@') AND
                                                                            NVL(PLATEA_TYPE,'@@@') = NVL(IN_PLATEA_TYPE,'@@@') AND
                                                                            NVL(PLATEA_SUBTYPE,'@@@') = NVL(IN_PLATEA_SUBTYPE,'@@@') AND
                                                                            NVL(SITUACION_ID,'@@@') = NVL(IN_SITUACION_ID,'@@@') AND
                                                                            NVL(STATUS,99999) = NVL(IN_STATUS,99999) AND
                                                                            NVL(TIPO_DOKUSI,'@@@') = NVL(IN_TIPO_DOKUSI,'@@@') AND
                                                                            NVL(SUBTIPO_DOKUSI,'@@@') = NVL(IN_SUBTIPO_DOKUSI,'@@@') AND
                                                                            NVL(ASUNTO_DOCUMENTAL,'@@@') = NVL(IN_ASUNTO_DOCUMENTAL,'@@@');

EXCEPTION WHEN NO_DATA_FOUND THEN

    BEGIN
        SELECT AB61.S_AB6144T00.NEXTVAL INTO n_ID_FECHA_EXPEDIENTE FROM DUAL;  
        
        INSERT INTO AB6144T00 (ID_FECHA_EXPEDIENTE, TIPO_EVENTO, TASK_ID, PLATEA_TYPE, PLATEA_SUBTYPE, SITUACION_ID, STATUS, TIPO_DOKUSI, SUBTIPO_DOKUSI, ASUNTO_DOCUMENTAL, FECHA_REGISTRO, USUARIO_REGISTRO)
         VALUES (n_ID_FECHA_EXPEDIENTE, IN_TIPO_EVENTO, IN_TASK_ID, IN_PLATEA_TYPE, IN_PLATEA_SUBTYPE, IN_SITUACION_ID, IN_STATUS, IN_TIPO_DOKUSI, IN_SUBTIPO_DOKUSI, IN_ASUNTO_DOCUMENTAL, SYSDATE, 'MIGRACION');
        
    END;
END;
    
SELECT AB61.S_AB6142T00.NEXTVAL INTO n_ID_REL_EXP_FECH FROM DUAL;  
    
     INSERT INTO AB6142T00 (ID_REL_EXP_FECH, ID_EXPEDIENTE, ID_FECHA_EXPEDIENTE, FECHA_EXPEDIENTE, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES(n_ID_REL_EXP_FECH, IN_ID_EXPEDIENTE, n_ID_FECHA_EXPEDIENTE, IN_FECHA_EXPEDIENTE, SYSDATE, 'MIGRACION');
    
    
    
    IF v_ETIQUETA_FECHA IS NULL THEN
        v_ETIQUETA_FECHA:= 'SIN Descripcin';
    END IF;
    
    v_EXCEPCION:= 'Fecha actualizada (' || v_ETIQUETA_FECHA ||'): ' || TO_CHAR(IN_FECHA_EXPEDIENTE);
    
    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  
    
    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO) 
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, IN_ID_EXPEDIENTE, IN_COD_PROCEDURE_ID, v_EXCEPCION , 'ALMACENAR_FECHA_MIGRACION', 1, '', SYSDATE);
    
    
COMMIT;

EXCEPTION WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, IN_ID_EXPEDIENTE, IN_COD_PROCEDURE_ID, v_EXCEPCION, 'ALMACENAR_FECHA_MIGRACION', 2, '', SYSDATE);

    COMMIT;

END;  

END ALMACENAR_FECHA;

/