CREATE OR REPLACE PROCEDURE AB61.COMPLETAR_EXPEDIENTES_REATE AS


n_ID_EXPEDIENTE             AB6102T00.ID_EXPEDIENTE%TYPE;                   -- Identificador del Expediente
n_ID_SOLICITUD              AB6118T00.ID_SOLICITUD%TYPE;
n_COD_PROCEDURE_ID          AB6118T00.COD_PROCEDURE_ID%TYPE;
                            
n_ID_TRAZA                  AB6121T00.ID_TRAZA%TYPE;                        -- Identificador de la Traza
v_EXCEPCION                 AB6121T00.EXCEPCION%TYPE;                       -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_TAREAS                    AB6121T00.TAREAS%TYPE;                          -- Tareas de la carga de la Solicitud que se han desarrollado
v_METODO                    Ab6121T00.METODO%TYPE;                          -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin

xmltype_SOLICITUD XMLTYPE;          -- Variable XMLTYPE donde almacenaremos el XML de la Solicitud


-- Obtenemos el XML (CLOB) de la tabla AB6118T00 para los expedientes del servicio de REATE (001280X)
CURSOR cSOLICITUDES IS
SELECT T02.ID_EXPEDIENTE, T18.SOLICITUD, T18.ID_SOLICITUD, T01.COD_PROCEDURE_ID
FROM AB6118T00 T18, AB6121T00 T21, AB6102T00 T02, AB6101T00 T01
WHERE T18.ID_SOLICITUD = T21.ID_SOLICITUD
AND T21.ID_EXPEDIENTE = T02.ID_EXPEDIENTE
AND T02.ID_PROCEDIMIENTO = T01.ID_PROCEDIMIENTO
AND T01.COD_PROCEDURE_ID LIKE '001280%';

BEGIN

  v_METODO := 'COMPLETAR_EXPEDIENTES_REATE';
  
    --Cambiamos todas las direcciones postales asociadas a terceros de expediente de REATE de tipo 1 a 4.
	UPDATE AB6136T00 SET ID_TIPO_DIRECCION = 4,
	FECHA_ULTMODIFICACION = SYSDATE,
	USUARIO_ULTMODIFICACION  = 'MIG_REATE'
	WHERE ID_DIRECCION IN (SELECT T36.ID_DIRECCION
	FROM AB6134T00 T34, AB6136T00 T36, AB6102T00 T02, AB6101T00 T01
	WHERE T34.ID_EXPEDIENTE = T02.ID_EXPEDIENTE
	AND T34.ID_TERCERO = T36.ID_TERCERO
	AND T02.ID_PROCEDIMIENTO = T01.ID_PROCEDIMIENTO
	AND T01.COD_PROCEDURE_ID LIKE '001280%'
	AND T36.ID_TIPO_DIRECCION = 1);
  
  FOR sol IN cSOLICITUDES
  LOOP
  
	dbms_output.put_line(sol.ID_EXPEDIENTE);
	dbms_output.put_line(sol.ID_SOLICITUD);
	dbms_output.put_line(sol.COD_PROCEDURE_ID);

    -- Convertimos el CLOB (que tiene el XML de la Solicitud) en el tipo XMLTYPE
    xmltype_SOLICITUD := XMLTYPE.createXML(sol.SOLICITUD);
    n_ID_EXPEDIENTE := sol.ID_EXPEDIENTE;
    n_ID_SOLICITUD := sol.ID_SOLICITUD;
    n_COD_PROCEDURE_ID := sol.COD_PROCEDURE_ID;
    
    
    dbms_output.put_line('bbb');
    
    /***** Completamos los terceros y direccin de los establecimiento de los expedientes *****/
    IF (xmltype_SOLICITUD.EXISTSNODE('.//ApplicantInfoRRI') > 0) THEN
    	--Toolkit NUEVO
	    v_METODO := 'ALMACENAR_INTER_MIG_REATE';
		AB61.ALMACENAR_INTER_MIG_REATE (xmltype_SOLICITUD, n_ID_EXPEDIENTE, v_TAREAS);
    ELSE
    	--Toolkit VIEJO
    	v_METODO := 'ALM_INTER_MIG_REATE_VIEJO';
		AB61.ALM_INTER_MIG_REATE_VIEJO (xmltype_SOLICITUD, n_ID_EXPEDIENTE, v_TAREAS);
    END IF;

    dbms_output.put_line('finnn iter');
    
  END LOOP;
  
  dbms_output.put_line('fin total');
  
	-- Una vez que hayamos almacenado toda la informacin, guardamos una Traza con las Tareas Realizadas en la tbala AB6121T00
	SELECT S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;
	
	-- En este caso el Estado ser igual a 1 ya que todo ha ido bien
	v_METODO := 'COMPLETAR_EXPEDIENTES_REATE';
	INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO) VALUES 
	(n_ID_TRAZA, n_ID_SOLICITUD, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, '', v_METODO, 1, v_TAREAS, SYSDATE);

-- Haremos COMMIT cuando hayamos conpletado toda la informacin relacionada con el expediente.
COMMIT;
--ROLLBACK;

EXCEPTION
WHEN NO_DATA_FOUND THEN
BEGIN
    ROLLBACK;

    SELECT S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

    v_METODO := 'COMPLETAR_EXPEDIENTES_REATE';

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, n_ID_SOLICITUD, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

    END;

WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, n_ID_SOLICITUD, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

    END;

END COMPLETAR_EXPEDIENTES_REATE;
/
