CREATE OR REPLACE PROCEDURE AB61.ALMACENAR_INTER_MIG_REATE (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB6102T00.ID_EXPEDIENTE%TYPE,
                                                       OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_ID_REL_EXP_TER            AB6134T00.ID_REL_EXP_TER%TYPE;         -- Identificador de la Relacin del Expediente con el Tercero / la Empresa

n_ID_TERCERO                AB6135T00.ID_TERCERO%TYPE;             -- Identificador del Tercero
n_ID_TERCERO_REPRE          AB6135T00.ID_TERCERO%TYPE;             -- Identificador del Tercero del representante
v_DOCUMENTO                 AB6135T00.DOCUMENTO%TYPE;              -- DNI, NIF o Pasaporte del tercero
n_TIPO_PARTICIPANTE         AB6135T00.TIPO_PARTICIPANTE%TYPE;

n_ID_TIPO_TERCERO           AB6106T00.ID_TIPO_TERCERO%TYPE;        -- Identificador de Tipo de Tercero / Empresa

n_ID_TIPO_DOCUMENTO         AB6107T00.ID_TIPO_DOCUMENTO%TYPE;      -- Identificador de Tipo de Documento

n_ID_DIRECCION              AB6136T00.ID_DIRECCION%TYPE;
v_DIRECCION                 AB6136T00.DIRECCION%TYPE;                       -- Direccin del Titular
v_NUMERO                    AB6136T00.NUMERO%TYPE;                          -- Nmero de la Direccin del Titular
v_ESCALERA                  AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Direccin del Titular
v_PISO                      AB6136T00.PISO%TYPE;                            -- Piso de la Direccin del Titular
v_LETRA                     AB6136T00.LETRA%TYPE;                           -- Letra de la Direccin del Titular
v_CODIGO_POSTAL             AB6136T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin del Titular
n_ID_PROVINCIA              AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin del Titular
n_ID_MUNICIPIO              AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin del Titular
n_ID_LOCALIDAD              AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin del Titular
v_IDENT_ESTABLECIMIENTO		AB6136T00.IDENTIFICADOR_ESTABLECIMIENTO%TYPE;
v_ESTABLECIMIENTO					AB6136T00.ESTABLECIMIENTO%TYPE;

v_NUMERO_REGISTRO_1         	VARCHAR(1);                 					     -- Nmero de Registro _tipoEstSign
v_NUMERO_REGISTRO_2         	VARCHAR(2);                 					     -- Nmero de Registro _territEstSign
v_NUMERO_REGISTRO_3         	VARCHAR(5);						                     -- Nmero de Registro _correlativEstSign
v_IDESTAB_SOLIC					AB6136T00.IDENTIFICADOR_ESTABLECIMIENTO%TYPE; --Signatura rellenada en la solicitud
v_ESTAB_SOLIC					AB6136T00.ESTABLECIMIENTO%TYPE;

n_TXT_PROVINCIA   varchar2(500);
n_TXT_MUNICIPIO   varchar2(500);
n_TXT_LOCALIDAD   varchar2(500);

xmltype_AUXILIAR XMLTYPE;           	  -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
n_NumeroNodos NUMBER;               	  -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
xmltype_AUXILIAR_CanalesAviso XMLTYPE;  -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud para los Canales de Aviso

BEGIN

	
	dbms_output.put_line('N1');
	 
n_ID_TIPO_TERCERO:= 1; -- SOLICITANTE
n_ID_TERCERO_REPRE := null;

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ApplicantInfoRRI') > 0) THEN
  xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI');

  -- REPRESENTANTE: representativeRRI
  IF (xmltype_AUXILIAR.EXISTSNODE('.//representativeRRI') > 0) THEN

    xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI/representativeRRI');

    v_DOCUMENTO := null;
    n_ID_TIPO_DOCUMENTO := null;
    n_TIPO_PARTICIPANTE := 1; -- Representante

    IF (xmltype_AUXILIAR.EXISTSNODE('.//ID/text()') > 0) THEN
      v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('.//ID/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//personType/text()') > 0) THEN
      n_ID_TIPO_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('.//personType/text()').getStringVal();
    END IF;
    
    -- Canal comunicacin
    IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress') = 1) THEN
      -- Canal postal

    dbms_output.put_line('N2');
    
      	--Hay direccion postal para el representante, comprobamos si est insertada en la BD de AB61.
      	SELECT T35.ID_TERCERO, T36.ID_DIRECCION
      	INTO n_ID_TERCERO_REPRE, n_ID_DIRECCION
		FROM AB6134T00 T34, AB6135T00 T35, AB6136T00 T36
		WHERE T34.ID_TERCERO = T35.ID_TERCERO
		AND T35.ID_TERCERO = T36.ID_TERCERO(+)
		AND T34.ID_EXPEDIENTE = IN_ID_EXPEDIENTE
		AND T34.ID_TIPO_TERCERO = n_ID_TIPO_TERCERO
		AND T35.DOCUMENTO = v_DOCUMENTO
		AND T35.ID_TIPO_DOCUMENTO = n_ID_TIPO_DOCUMENTO
		AND T35.TIPO_PARTICIPANTE = n_TIPO_PARTICIPANTE
		AND T36.ID_TIPO_DIRECCION(+) = 4;
		
		
		dbms_output.put_line('N3');
		
		IF(n_ID_TERCERO_REPRE IS NOT NULL AND n_ID_DIRECCION IS NULL) THEN
			--No se ha encontrado direccion postal insertada para el respresentante, pero si est el tercero en BD.
			--Se inserta la direccion...
			
		      --v_PAIS := null;
		      --IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/pais/text()') > 0) THEN
		        --v_PAIS := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/pais/text()').getStringVal();
		      --END IF;
		      v_DIRECCION := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/direccion/text()') > 0) THEN
		        v_DIRECCION := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/direccion/text()').getStringVal();
		      END IF;
		
		      n_ID_LOCALIDAD := null;
		      n_TXT_LOCALIDAD := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/localidad/text()') > 0) THEN
		        n_TXT_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/localidad/text()').getStringVal();
		        IF INSTR(n_TXT_LOCALIDAD, '(') = 1 THEN
		          n_ID_LOCALIDAD := SUBSTR( n_TXT_LOCALIDAD, 2, INSTR(n_TXT_LOCALIDAD, ')')-2);
		        END IF;
		      END IF;
		
		      n_ID_MUNICIPIO := null;
		      n_TXT_MUNICIPIO := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/municipio/text()') > 0) THEN
		        n_TXT_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/municipio/text()').getStringVal();
		        IF INSTR(n_TXT_MUNICIPIO, '(') = 1 THEN
		          n_ID_MUNICIPIO := SUBSTR( n_TXT_MUNICIPIO, 2, INSTR(n_TXT_MUNICIPIO, ')')-2);
		        END IF;
		      END IF;
		
		      n_ID_PROVINCIA := null;
		      n_TXT_PROVINCIA := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/provincia/text()') > 0) THEN
		        n_TXT_PROVINCIA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/provincia/text()').getStringVal();
		        IF INSTR(n_TXT_PROVINCIA, '(') = 1 THEN
		          n_ID_PROVINCIA := SUBSTR( n_TXT_PROVINCIA, 2, INSTR(n_TXT_PROVINCIA, ')')-2);
		        END IF;
		      END IF;
		
		      v_NUMERO := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/portal/text()') > 0) THEN
		        v_NUMERO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/portal/text()').getStringVal();
		      END IF;
		      v_ESCALERA := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/escalera/text()') > 0) THEN
		        v_ESCALERA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/escalera/text()').getStringVal();
		      END IF;
		      v_PISO := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/piso/text()') > 0) THEN
		        v_PISO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/piso/text()').getStringVal();
		      END IF;
		      v_LETRA := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/letra/text()') > 0) THEN
		        v_LETRA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/letra/text()').getStringVal();
		      END IF;
		      v_CODIGO_POSTAL := null;
		      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/cp/text()') > 0) THEN
		        v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/cp/text()').getStringVal();
		      END IF;
		
		      -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
		      SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;
		
		      -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
		      INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
		      VALUES(n_ID_DIRECCION, n_ID_TERCERO_REPRE, 4, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'MIG_REATE');
		
		      --OUT_TAREAS := OUT_TAREAS || chr(13) || '-Direccion postal de notificacion representante aadida (' || n_ID_DIRECCION || ')';
		
		END IF;

    END IF;
    
  END IF;

  
  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//interestedListRRI') > 0) THEN
    -- TITULAR: interestedListRRI

    n_NumeroNodos:= 1;

    xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI/interestedListRRI');

    -- Obtenemos el nodo <body><ApplicantInfo><persons> para obtener el Solitante y/o representante
    WHILE xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']') = 1 LOOP
      v_DOCUMENTO := null;
      n_ID_TIPO_DOCUMENTO := null;
      n_TIPO_PARTICIPANTE := 0; -- Titular
      n_ID_TERCERO := null;
      n_ID_DIRECCION :=null;
      v_IDENT_ESTABLECIMIENTO := null;
      v_ESTABLECIMIENTO := null;
      v_NUMERO_REGISTRO_1 := null;
      v_NUMERO_REGISTRO_2 := null;
      v_NUMERO_REGISTRO_3 := null;
      v_IDESTAB_SOLIC := null;
      v_ESTAB_SOLIC := null;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ID/text()') > 0) THEN
        v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ID/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/personType/text()') > 0) THEN
        n_ID_TIPO_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/personType/text()').getStringVal();
      END IF;
      
      dbms_output.put_line('N4');

        --DIRECCION DEL ESTABLECIMIENTO
		BEGIN
		      	--Se comprueba si el titular tiene asociada la direccion del establecimiento, y si no se lanza ALMACENAR_UBICACION para que la inserte si viene en la solicitud.
		      	SELECT T35.ID_TERCERO, T36.ID_DIRECCION, T36.IDENTIFICADOR_ESTABLECIMIENTO, T36.ESTABLECIMIENTO
		      	INTO n_ID_TERCERO, n_ID_DIRECCION, v_IDENT_ESTABLECIMIENTO, v_ESTABLECIMIENTO
				FROM AB6134T00 T34, AB6135T00 T35, AB6136T00 T36
				WHERE T34.ID_TERCERO = T35.ID_TERCERO
				AND T35.ID_TERCERO = T36.ID_TERCERO(+)
				AND T34.ID_EXPEDIENTE = IN_ID_EXPEDIENTE
				AND T34.ID_TIPO_TERCERO = n_ID_TIPO_TERCERO
				AND T35.DOCUMENTO = v_DOCUMENTO
				AND T35.ID_TIPO_DOCUMENTO = n_ID_TIPO_DOCUMENTO
				AND T35.TIPO_PARTICIPANTE = n_TIPO_PARTICIPANTE
				AND T36.ID_TIPO_DIRECCION(+) = 2;
			EXCEPTION  
			WHEN NO_DATA_FOUND THEN
		      n_ID_TERCERO := null;
		      n_ID_DIRECCION :=null;
		      v_IDENT_ESTABLECIMIENTO := null;
		      v_ESTABLECIMIENTO := null;
			END;
      	
		
		dbms_output.put_line('N5');
		
      	IF(n_ID_TERCERO IS NOT NULL AND n_ID_DIRECCION IS NULL) THEN
      		
      		--Insertar direcccion del establecimiento.
			AB61.ALMACENAR_UBICACION_MIG_REATE (IN_xmltype_SOLICITUD, IN_ID_EXPEDIENTE, n_ID_TERCERO, OUT_TAREAS);
			
      	END IF;
      	
      	dbms_output.put_line('N6');
      	
      	--DIRECCION DEL ESTABLECIMIENTO: Identificador establecimiento y Nombre del establecimiento.
      	--Si hay direccion, y alguno de estos campos esta vacio, meter el de la solcitud.

      	---- Signatura introducida en la solicitud.
		IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//tipoEstSign/text()') > 0) THEN
			v_NUMERO_REGISTRO_1 := IN_xmltype_SOLICITUD.EXTRACT('.//tipoEstSign/text()').getStringVal();
		END IF;
		IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//signature/text()') > 0) THEN
			v_NUMERO_REGISTRO_2 := IN_xmltype_SOLICITUD.EXTRACT('.//signature/text()').getStringVal();
		END IF;
		IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//correlativEstSign/text()') > 0) THEN
			v_NUMERO_REGISTRO_3 := IN_xmltype_SOLICITUD.EXTRACT('.//correlativEstSign/text()').getStringVal();
			v_NUMERO_REGISTRO_3 := LPAD(v_NUMERO_REGISTRO_3,5,'0');
		END IF;
		v_IDESTAB_SOLIC := v_NUMERO_REGISTRO_1 || v_NUMERO_REGISTRO_2 || v_NUMERO_REGISTRO_3;
      	
      	--Nombre establecimiento rellenado en la solicitud.
      	IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//establecimientoNombre/text()') > 0) THEN
			v_ESTAB_SOLIC := IN_xmltype_SOLICITUD.EXTRACT('.//establecimientoNombre/text()').getStringVal();
		END IF;
      	
		IF(v_IDESTAB_SOLIC IS NOT NULL OR v_ESTAB_SOLIC IS NOT NULL) THEN
			--Alguno de los dos campos viene en la solicitud, hay que rellenarlos
		
			IF(n_ID_DIRECCION IS NULL) THEN
			
			dbms_output.put_line('N7');
				
      			BEGIN
		      			-- No sabemos si hay direccin, hay que comprobar si la hay primero.
				      	SELECT T35.ID_TERCERO, T36.ID_DIRECCION, T36.IDENTIFICADOR_ESTABLECIMIENTO, T36.ESTABLECIMIENTO
				      	INTO n_ID_TERCERO, n_ID_DIRECCION, v_IDENT_ESTABLECIMIENTO, v_ESTABLECIMIENTO
						FROM AB6134T00 T34, AB6135T00 T35, AB6136T00 T36
						WHERE T34.ID_TERCERO = T35.ID_TERCERO
						AND T35.ID_TERCERO = T36.ID_TERCERO(+)
						AND T34.ID_EXPEDIENTE = IN_ID_EXPEDIENTE
						AND T34.ID_TIPO_TERCERO = n_ID_TIPO_TERCERO
						AND T35.DOCUMENTO = v_DOCUMENTO
						AND T35.ID_TIPO_DOCUMENTO = n_ID_TIPO_DOCUMENTO
						AND T35.TIPO_PARTICIPANTE = n_TIPO_PARTICIPANTE
						AND T36.ID_TIPO_DIRECCION(+) = 2;
					EXCEPTION  
					WHEN NO_DATA_FOUND THEN
				      n_ID_TERCERO := null;
				      n_ID_DIRECCION :=null;
				      v_IDENT_ESTABLECIMIENTO := null;
				      v_ESTABLECIMIENTO := null;
					END;
				
			
			END IF;
		
			dbms_output.put_line('N8');
			
	      	IF(n_ID_DIRECCION IS NOT NULL) THEN
      			--Hay direccion, se meten el ident establecimiento y el nombre del establecimiento si no estaban metidos.
	      	
      			IF(v_IDENT_ESTABLECIMIENTO IS NULL) THEN
					--Si no hay ident, se mete el de la solicitud.
					
	  				UPDATE AB6136T00 SET IDENTIFICADOR_ESTABLECIMIENTO = v_IDESTAB_SOLIC,
	  				FECHA_ULTMODIFICACION = SYSDATE,
					USUARIO_ULTMODIFICACION  = 'MIG_REATE'
	  				WHERE ID_DIRECCION = n_ID_DIRECCION;
	  				
	  			END IF;
      		
  			    IF(v_ESTABLECIMIENTO IS NULL) THEN
					--Si no hay nombre, se mete el de la solicitud.
					
	  				UPDATE AB6136T00 SET ESTABLECIMIENTO = v_ESTAB_SOLIC,
	  				FECHA_ULTMODIFICACION = SYSDATE,
					USUARIO_ULTMODIFICACION  = 'MIG_REATE'
	  				WHERE ID_DIRECCION = n_ID_DIRECCION;
	  				
	  				
	  			END IF;
				
	      	END IF;
	      	
	      	dbms_output.put_line('N9');
	      	
		END IF;
      
     
      -- Canal comunicacin
      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress') = 1) THEN
        -- Canal postal
dbms_output.put_line('N10');
       		n_ID_TERCERO := null;
      
			BEGIN
	        	--Hay direccion postal para el titular, comprobamos si est insertada en la BD de AB61.
		      	SELECT T35.ID_TERCERO, T36.ID_DIRECCION
		      	INTO n_ID_TERCERO, n_ID_DIRECCION
				FROM AB6134T00 T34, AB6135T00 T35, AB6136T00 T36
				WHERE T34.ID_TERCERO = T35.ID_TERCERO
				AND T35.ID_TERCERO = T36.ID_TERCERO(+)
				AND T34.ID_EXPEDIENTE = IN_ID_EXPEDIENTE
				AND T34.ID_TIPO_TERCERO = n_ID_TIPO_TERCERO
				AND T35.DOCUMENTO = v_DOCUMENTO
				AND T35.ID_TIPO_DOCUMENTO = n_ID_TIPO_DOCUMENTO
				AND T35.TIPO_PARTICIPANTE = n_TIPO_PARTICIPANTE
				AND T36.ID_TIPO_DIRECCION(+) = 4;
			EXCEPTION  
			WHEN NO_DATA_FOUND THEN
		      n_ID_TERCERO := null;
		      n_ID_DIRECCION :=null;
			END;
	    
			dbms_output.put_line('N11');
			
			IF(n_ID_TERCERO IS NOT NULL AND n_ID_DIRECCION IS NULL) THEN
			
		        --v_PAIS := null;
		        --IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/pais/text()') > 0) THEN
		          --v_PAIS := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/pais/text()').getStringVal();
		        --END IF;
		        v_DIRECCION := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/direccion/text()') > 0) THEN
		          v_DIRECCION := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/direccion/text()').getStringVal();
		        END IF;
		
		        n_ID_LOCALIDAD := null;
		        n_TXT_LOCALIDAD := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/localidad/text()') > 0) THEN
		          n_TXT_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/localidad/text()').getStringVal();
		          IF INSTR(n_TXT_LOCALIDAD, '(') = 1 THEN
		            n_ID_LOCALIDAD := SUBSTR( n_TXT_LOCALIDAD, 2, INSTR(n_TXT_LOCALIDAD, ')')-2);
		          END IF;
		        END IF;
		
		        n_ID_MUNICIPIO := null;
		        n_TXT_MUNICIPIO := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/municipio/text()') > 0) THEN
		          n_TXT_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/municipio/text()').getStringVal();
		          IF INSTR(n_TXT_MUNICIPIO, '(') = 1 THEN
		            n_ID_MUNICIPIO := SUBSTR( n_TXT_MUNICIPIO, 2, INSTR(n_TXT_MUNICIPIO, ')')-2);
		          END IF;
		        END IF;
		
		        n_ID_PROVINCIA := null;
		        n_TXT_PROVINCIA := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/provincia/text()') > 0) THEN
		          n_TXT_PROVINCIA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/provincia/text()').getStringVal();
		          IF INSTR(n_TXT_PROVINCIA, '(') = 1 THEN
		            n_ID_PROVINCIA := SUBSTR( n_TXT_PROVINCIA, 2, INSTR(n_TXT_PROVINCIA, ')')-2);
		          END IF;
		        END IF;
		
		        v_NUMERO := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/portal/text()') > 0) THEN
		          v_NUMERO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/portal/text()').getStringVal();
		        END IF;
		        v_ESCALERA := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/escalera/text()') > 0) THEN
		          v_ESCALERA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/escalera/text()').getStringVal();
		        END IF;
		        v_PISO := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/piso/text()') > 0) THEN
		          v_PISO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/piso/text()').getStringVal();
		        END IF;
		        v_LETRA := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/letra/text()') > 0) THEN
		          v_LETRA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/letra/text()').getStringVal();
		        END IF;
		        v_CODIGO_POSTAL := null;
		        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/cp/text()') > 0) THEN
		          v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/cp/text()').getStringVal();
		        END IF;
		
		        -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
		        SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;
		
		        -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
		        INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
		        VALUES(n_ID_DIRECCION, n_ID_TERCERO, 4, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'MIG_REATE');
		
		        --OUT_TAREAS := OUT_TAREAS || chr(13) || '-Direccion postal de notificacion de titular aadida (' || n_ID_DIRECCION || ')';
      
      		END IF;

      END IF;
      
      n_NumeroNodos := n_NumeroNodos + 1;

    END LOOP;

  END IF;
  
END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_INTER_MIG_REATE;
/
