CREATE OR REPLACE PROCEDURE AB61.ALMACENAR_UBICACION_MIG_REATE (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB61.AB6102T00.ID_EXPEDIENTE%TYPE,
                                                 IN_ID_TERCERO IN AB61.AB6135T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB61.AB6121T00.TAREAS%TYPE) AS

n_ID_DIRECCION              AB61.AB6136T00.ID_DIRECCION%TYPE;                      -- Identificador de la Empresa
n_ID_TIPO_DIRECCION         AB61.AB6136T00.ID_TIPO_DIRECCION%TYPE;
v_ESTABLECIMIENTO           AB61.AB6136T00.ESTABLECIMIENTO%TYPE;                 -- Nombre de la Empresa / Establecimiento
v_DIRECCION                 AB61.AB6136T00.DIRECCION%TYPE;                       -- Direccin de la Empresa / Establecimiento
v_NUMERO                    AB61.AB6136T00.NUMERO%TYPE;                          -- Nmero de la Direccin de la Empresa / Establecimiento
v_ESCALERA                  AB61.AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Direccin de la Empresa / Establecimiento
v_PISO                      AB61.AB6136T00.PISO%TYPE;                            -- Piso de la Direccin de la Empresa / Establecimiento
v_LETRA                     AB61.AB6136T00.LETRA%TYPE;                           -- Letra de la Direccin de la Empresa / Establecimiento
v_CODIGO_POSTAL             AB61.AB6136T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin de la Empresa / Establecimiento
n_ID_PROVINCIA              AB61.AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin de la Empresa / Establecimiento
n_ID_MUNICIPIO              AB61.AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin de la Empresa / Establecimiento
n_ID_LOCALIDAD              AB61.AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin de la Empresa / Establecimiento

xmltype_AUXILIAR XMLTYPE;           -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
ubi number;

BEGIN

	dbms_output.put_line('U1');
	
    v_ESTABLECIMIENTO := null;
    v_DIRECCION := null;
    v_NUMERO := null;
    v_ESCALERA := null;
    v_PISO := null;
    v_LETRA := null;
    v_CODIGO_POSTAL := null;
    n_ID_PROVINCIA := null;
    n_ID_MUNICIPIO := null;
    n_ID_LOCALIDAD := null;
    n_ID_TIPO_DIRECCION := 2; -- Ubicacin de la actividad

    IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoEstablecimiento') >  0) THEN
      --SOLICITUD NUEVA (grupoEstablecimiento).
    	
    dbms_output.put_line('U2');
    
      xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//grupoEstablecimiento');
    
      IF (xmltype_AUXILIAR.EXISTSNODE('.//establecimientoNombre/text()') > 0) THEN
        v_ESTABLECIMIENTO := xmltype_AUXILIAR.EXTRACT('.//establecimientoNombre/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDomicilio/text()') > 0) THEN
        v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//ubiDomicilio/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiPortal/text()') > 0) THEN
        v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//ubiPortal/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEscalera/text()') > 0) THEN
        v_ESCALERA := xmltype_AUXILIAR.EXTRACT('.//ubiEscalera/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiPiso/text()') > 0) THEN
        v_PISO := xmltype_AUXILIAR.EXTRACT('.//ubiPiso/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLetra/text()') > 0) THEN
        v_LETRA := xmltype_AUXILIAR.EXTRACT('.//ubiLetra/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiCP/text()') > 0) THEN
        v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//ubiCP/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiProvincia/text()') > 0) THEN
        n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//ubiProvincia/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiMunicipio/text()') > 0) THEN
        n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//ubiMunicipio/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLocalidad/text()') > 0) THEN
        n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('.//ubiLocalidad/text()').getStringVal();
      END IF;
      
      dbms_output.put_line('U3');
      
      -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
      SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

      -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
      INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, ESTABLECIMIENTO, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
      VALUES(n_ID_DIRECCION, IN_ID_TERCERO, n_ID_TIPO_DIRECCION, v_ESTABLECIMIENTO, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'MIG_REATE');

      --OUT_TAREAS := OUT_TAREAS || chr(13) || '-Datos de la Empresa / Ubicacin Almacenada (' || n_ID_DIRECCION || ')';

    ELSIF (IN_xmltype_SOLICITUD.EXISTSNODE('.//datosDomicilioUbi') >  0) THEN
    	--SOLICITUD VIEJA (datosDomicilioUbi).
    
    	dbms_output.put_line('U4');
    
    	IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/proyecto/ubicacionInversion/ubiNombre/text()') > 0) THEN
    		v_ESTABLECIMIENTO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/proyecto/ubicacionInversion/ubiNombre/text()').getStringVal();
    	END IF;

		IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//datosDomicilioUbi') >  0) THEN
		
			dbms_output.put_line('U5');
		
		    xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//datosDomicilioUbi');
		    
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiDomicilio/text()') > 0) THEN
			    v_DIRECCION := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiDomicilio/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiPortal/text()') > 0) THEN
			    v_NUMERO := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiPortal/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiEscalera/text()') > 0) THEN
		        v_ESCALERA := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiEscalera/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiPiso/text()') > 0) THEN
		        v_PISO := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiPiso/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiLetra/text()') > 0) THEN
		        v_LETRA := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiLetra/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiCP/text()') > 0) THEN
		    	v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiCP/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiProvince/text()') > 0) THEN
		    	n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiProvince/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('/datosDomicilioUbi/holderchoicedatosDomicilioUbiMunicipio/text()') > 0) THEN
		    	n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiMunicipio/text()').getStringVal();
		    END IF;
		    IF (xmltype_AUXILIAR.EXISTSNODE('datosDomicilioUbi/holderchoicedatosDomicilioUbiLocalidad/text()') > 0) THEN
		        n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('/datosDomicilioUbi/holderchoicedatosDomicilioUbiLocalidad/text()').getStringVal();
		    END IF;
		
		END IF;
		
		dbms_output.put_line('U6');
		
		 -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
		SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;
		
		-- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
		INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, ESTABLECIMIENTO, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
		VALUES(n_ID_DIRECCION, IN_ID_TERCERO, n_ID_TIPO_DIRECCION, v_ESTABLECIMIENTO, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'MIG_REATE');
		
		
		--OUT_TAREAS := OUT_TAREAS || chr(13) || '-Datos de la Empresa / Ubicacin Almacenada (' || n_ID_DIRECCION || ')';
		
	ELSIF (IN_xmltype_SOLICITUD.EXISTSNODE('.//datosUbicacionActividad') >  0) THEN
		--SOLICITUD TOOLKIT VIEJO (datosUbicacionActividad).
	
		dbms_output.put_line('U7');
	
	
	    xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//datosUbicacionActividad');
	    
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadDomicilio/text()') > 0) THEN
		    v_DIRECCION := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadDomicilio/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadPortal/text()') > 0) THEN
		    v_NUMERO := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadPortal/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadEscalera/text()') > 0) THEN
	        v_ESCALERA := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadEscalera/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadPiso/text()') > 0) THEN
	        v_PISO := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadPiso/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadLetra/text()') > 0) THEN
	        v_LETRA := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadLetra/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadCP/text()') > 0) THEN
	    	v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadCP/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadProvince/text()') > 0) THEN
	    	n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadProvince/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadMunicipio/text()') > 0) THEN
	    	n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadMunicipio/text()').getStringVal();
	    END IF;
	    IF (xmltype_AUXILIAR.EXISTSNODE('datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadLocalidad/text()') > 0) THEN
	        n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('/datosUbicacionActividad/holderchoicedatosDomicilioUbicacionActividadLocalidad/text()').getStringVal();
	    END IF;
		
	    
	    dbms_output.put_line('U8');
		
		 -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
		SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;
		
		-- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
		INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, ESTABLECIMIENTO, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
		VALUES(n_ID_DIRECCION, IN_ID_TERCERO, n_ID_TIPO_DIRECCION, v_ESTABLECIMIENTO, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'MIG_REATE');
		
		
		--OUT_TAREAS := OUT_TAREAS || chr(13) || '-Datos de la Empresa / Ubicacin Almacenada (' || n_ID_DIRECCION || ')';
		
    END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_UBICACION_MIG_REATE;
/
