PROMPT Creacin Tabla (AB6130T00)

CREATE TABLE AB6130T00
(
	ID_DETALLE_HACIENDA  NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	FECHA_PETICION       DATE NULL ,
	FECHA_EST_RESPUESTA  DATE NULL ,
	CODIGO_PETICION      VARCHAR2(50 CHAR) NULL ,
	ID_ESTADO_HACIENDA   NUMBER(4) NOT NULL ,
	DESCRIPCION          VARCHAR2(200 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6001E00;

COMMENT ON TABLE AB6130T00 IS 'Tabla para almacenar el Detalle de Interoperabilidad de las llamadas realizadas a Hacienda';
COMMENT ON COLUMN AB6130T00.ID_DETALLE_HACIENDA IS 'Identificador del Detalle de Interoperabilidad de las llamadas realizadas a Hacienda';
COMMENT ON COLUMN AB6130T00.FECHA_PETICION IS 'Fecha de Peticin';
COMMENT ON COLUMN AB6130T00.FECHA_EST_RESPUESTA IS 'Fecha Estimada de Respuesta';
COMMENT ON COLUMN AB6130T00.CODIGO_PETICION IS 'Cdigo de Peticin';
COMMENT ON COLUMN AB6130T00.DESCRIPCION IS 'Descripcin del Detalle de Interoperabilidad de las llamadas realizadas a Hacienda';
COMMENT ON COLUMN AB6130T00.ID_ESTADO_HACIENDA IS 'Identificador del Estado de Hacienda (Interoperabilidad)';
COMMENT ON COLUMN AB6130T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6130T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6130T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente';


CREATE SYNONYM DET_INT_HACIENDA	 FOR AB6130T00;


CREATE UNIQUE INDEX PK_AB6130T00 ON AB6130T00(ID_DETALLE_HACIENDA   ASC);
ALTER TABLE AB6130T00	ADD CONSTRAINT  PK_AB6130T00 PRIMARY KEY (ID_DETALLE_HACIENDA);

CREATE  INDEX FK_AB6130T00 ON AB6130T00(ID_ESTADO_HACIENDA   ASC);
CREATE  INDEX FK_AB6130T01 ON AB6130T00(ID_EXPEDIENTE   ASC);

ALTER TABLE AB6130T00	ADD (CONSTRAINT FK_AB6128T00_AB6130T00 FOREIGN KEY (ID_ESTADO_HACIENDA) REFERENCES AB6128T00 (ID_ESTADO_HACIENDA));
ALTER TABLE AB6130T00	ADD (CONSTRAINT FK_AB6102T00_AB6130T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));


