PROMPT Creacin Tabla (AB6130T00)

CREATE TABLE AB6131T00
(
	ID_DETALLE_TGSS      NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	FECHA_PETICION       DATE NULL ,
	CODIGO_PETICION      VARCHAR2(50 CHAR) NULL ,
	ID_ESTADO_TGSS       NUMBER(4) NOT NULL ,
	DESCRIPCION          VARCHAR2(200 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6131T00 IS 'Tabla para almacenar el Detalle de Interoperabilidad de las llamadas realizadas a Tesorera General de la Seguridad Socilas (TGSS)';
COMMENT ON COLUMN AB6131T00.ID_DETALLE_TGSS IS 'Identificador del Detalle de Interoperabilidad de las llamadas realizadas a TGSS (Tesorera General de la Seguridad Social)';
COMMENT ON COLUMN AB6131T00.FECHA_PETICION IS 'Fecha de Peticin';
COMMENT ON COLUMN AB6131T00.CODIGO_PETICION IS 'Cdigo de Peticin';
COMMENT ON COLUMN AB6131T00.DESCRIPCION IS 'Descripcin del Detalle de Interoperabilidad de las llamadas realizadas a TGSS (Tesorera General de la Seguridad Social)';
COMMENT ON COLUMN AB6131T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6131T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6131T00.ID_ESTADO_TGSS IS 'Identificador del Estado de TGSS - Tesorera General de la Seguridad Social (Interoperabilidad)';
COMMENT ON COLUMN AB6131T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente';


CREATE SYNONYM DET_INT_TGSS	 FOR AB6131T00;


CREATE UNIQUE INDEX PK_AB6131T00 ON AB6131T00(ID_DETALLE_TGSS   ASC);
ALTER TABLE AB6131T00	ADD CONSTRAINT  PK_AB6131T00 PRIMARY KEY (ID_DETALLE_TGSS);

CREATE  INDEX FK_AB6131T00 ON AB6131T00(ID_ESTADO_TGSS   ASC);
CREATE  INDEX FK_AB6131T01 ON AB6131T00(ID_EXPEDIENTE   ASC);

ALTER TABLE AB6131T00	ADD (CONSTRAINT FK_AB6129T00_AB6131T00 FOREIGN KEY (ID_ESTADO_TGSS) REFERENCES AB6129T00 (ID_ESTADO_TGSS));
ALTER TABLE AB6131T00	ADD (CONSTRAINT FK_AB6102T00_AB6131T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));


