CREATE TABLE AB6133T00
(
	ID_REL_EXP_PLA       NUMBER(8) NOT NULL ,
	ID_PLANTILLA         NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	RUTA                 VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6133T00 IS 'Tabla que relaciona el Expediente con la Plantilla que se est generando / modificando';
COMMENT ON COLUMN AB6133T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente (secuencia)';
COMMENT ON COLUMN AB6133T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6133T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6133T00.ID_PLANTILLA IS 'Identificador interno de Plantilla (secuencia)';
COMMENT ON COLUMN AB6133T00.ID_REL_EXP_PLA IS 'Identificador interno de la relacin del Expediente y la Plantilla';
COMMENT ON COLUMN AB6133T00.RUTA IS 'Ruta donde vamos a crear el documento en /DATOS/TMP y el PIF: Cdigo de Aplicacin, Fecha y Nombre de Archivo (FOLDER_NUMBER + Plantilla + Timestamp)';


CREATE SYNONYM REL_EXP_PLA	 FOR AB6133T00;


CREATE UNIQUE INDEX PK_AB6133T00 ON AB6133T00(ID_REL_EXP_PLA   ASC);
ALTER TABLE AB6133T00	ADD CONSTRAINT  PK_AB6133T00 PRIMARY KEY (ID_REL_EXP_PLA);


CREATE  INDEX FK_AB6133T00 ON AB6133T00(ID_EXPEDIENTE   ASC);
CREATE  INDEX FK_AB6133T01 ON AB6133T00(ID_PLANTILLA   ASC);

ALTER TABLE AB6133T00	ADD (CONSTRAINT FK_AB6102T00_AB6133T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));
ALTER TABLE AB6133T00	ADD (CONSTRAINT FK_AB6110T00_AB6133T00 FOREIGN KEY (ID_PLANTILLA) REFERENCES AB6110T00 (ID_PLANTILLA));








