PROMPT Eliminar Vista (AB61_P88_CONTABLE_MET)
DROP VIEW AB61_P88_CONTABLE_MET;

PROMPT Crear Vista (AB61_P88_CONTABLE_MET)

  CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."AB61_P88_CONTABLE_MET" ("LINEA", "ANO_EXPEDIENTE", "ID_EXPEDIENTE", "NUMERO_EXPEDIENTE", "FECHA_ENTRADA_EXP", "IMPORTE", "ANTICIPO", "CIF_NIF", "ID_EMPRESA", "FISICA_JURIDICA", "RAZON_SOCIAL", "NOMBRE_EMPRESA_F", "APELLIDO1_EMPRESA_F", "APELLIDO2_EMPRESA_F", "FH_RESOLUCION", "TERRITORIO_OT", "FH_DOC_COMPLETA", "FH_PRES_DOC", "ID_OPERACION", "ACTUACION") AS 
  SELECT 'MET' LINEA,
  T1.CONVOCATORIA ANO_EXPEDIENTE, T2.ID_EXPEDIENTE ID_EXPEDIENTE,   
  (T2.FOLDER_NUMBER || '   ') NUMERO_EXPEDIENTE, 
  T2.FECHA_ENTRADA FECHA_ENTRADA_EXP, T05.SUBVENCION_RESUELTA IMPORTE, NULL ANTICIPO,
  CASE WHEN T3.ID_TERCERO IS NOT NULL THEN T4.DOCUMENTO ELSE T5.NIF END CIF_NIF,
  1 ID_EMPRESA,
  CASE WHEN T3.ID_TERCERO IS NOT NULL THEN 'F' ELSE 'J' END FISICA_JURIDICA, NVL (T5.NOMBRE, T4.NOMBRE || ' ' || T4.APELLIDO1 || ' ' || T4.APELLIDO2) RAZON_SOCIAL,
  T4.NOMBRE NOMBRE_EMPRESA_F, T4.APELLIDO1 APELLIDO1_EMPRESA_F, T4.APELLIDO2 APELLIDO2_EMPRESA_F,
  T2.FECHA_RESOLUCION FH_RESOLUCION,
  DECODE (ID_TERRITORIO_HISTORICO, '1', '1', '20', '2', '48', '3', '4' ) TERRITORIO_OT,
  T2.FECHA_DOC_COM FH_DOC_COMPLETA,
  T2.FECHA_DOC_COM FH_PRES_DOC,
  0 ID_OPERACION,
  NULL ACTUACION
FROM 
  AB60.AB6001T00 T1,
  AB61.AB6102T00 T2
, (SELECT ID_TERCERO,ID_EMPRESA,ID_TIPO_TERCERO,ID_EXPEDIENTE FROM AB61.AB6103T00 WHERE ID_TIPO_TERCERO=1) T3
, AB61.AB6104T00 T4
, AB61.AB6105T00 T5
, AB60.AB6005T00 T05
WHERE 
T2.ID_PROCEDIMIENTO=6
AND T2.ID_PROCEDIMIENTO = T1.ID_PROCEDIMIENTO
AND T2.ID_EXPEDIENTE = T05.ID_EXPEDIENTE
AND T2.ID_EXPEDIENTE = T3.ID_EXPEDIENTE
AND T3.ID_TERCERO = T4.ID_TERCERO (+)
AND T3.ID_EMPRESA = T5.ID_EMPRESA (+)
AND T05.ID_RESULTADO=1
AND T05.SUBVENCION_RESUELTA > 0 
ORDER BY T2.ID_TERRITORIO_HISTORICO, T2.FOLDER_NUMBER;
/

GRANT SELECT ON "AB61"."AB61_P88_CONTABLE_MET" TO "P88B" WITH GRANT OPTION;