PROMPT Creacion de 	Tabla (AB6135T00)

CREATE TABLE AB6135T00
(
	ID_TERCERO           NUMBER(8) NOT NULL ,
	DOCUMENTO            VARCHAR2(65) NULL ,
	ID_TIPO_DOCUMENTO    NUMBER(2) NULL ,
	NOMBRE               VARCHAR2(260 CHAR) NULL ,
	APELLIDO1            VARCHAR2(260) NULL ,
	APELLIDO2            VARCHAR2(260) NULL ,
	ID_SEXO              NUMBER(2) NULL ,
	TELEFONO             NUMBER(10,0) NULL ,
	EMAIL                VARCHAR2(100 CHAR) NULL ,
	IDIOMA               NUMBER(1) NULL ,
	TIPO_PARTICIPANTE    NUMBER(1) NULL ,
	ID_REPRESENTANTE     NUMBER(8) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
);


COMMENT ON COLUMN AB6135T00.ID_TERCERO IS 'Identificador interno del Tercero (secuencia)';
COMMENT ON COLUMN AB6135T00.DOCUMENTO IS 'DNI, NIF o Pasaporte del tercero';
COMMENT ON COLUMN AB6135T00.ID_TIPO_DOCUMENTO IS 'Identicador del Tipo de Documento';
COMMENT ON COLUMN AB6135T00.NOMBRE IS 'Nombre del Tercero / Razn social del Tercero';
COMMENT ON COLUMN AB6135T00.APELLIDO1 IS 'Primer Apellido del Tercero';
COMMENT ON COLUMN AB6135T00.APELLIDO2 IS 'Segundo Apellido del Tercero';
COMMENT ON COLUMN AB6135T00.ID_SEXO IS 'Identificador interno de Sexo';
COMMENT ON COLUMN AB6135T00.TELEFONO IS 'Telfono del Tercero (Persona de Contacto)';
COMMENT ON COLUMN AB6135T00.EMAIL IS 'Email del Tercero (Persona de Contacto)';
COMMENT ON COLUMN AB6135T00.IDIOMA IS 'Idioma de comunicacin con el Tercero:
0: Castellano
1: Euskera';
COMMENT ON COLUMN AB6135T00.TIPO_PARTICIPANTE IS 'Tipo del Participante del Tercero dentro de la Participacin:
0: Titular
1: Representante';
COMMENT ON COLUMN AB6135T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6135T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6135T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6135T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6135T00.ID_REPRESENTANTE IS 'Identificador interno del Representante, en el caso de que el Tercero sea Titular';


CREATE SYNONYM DATOS_TERCEROS	 FOR AB6135T00;


CREATE UNIQUE INDEX PK_AB6135T00 ON AB6135T00(ID_TERCERO   ASC);
ALTER TABLE AB6135T00	ADD CONSTRAINT  PK_AB6135T00 PRIMARY KEY (ID_TERCERO);


CREATE  INDEX FK_AB6135T00 ON AB6135T00(ID_TIPO_DOCUMENTO   ASC);
CREATE  INDEX FK_AB6135T01 ON AB6135T00(ID_SEXO   ASC);
CREATE  INDEX FK_AB6135T02 ON AB6135T00(ID_REPRESENTANTE   ASC);

ALTER TABLE AB6135T00	ADD (CONSTRAINT FK_AB6107T00_AB6135T00 FOREIGN KEY (ID_TIPO_DOCUMENTO) REFERENCES AB6107T00 (ID_TIPO_DOCUMENTO));
ALTER TABLE AB6135T00	ADD (CONSTRAINT FK_AB6120T00_AB6135T00 FOREIGN KEY (ID_SEXO) REFERENCES AB6120T00 (ID_SEXO));
ALTER TABLE AB6135T00	ADD (CONSTRAINT FK_AB6135T00_AB6135T00 FOREIGN KEY (ID_REPRESENTANTE) REFERENCES AB6135T00 (ID_TERCERO) ON DELETE SET NULL);