PROMPT Creacion de 	Tabla (AB6134T00)


CREATE TABLE AB6134T00
(
	ID_REL_EXP_TER       NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	ID_TERCERO           NUMBER(8) NOT NULL ,
	ID_TIPO_TERCERO      NUMBER(2) NOT NULL ,
	PARTICIPANT_ID       VARCHAR2(64 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 	
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6134T00 IS 'Relacin de Terceros con el Expediente';
COMMENT ON COLUMN AB6134T00.ID_REL_EXP_TER IS 'Identificador interno de la Relacin del Expediente con el Tercero (secuencia)';
COMMENT ON COLUMN AB6134T00.ID_TERCERO IS 'Identificador interno del Tercero';
COMMENT ON COLUMN AB6134T00.ID_TIPO_TERCERO IS 'Identificador interno de Tipo de Tercero';
COMMENT ON COLUMN AB6134T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente';
COMMENT ON COLUMN AB6134T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6134T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6134T00.PARTICIPANT_ID IS 'PARTICIPANT_ID del Tercero obtenido de PLATEA';
COMMENT ON COLUMN AB6134T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6134T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';

CREATE SYNONYM REL_EXP_TER	 FOR AB6134T00;


CREATE UNIQUE INDEX PK_AB6134T00 ON AB6134T00(ID_REL_EXP_TER   ASC);
ALTER TABLE AB6134T00	ADD CONSTRAINT  PK_AB6134T00 PRIMARY KEY (ID_REL_EXP_TER);


CREATE  INDEX FK_AB6134T00 ON AB6134T00(ID_TERCERO   ASC);
CREATE  INDEX FK_AB6134T01 ON AB6134T00(ID_TIPO_TERCERO   ASC);
CREATE  INDEX FK_AB6134T02 ON AB6134T00(ID_EXPEDIENTE   ASC);


ALTER TABLE AB6134T00	ADD (CONSTRAINT FK_AB6135T00_AB6134T00 FOREIGN KEY (ID_TERCERO) REFERENCES AB6135T00 (ID_TERCERO));
ALTER TABLE AB6134T00	ADD (CONSTRAINT FK_AB6106T00_AB6106T00 FOREIGN KEY (ID_TIPO_TERCERO) REFERENCES AB6106T00 (ID_TIPO_TERCERO));
ALTER TABLE AB6134T00	ADD (CONSTRAINT FK_AB6102T00_AB6134T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));