PROMPT Creacion de 	Tabla (AB6136T00)


CREATE TABLE AB6136T00
(
	ID_DIRECCION         NUMBER(8) NOT NULL ,
	ID_TERCERO           NUMBER(8) NOT NULL ,
	ID_TIPO_DIRECCION    NUMBER(2) NOT NULL ,
	IDENTIFICADOR_ESTABLECIMIENTO VARCHAR2(20 CHAR) NULL ,
	ESTABLECIMIENTO      VARCHAR2(260 CHAR) NULL ,
	DIRECCION            VARCHAR2(100 CHAR) NULL ,
	NUMERO               VARCHAR2(10 CHAR) NULL ,
	ESCALERA             VARCHAR2(4) NULL ,
	PISO                 VARCHAR2(4) NULL ,
	LETRA                VARCHAR2(4) NULL ,
	CODIGO_POSTAL        VARCHAR2(5) NULL ,
	ID_PROVINCIA         NUMBER(2,0) NULL ,
	ID_MUNICIPIO         NUMBER(3,0) NULL ,
	ID_LOCALIDAD         NUMBER(15,0) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6136T00 IS 'Tabla de las Direcciones de los Terceros';
COMMENT ON COLUMN AB6136T00.ID_DIRECCION IS 'Identificador interno de la Direccin (secuencia)';
COMMENT ON COLUMN AB6136T00.ID_TERCERO IS 'Identificador interno del Tercero';
COMMENT ON COLUMN AB6136T00.DIRECCION IS 'Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.NUMERO IS 'Nmero de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.ESCALERA IS 'Escalera de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.PISO IS 'Piso de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.LETRA IS 'Letra de la Direccin de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.CODIGO_POSTAL IS 'Cdigo Postal de la Empresa / Establecimiento';
COMMENT ON COLUMN AB6136T00.ID_PROVINCIA IS 'Identificador de la Provincia, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6136T00.ID_MUNICIPIO IS 'Identificador del Municipio, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6136T00.ID_LOCALIDAD IS 'Identificador de la Localidad, mediante este identificador iremos a NORA a por la descripcin';
COMMENT ON COLUMN AB6136T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6136T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6136T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6136T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6136T00.ID_TIPO_DIRECCION IS 'Identificador del Tipo de Direccin';
COMMENT ON COLUMN AB6136T00.ESTABLECIMIENTO IS 'Nombre del Establecimiento';
COMMENT ON COLUMN AB6136T00.IDENTIFICADOR_ESTABLECIMIENTO IS 'Nmero de Registro del Establecimiento';


CREATE SYNONYM DATOS_DIRECCIONES	 FOR AB6136T00;


CREATE UNIQUE INDEX PK_AB6136T00 ON AB6136T00(ID_DIRECCION   ASC);
ALTER TABLE AB6136T00	ADD CONSTRAINT  PK_AB6136T00 PRIMARY KEY (ID_DIRECCION);

CREATE  INDEX IK_AB6136T00 ON AB6136T00(IDENTIFICADOR_ESTABLECIMIENTO   ASC);

CREATE  INDEX FK_AB6136T00 ON AB6136T00(ID_TERCERO   ASC);
CREATE  INDEX FK_AB6136T01 ON AB6136T00(ID_TIPO_DIRECCION   ASC);

ALTER TABLE AB6136T00	ADD (CONSTRAINT FK_AB6135T00_AB6136T00 FOREIGN KEY (ID_TERCERO) REFERENCES AB6135T00 (ID_TERCERO));
ALTER TABLE AB6136T00	ADD (CONSTRAINT FK_AB6137T00_AB6136T00 FOREIGN KEY (ID_TIPO_DIRECCION) REFERENCES AB6137T00 (ID_TIPO_DIRECCION));