PROMPT Lanzar Procedimiento ALMACENAR_TER_EMP_SOL_REP

create or replace PROCEDURE ALMACENAR_TER_EMP_SOL_REP (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB6102T00.ID_EXPEDIENTE%TYPE, 
                                                       OUT_ID_TERCERO IN OUT AB6135T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS 

n_ID_REL_EXP_TER            AB6134T00.ID_REL_EXP_TER%TYPE;              -- Identificador de la Relacin del Expediente con el Tercero / la Empresa

n_ID_TERCERO                AB6135T00.ID_TERCERO%TYPE;                      -- Identificador del Tercero
v_DOCUMENTO                 AB6135T00.DOCUMENTO%TYPE;                       -- DNI, NIF o Pasaporte del tercero
v_NOMBRE                    AB6135T00.NOMBRE%TYPE;                          -- Nombre del Tercero
v_APELLIDO1                 AB6135T00.APELLIDO1%TYPE;                       -- Primer Apellido del Tercero
v_APELLIDO2                 AB6135T00.APELLIDO2%TYPE;                       -- Segundo Apellido del Tercero
n_TIPO_PARTICIPANTE         AB6135T00.TIPO_PARTICIPANTE%TYPE;

n_ID_TIPO_TERCERO           AB6106T00.ID_TIPO_TERCERO%TYPE;                 -- Identificador de Tipo de Tercero / Empresa

n_ID_TIPO_DOCUMENTO         AB6107T00.ID_TIPO_DOCUMENTO%TYPE;               -- Identificador de Tipo de Documento

n_ID_SEXO                   AB6120T00.ID_SEXO%TYPE;                         -- Identificador del Sexo

n_ID_TIPO_CANAL_AVISO       AB6115T00.ID_TIPO_CANAL_AVISO%TYPE;             -- Identificador de Tipo de Canal de Aviso

n_ID_CANAL_AVISO            AB6116T00.ID_CANAL_AVISO%TYPE;                  -- Identificador del Canal de Aviso
v_CANAL_AVISO               AB6116T00.CANAL_AVISO%TYPE;                     -- Descripcin del Canal de Aviso

xmltype_AUXILIAR XMLTYPE;           	-- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
n_NumeroNodos NUMBER;               	-- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
xmltype_AUXILIAR_CanalesAviso XMLTYPE;  -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud para los Canales de Aviso
n_NumeroNodos_CanalesAviso NUMBER;      -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar para los Canales de Aviso

BEGIN

xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfo/persons');

n_NumeroNodos:= 1;

n_ID_TIPO_TERCERO:= 1; -- SOLICITANTE

-- Obtenemos el nodo <body><ApplicantInfo><persons> para obtener el Solitante y/o representante
WHILE xmltype_AUXILIAR.EXISTSNODE('persons/person[' || n_NumeroNodos || ']') = 1 LOOP

    -- En primer lugar, miramos qu Tipo de Tercero (Persona) o Empresa es: Solitante (Tipo de Tercero = 1) o Representante (Tipo de Tercero = 3)
    IF (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/holderShip/text()').getStringVal() = 'HOLDER') THEN -- HolderShip = HOLDER (Solitante)

        n_TIPO_PARTICIPANTE := 0; -- Titular
        
        -- En este caso, el Sexo viene como un nodo, con lo que tendremos que obtener el siguiente nodo a <holder1Sexo> para ver el Sexo
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//holder1Sexo') > 0) THEN

            IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//holder1Sexo/*[1]') >  0) THEN

                n_ID_SEXO := CORRELACION_SEXO(IN_xmltype_SOLICITUD.EXTRACT('.//holder1Sexo/*[1]').getRootElement());

            END IF;

        END IF;

    ELSIF (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/holderShip/text()').getStringVal() = 'REPRESENTATIVE') THEN -- HolderShip = REPRESENTATIVE (Representante)

        n_TIPO_PARTICIPANTE := 1; -- Representante
        
        -- En este caso, el Sexo viene como un nodo, con lo que tendremos que obtener el siguiente nodo a <representative1Sexo> para ver el Sexo
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//representative1Sexo') >  0) THEN

            IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//representative1Sexo/*[1]') >  0) THEN

                n_ID_SEXO := CORRELACION_SEXO(IN_xmltype_SOLICITUD.EXTRACT('.//representative1Sexo/*[1]').getRootElement());

            END IF;

        END IF;

    END IF;

   
    IF (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal() = 1)       -- PersonType = 1 (DNI)
        OR (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal() = 2)   -- PersonType = 2 (CIF)
        OR (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal() = 3)   -- PersonType = 3 (NIE)
        OR (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal() = 4)   -- PersonType = 4 (Pasaporte)
        OR (xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal() = 5)   -- PersonType = 5 (Otros)
    THEN 
       
        v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/id/text()').getStringVal();
        v_NOMBRE := xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/name/text()').getStringVal();
        -- Tenemos que mirar su existe el Primer Apellido ya que si el Tipo de Documento es igual a 5 (Otros) no obtenemos este campo
        IF (xmltype_AUXILIAR.EXISTSNODE('persons/person[' || n_NumeroNodos || ']/ape1/text()') > 0) THEN
            v_APELLIDO1 := xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/ape1/text()').getStringVal();
        END IF;
        -- Tenemos que mirar su existe el Segundo Apellido ya que si el Tipo de Documento es igual a 5 (Otros) no obtenemos este campo
        IF (xmltype_AUXILIAR.EXISTSNODE('persons/person[' || n_NumeroNodos || ']/ape2/text()') > 0) THEN
            v_APELLIDO2 := xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/ape2/text()').getStringVal();
        END IF;
        n_ID_TIPO_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('persons/person[' || n_NumeroNodos || ']/personType/text()').getStringVal();

        -- Obtenemos el Identificador del Tercero a partir de la secuencia S_AB6135T00
        SELECT S_AB6135T00.NEXTVAL INTO n_ID_TERCERO FROM DUAL;  

        -- Almacenamos la informacin relacionada con el Tercero en la tabla AB6135T00
        INSERT INTO AB6135T00 (ID_TERCERO, DOCUMENTO, ID_TIPO_DOCUMENTO, NOMBRE, APELLIDO1, APELLIDO2, ID_SEXO, TIPO_PARTICIPANTE, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES(n_ID_TERCERO, v_DOCUMENTO, n_ID_TIPO_DOCUMENTO, v_NOMBRE, v_APELLIDO1, v_APELLIDO2, n_ID_SEXO, n_TIPO_PARTICIPANTE, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Tercero Almacenado (' || v_DOCUMENTO || ', Tipo Tercero: ' || n_ID_TIPO_TERCERO || ')';
        
        IF (n_TIPO_PARTICIPANTE = 1) THEN -- Si es Representante, actualizaremos el ID_REPRESENTANTE del Titular
        
            UPDATE AB6135T00 SET ID_REPRESENTANTE = n_ID_TERCERO WHERE ID_TERCERO = OUT_ID_TERCERO;
        
        END IF;

        -- Obtenemos los Canales de Aviso del Tercero
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/ApplicantInfo/notices/notice[addressee/addresseeID="' || v_DOCUMENTO || '"]') = 1) THEN

            xmltype_AUXILIAR_CanalesAviso:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfo/notices/notice[addressee/addresseeID="' || v_DOCUMENTO || '"]');

            n_NumeroNodos_CanalesAviso:= 1;

            WHILE xmltype_AUXILIAR_CanalesAviso.EXISTSNODE('notice[' || n_NumeroNodos_CanalesAviso || ']') = 1 LOOP

                IF (xmltype_AUXILIAR_CanalesAviso.EXTRACT('notice[' || n_NumeroNodos_CanalesAviso || ']/channel/channelType/text()').getStringVal() = 'EMAIL') THEN

                    n_ID_TIPO_CANAL_AVISO := 2; -- Correo electrnico
                    v_CANAL_AVISO := xmltype_AUXILIAR_CanalesAviso.EXTRACT('notice[' || n_NumeroNodos_CanalesAviso || ']/channel/channelInfo/emailAddress/text()').getStringVal();

                ELSIF (xmltype_AUXILIAR_CanalesAviso.EXTRACT('notice[' || n_NumeroNodos_CanalesAviso || ']/channel/channelType/text()').getStringVal() = 'SMS') THEN

                    n_ID_TIPO_CANAL_AVISO := 1; -- Telfono
                    v_CANAL_AVISO := xmltype_AUXILIAR_CanalesAviso.EXTRACT('notice[' || n_NumeroNodos_CanalesAviso || ']/channel/channelInfo/smsNumber/text()').getStringVal();

                END IF;

                 -- Obtenemos el Identificador del Canal de Aviso a partir de la secuencia S_AB6116T00
                SELECT S_AB6116T00.NEXTVAL INTO n_ID_CANAL_AVISO FROM DUAL;  

                INSERT INTO AB6116T00 (ID_CANAL_AVISO, ID_DATO_TERCERO, ID_TIPO_CANAL_AVISO, CANAL_AVISO, FECHA_REGISTRO, USUARIO_REGISTRO) 
                VALUES (n_ID_CANAL_AVISO, n_ID_TERCERO, n_ID_TIPO_CANAL_AVISO, v_CANAL_AVISO, SYSDATE, 'PL/SQL');

                OUT_TAREAS := OUT_TAREAS || chr(13) || '-Canal de Aviso Almacenado (' || v_CANAL_AVISO || ')';

                n_NumeroNodos_CanalesAviso := n_NumeroNodos_CanalesAviso + 1;

            END LOOP;

        END IF;
        
    END IF;

    -- Obtenemos el Identificador de la Relacin del Expediente con el Tercero / la Empresa a partir de la secuencia S_AB6103T00
    SELECT S_AB6134T00.NEXTVAL INTO n_ID_REL_EXP_TER FROM DUAL;  

    -- Almacenamos la informacin relacionada con la Relacin del Expediente con el Tercero / la Empresa en la tabla AB6103T00 
    INSERT INTO AB6134T00 (ID_REL_EXP_TER, ID_TERCERO, ID_TIPO_TERCERO, ID_EXPEDIENTE, PARTICIPANT_ID, FECHA_REGISTRO, USUARIO_REGISTRO) 
    VALUES (n_ID_REL_EXP_TER, n_ID_TERCERO, n_ID_TIPO_TERCERO, IN_ID_EXPEDIENTE, 0, SYSDATE, 'PL/SQL');

    IF (n_ID_TIPO_TERCERO = 1 AND n_TIPO_PARTICIPANTE = 0) THEN
        OUT_ID_TERCERO := n_ID_TERCERO;
    END IF;
   
    OUT_TAREAS := OUT_TAREAS || chr(13) || '-Relacin Expediente / Tercero Almacenada (Expediente:' || IN_ID_EXPEDIENTE || ' - Tercero:' || n_ID_TERCERO || ' )';

    n_ID_TERCERO := null;

    n_NumeroNodos := n_NumeroNodos + 1;

END LOOP;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;  

END ALMACENAR_TER_EMP_SOL_REP;

/