create or replace FUNCTION FORMATEAR_FECHA(IN_FECHA IN VARCHAR2, IN_IDIOMA IN VARCHAR2) RETURN DATE AS 

f_fecha DATE;

BEGIN

-- Fecha en Castellano (XX/XX/XXXX)
IF (IN_IDIOMA = 'es' OR IN_IDIOMA = 'ES') THEN

    IF (LENGTH(IN_FECHA) = 10) THEN

        f_fecha := TO_DATE(IN_FECHA,'dd/MM/yyyy');
    
    ELSIF (LENGTH(REPLACE(IN_FECHA, ' ', '')) = 18) THEN
    
        f_fecha := TO_DATE(IN_FECHA,'dd/MM/yyyy hh24:mi:ss');
    
    END IF;

-- Fecha en Euskera (XXXX/XX/XX)
ELSIF (IN_IDIOMA = 'eu' OR IN_IDIOMA = 'EU') THEN

    IF (LENGTH(IN_FECHA) = 10) THEN

        f_fecha := TO_DATE(IN_FECHA,'yyyy/MM/dd');
    
    ELSIF (LENGTH(REPLACE(IN_FECHA, ' ', '')) = 18) THEN
    
        f_fecha := TO_DATE(IN_FECHA,'yyyy/MM/dd hh24:mi:ss');
    
    END IF;

ELSE

    IF (LENGTH(IN_FECHA) = 10) THEN
    
        IF (INSTR(IN_FECHA, '/') = 3) THEN
            f_fecha := TO_DATE(IN_FECHA,'dd/MM/yyyy');
        ELSIF (INSTR(IN_FECHA, '/') = 5) THEN
            f_fecha := TO_DATE(IN_FECHA,'yyyy/MM/dd');
        END IF;
    
    ELSIF (LENGTH(REPLACE(IN_FECHA, ' ', '')) = 18) THEN
    
        IF (INSTR(IN_FECHA, '/') = 3) THEN
            f_fecha := TO_DATE(IN_FECHA,'dd/MM/yyyy hh24:mi:ss');
        ELSIF (INSTR(IN_FECHA, '/') = 5) THEN
            f_fecha := TO_DATE(IN_FECHA,'yyyy/MM/dd hh24:mi:ss');
        END IF;
    
    END IF;

END IF;

RETURN f_fecha;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END FORMATEAR_FECHA;

/