PROMPT Creacion de 	Tabla (AB6108T00)

CREATE TABLE AB6108T00
(
	ID_LISTADO           NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	NOMBRE               VARCHAR2(50 CHAR) NULL ,
	FICHERO              BLOB NULL ,
	NOMBRE_FICHERO       VARCHAR2(100 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6108T00 IS 'Tabla de Listados por Procedimiento';
COMMENT ON COLUMN AB6108T00.ID_LISTADO IS 'Identificador interno del Listado (secuencia)';
COMMENT ON COLUMN AB6108T00.NOMBRE IS 'Nombre del Listado';
COMMENT ON COLUMN AB6108T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6108T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6108T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6108T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';
COMMENT ON COLUMN AB6108T00.ID_PROCEDIMIENTO IS 'Identificador interno del Procedimiento';
COMMENT ON COLUMN AB6108T00.FICHERO IS 'Fichero Excel del Listado';
COMMENT ON COLUMN AB6108T00.NOMBRE_FICHERO IS 'Nombre del Fichero Excel del Listado';


CREATE SYNONYM LISTADOS	 FOR AB6108T00;


CREATE UNIQUE INDEX PK_AB6108T00 ON AB6108T00(ID_LISTADO   ASC);
ALTER TABLE AB6108T00	ADD CONSTRAINT  PK_AB6108T00 PRIMARY KEY (ID_LISTADO);


CREATE  INDEX FK_AB6108T00 ON AB6108T00(ID_PROCEDIMIENTO   ASC);
ALTER TABLE AB6108T00	ADD (CONSTRAINT FK_AB6101T00_AB6108T00 FOREIGN KEY (ID_PROCEDIMIENTO) REFERENCES AB6101T00 (ID_PROCEDIMIENTO));