PROMPT Creacion de 	Tabla (AB6143T00)

DROP TABLE AB6143T00;
CREATE TABLE AB6143T00
(
	ID_REL_EXP_INS       NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	ID_INSPECCION        NUMBER(8) NULL ,
	IDENTIFICADOR_INSPECCION VARCHAR2(20 CHAR) NULL ,
	TIPO_INSPECCION      NUMBER(1) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6143T00 IS 'Tabla de la Relacin del Expediente y la Inspeccin';
COMMENT ON COLUMN AB6143T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente (secuencia)';
COMMENT ON COLUMN AB6143T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6143T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6143T00.ID_INSPECCION IS 'Identificador interno de la Inspeccion';
COMMENT ON COLUMN AB6143T00.TIPO_INSPECCION IS 'Identificador del Tipo de Inspeccin:
1: Inspeccin de Estudio Tcnico (AB60)
2: Inspeccin de Justificacin (AB60)';
COMMENT ON COLUMN AB6143T00.ID_REL_EXP_INS IS 'Identificador interno de la Relacin del Expediente y la Inspeccin';
COMMENT ON COLUMN AB6143T00.IDENTIFICADOR_INSPECCION IS 'Identificador de la Inspeccin';


DROP SYNONYM REL_EXP_INS;
CREATE SYNONYM REL_EXP_INS	 FOR AB6143T00;

CREATE UNIQUE INDEX PK_AB6143T00 ON AB6143T00(ID_REL_EXP_INS   ASC)	TABLESPACE AB6102E00;

ALTER TABLE AB6143T00	ADD CONSTRAINT  PK_AB6143T00 PRIMARY KEY (ID_REL_EXP_INS);

CREATE  INDEX FK_AB6143T00 ON AB6143T00(ID_EXPEDIENTE   ASC)	TABLESPACE AB6102E00;

ALTER TABLE AB6143T00	ADD (CONSTRAINT FK_AB6102T00_AB6143T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));