PROMPT Creacion Tabla (AB6145T00)

DROP TABLE AB6145T00;
CREATE TABLE AB6145T00
(
	ID_FEC_COM_COM       NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE        NUMBER(8) NOT NULL ,
	FECHA_INICIO         DATE NULL ,
	FECHA_FIN            DATE NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6145T00 IS 'Tabla para almacenar las Fechas de Comuniacin de Comercio';
COMMENT ON COLUMN AB6145T00.ID_FEC_COM_COM IS 'Identificador interno de la Fecha de Comunicacin de Comercio';
COMMENT ON COLUMN AB6145T00.FECHA_INICIO IS 'Fecha de Inicio de la Comunicacin de Comercio';
COMMENT ON COLUMN AB6145T00.FECHA_FIN IS 'Fecha de Fin de la Comunicacin de Comercio';
COMMENT ON COLUMN AB6145T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6145T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6145T00.ID_EXPEDIENTE IS 'Identificador interno del Expediente';


DROP SYNONYM FEC_COM_COM;
CREATE SYNONYM FEC_COM_COM	 FOR AB6145T00;


CREATE UNIQUE INDEX PK_AB6145T00 ON AB6145T00(ID_FEC_COM_COM   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6145T00	ADD CONSTRAINT  PK_AB6145T00 PRIMARY KEY (ID_FEC_COM_COM);

CREATE  INDEX FK_AB6145T00 ON AB6145T00(ID_EXPEDIENTE   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6145T00	ADD (CONSTRAINT FK_AB6102T00_AB6145T00 FOREIGN KEY (ID_EXPEDIENTE) REFERENCES AB6102T00 (ID_EXPEDIENTE));