PROMPT Crear función OBTENER_DIRECCION

create or replace FUNCTION OBTENER_DIRECCION(IN_ID_DIRECCION IN AB61.AB6136T00.ID_DIRECCION%TYPE,
                                              IN_TIPO IN NUMBER
                                              ) RETURN VARCHAR2 AS 

--IN_TIPO=1   Formato para la descripción del informe municipal (0012807)                                            

v_DIRECCION                 AB61.AB6136T00.DIRECCION%TYPE;                       -- Dirección de la Empresa / Establecimiento
v_NUMERO                    AB61.AB6136T00.NUMERO%TYPE;                          -- Número de la Dirección de la Empresa / Establecimiento
v_ESCALERA                  AB61.AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Dirección de la Empresa / Establecimiento
v_PISO                      AB61.AB6136T00.PISO%TYPE;                            -- Piso de la Dirección de la Empresa / Establecimiento
v_LETRA                     AB61.AB6136T00.LETRA%TYPE;                           -- Letra de la Dirección de la Empresa / Establecimiento
v_CODIGO_POSTAL             AB61.AB6136T00.CODIGO_POSTAL%TYPE;                   -- Código Postal de la Dirección de la Empresa / Establecimiento
n_ID_PROVINCIA              AB61.AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Dirección de la Empresa / Establecimiento
n_ID_MUNICIPIO              AB61.AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Dirección de la Empresa / Establecimiento
n_ID_LOCALIDAD              AB61.AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Dirección de la Empresa / Establecimiento

v_PROVINCIA                 VARCHAR2(200); 
v_MUNICIPIO                 VARCHAR2(200);
v_LOCALIDAD                 VARCHAR2(200);
v_DESCRIPCION               VARCHAR2(1000);

BEGIN
  SELECT DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,
  PROVINCIAS.DS_O PROVINCIA, MUNICIPIOS.DS_O MUNICIPIO, LOCALIDADES.DS_O LOCALIDAD   
  INTO v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD,
  v_PROVINCIA, v_MUNICIPIO, v_LOCALIDAD
  FROM 
    AB61.AB6136T00, PROVINCIAS, MUNICIPIOS, LOCALIDADES  
  WHERE 
    ID_DIRECCION=IN_ID_DIRECCION
    AND ID_PROVINCIA=PROVINCIAS.ID (+) 
    AND ID_PROVINCIA=MUNICIPIOS.PROVINCIA_ID (+) 
    AND ID_MUNICIPIO=MUNICIPIOS.ID (+) 
    AND ID_PROVINCIA=LOCALIDADES.PROVINCIA_ID (+) 
    AND ID_MUNICIPIO=LOCALIDADES.MUNICIPIO_ID (+) 
    AND ID_LOCALIDAD=LOCALIDADES.ID (+);

  v_DESCRIPCION := null;

  CASE IN_TIPO    
    WHEN 1 THEN v_DESCRIPCION := ' ' ||v_DIRECCION || ' ' || v_NUMERO || ' ' || v_ESCALERA || ' ' || v_PISO || '' || v_LETRA || ' - ' || v_CODIGO_POSTAL  || ' (' || v_LOCALIDAD || ' )' ;
    ELSE v_DESCRIPCION :=  ' ' ||v_DIRECCION || ' ' || v_NUMERO || ' ' || v_ESCALERA || ' ' || v_PISO || '' || v_LETRA || ' - ' || v_CODIGO_POSTAL  || ' (' || v_LOCALIDAD || ' / ' || v_MUNICIPIO || ' / ' || v_PROVINCIA || ')' ;
  END CASE;
      
  RETURN v_DESCRIPCION;

END OBTENER_DIRECCION;

/

