PROMPT Crear vistas para el formulario de EMET

PROMPT Crear vista: V_T_EMET_TIPOLOGIA
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_TIPOLOGIA" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT 
  1 AS PARAMETRO,
  AB60.TIP_EMPRESA.ID_TIPO_EMPRESA AS VALOR,
  DESCRIPCION_CASTELLANO AS DESCRIPCION_CASTELLANO,
  DESCRIPCION_EUSKERA AS DESCRIPCION_EUSKERA
FROM 
  AB60.TIP_EMPRESA;
/

PROMPT Crear vista: V_T_DESC_EMPLEO
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_DESC_EMPLEO" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
    A.COD_PROCEDURE_ID AS PARAMETRO,
    --C.ID_DATO_EMPLEO AS VALOR,
    C.ID_AGRUPACION AS VALOR,
    C.DESCRIPCION_CASTELLANO,  
    C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6083T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA
  ORDER BY C.ID_DATO_EMPLEO;
/

PROMPT Crear vista: V_T_DESC_NIVEL1
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_DESC_NIVEL1" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  C.ID_AGRUPACION AS VALOR,
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Emprendimiento[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Competitividad[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  END DESCRIPCION_CASTELLANO,  
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Ekintzailetza[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Lehiakortasuna[_neg]: ' || C.DESCRIPCION_EUSKERA  
  END DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6006T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA  
    AND ID_ACT_SUB_PADRE IS NULL;
/

PROMPT Crear vista: V_T_EMET_ACTUACIONES
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_ACTUACIONES" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT
  C.ID_AGRUPACION AS PARAMETRO,
  C.ID_AGRUPACION AS VALOR,
  C.DESCRIPCION_CASTELLANO,  
  C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6006T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA      
    AND A.COD_PROCEDURE_ID='1010207';
/

PROMPT Crear vista: V_T_EMET_ACT24
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_ACT24" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
    --A.COD_PROCEDURE_ID AS PARAMETRO,
    C.ID_AGRUPACION AS PARAMETRO,
    1 AS VALOR,
    --C.ID_TIPO_GASTO AS VALVOR,
    C.DESCRIPCION_CASTELLANO,  
    C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6026T00 C, AB60.AB6006T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA
    AND B.ID_CONVOCATORIA=D.ID_CONVOCATORIA
    AND C.ID_ACT_SUB=D.ID_ACT_SUB
    AND D.ID_AGRUPACION=24
    AND A.COD_PROCEDURE_ID='1010207'   
  ORDER BY C.ID_TIPO_GASTO;
/

PROMPT Crear vista: V_T_EMET_ACT25
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_ACT25" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
    --A.COD_PROCEDURE_ID AS PARAMETRO,
    C.ID_AGRUPACION AS PARAMETRO,
    1 AS VALOR,
    --C.ID_TIPO_GASTO AS VALVOR,
    C.DESCRIPCION_CASTELLANO,  
    C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6026T00 C, AB60.AB6006T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA
    AND B.ID_CONVOCATORIA=D.ID_CONVOCATORIA
    AND C.ID_ACT_SUB=D.ID_ACT_SUB
    AND D.ID_AGRUPACION=25
    AND A.COD_PROCEDURE_ID='1010207'   
  ORDER BY C.ID_TIPO_GASTO;
/

PROMPT Crear vista: V_T_EMET_ACT26
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_ACT26" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
    --A.COD_PROCEDURE_ID AS PARAMETRO,
    C.ID_AGRUPACION AS PARAMETRO,
    1 AS VALOR,
    --C.ID_TIPO_GASTO AS VALVOR,
    C.DESCRIPCION_CASTELLANO,  
    C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6026T00 C, AB60.AB6006T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA
    AND B.ID_CONVOCATORIA=D.ID_CONVOCATORIA
    AND C.ID_ACT_SUB=D.ID_ACT_SUB
    AND D.ID_AGRUPACION=26
    AND A.COD_PROCEDURE_ID='1010207'   
  ORDER BY C.ID_TIPO_GASTO;    
/

PROMPT Crear vista: V_T_EMET_CRITERIO_10
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_CRITERIO_10" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  D.ID_AGRUPACION AS VALOR,
  D.DESCRIPCION_CASTELLANO,  
  D.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6003T00 C, AB60.AB6038T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA      
    AND C.ID_CRITERIO = D.ID_CRITERIO
    AND C.ID_AGRUPACION=10;
/

PROMPT Crear vista: V_T_EMET_CRITERIO_11
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_CRITERIO_11" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  D.ID_AGRUPACION AS VALOR,
  D.DESCRIPCION_CASTELLANO,  
  D.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6003T00 C, AB60.AB6038T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA      
    AND C.ID_CRITERIO = D.ID_CRITERIO
    AND C.ID_AGRUPACION=11;
/

PROMPT Crear vista: V_T_EMET_CRITERIO_21
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_CRITERIO_21" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  D.ID_AGRUPACION AS VALOR,
  D.DESCRIPCION_CASTELLANO,  
  D.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6003T00 C, AB60.AB6038T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA      
    AND C.ID_CRITERIO = D.ID_CRITERIO
    AND C.ID_AGRUPACION=21;
/

PROMPT Crear vista: V_T_EMET_CRITERIO_23
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_EMET_CRITERIO_23" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  D.ID_AGRUPACION AS VALOR,
  D.DESCRIPCION_CASTELLANO,  
  D.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6003T00 C, AB60.AB6038T00 D
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA      
    AND C.ID_CRITERIO = D.ID_CRITERIO
    AND C.ID_AGRUPACION=23;
/

