PROMPT Crear vistas para el formulario de PTT

PROMPT Crear vista: V_T_PTT_NIVEL1_11
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_PTT_NIVEL1_11" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  C.ID_AGRUPACION AS VALOR,
  --1 AS VALOR,
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Emprendimiento[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Competitividad[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=11 THEN '[neg_]Proyectos territoriales turísticos[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=12 THEN '[neg_]Mejora de la competitividad[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  END DESCRIPCION_CASTELLANO,  
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Ekintzailetza[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Lehiakortasuna[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=11 THEN '[neg_]Lurralde-proiektu turistikoak[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=12 THEN '[neg_]Lehiakortasuna hobetu[_neg]: ' || C.DESCRIPCION_EUSKERA  
  END DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6006T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA  
    AND ID_ACT_SUB_PADRE IS NULL
    AND C.ID_AGRUPACION=11;
/

PROMPT Crear vista: V_T_PTT_NIVEL1_12
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_PTT_NIVEL1_12" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  C.ID_AGRUPACION AS VALOR,
  --1 AS VALOR,
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Emprendimiento[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Competitividad[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=11 THEN '[neg_]Proyectos territoriales turísticos[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  WHEN C.ID_AGRUPACION=12 THEN '[neg_]Mejora de la competitividad[_neg]: ' || C.DESCRIPCION_CASTELLANO  
  END DESCRIPCION_CASTELLANO,  
  CASE 
  WHEN C.ID_AGRUPACION=22 THEN '[neg_]Ekintzailetza[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=23 THEN '[neg_]Lehiakortasuna[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=11 THEN '[neg_]Lurralde-proiektu turistikoak[_neg]: ' || C.DESCRIPCION_EUSKERA  
  WHEN C.ID_AGRUPACION=12 THEN '[neg_]Lehiakortasuna hobetu[_neg]: ' || C.DESCRIPCION_EUSKERA  
  END DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6006T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA  
    AND ID_ACT_SUB_PADRE IS NULL
    AND C.ID_AGRUPACION=12;
/

PROMPT Crear vista: V_T_PTT_AMBITO
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_PTT_AMBITO" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
    1 AS PARAMETRO,       
    ID_AMBITO_TERRITORIAL AS VALOR,
    DESCRIPCION_CASTELLANO,
    DESCRIPCION_EUSKERA    
  FROM 
    AB60.AB6039T00
  ORDER BY ID_AMBITO_TERRITORIAL;
/

PROMPT Crear vista: V_T_PTT_NIVEL2
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_PTT_NIVEL2" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
  --A.COD_PROCEDURE_ID AS PARAMETRO,
  C.ID_AGRUPACION AS PARAMETRO,
  C.ID_AGRUPACION AS VALOR,
  --1 AS VALOR,
  C.DESCRIPCION_CASTELLANO,  
  C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6006T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA  
    AND ID_ACT_SUB_PADRE IS NOT NULL
    AND A.COD_PROCEDURE_ID='1020606';
/

PROMPT Crear vista: V_T_PTT_PRODUCTOS
CREATE OR REPLACE FORCE EDITIONABLE VIEW "AB61"."V_T_PTT_PRODUCTOS" ("PARAMETRO", "VALOR", "DESCRIPCION_CASTELLANO", "DESCRIPCION_EUSKERA") AS 
  SELECT
  A.COD_PROCEDURE_ID AS PARAMETRO,
  C.ID_PRODUCTO_TURISTICO AS VALOR,
  C.DESCRIPCION_CASTELLANO,  
  C.DESCRIPCION_EUSKERA
  FROM 
    AB61.AB6101T00 A, AB60.AB6001T00 B, AB60.AB6045T00 C
  WHERE 
    A.ID_PROCEDIMIENTO=B.ID_PROCEDIMIENTO
    AND B.ID_CONVOCATORIA=C.ID_CONVOCATORIA  
  ORDER BY C.ID_PRODUCTO_TURISTICO;
/

commit;

