PROMPT Procedimiento (ALMACENAR_TITULO_EXP)

create or replace PROCEDURE ALMACENAR_PASO1_TOOLKIT (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB6102T00.ID_EXPEDIENTE%TYPE,
                                                       OUT_ID_TERCERO IN OUT AB6135T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_ID_REL_EXP_TER            AB6134T00.ID_REL_EXP_TER%TYPE;         -- Identificador de la Relacin del Expediente con el Tercero / la Empresa

n_ID_TERCERO                AB6135T00.ID_TERCERO%TYPE;             -- Identificador del Tercero
n_ID_TERCERO_REPRE          AB6135T00.ID_TERCERO%TYPE;             -- Identificador del Tercero del representante
v_DOCUMENTO                 AB6135T00.DOCUMENTO%TYPE;              -- DNI, NIF o Pasaporte del tercero
v_NOMBRE                    AB6135T00.NOMBRE%TYPE;                 -- Nombre del Tercero
v_APELLIDO1                 AB6135T00.APELLIDO1%TYPE;              -- Primer Apellido del Tercero
v_APELLIDO2                 AB6135T00.APELLIDO2%TYPE;              -- Segundo Apellido del Tercero
n_TIPO_PARTICIPANTE         AB6135T00.TIPO_PARTICIPANTE%TYPE;
n_IDIOMA         			      AB6135T00.IDIOMA %TYPE;

n_ID_TIPO_TERCERO           AB6106T00.ID_TIPO_TERCERO%TYPE;        -- Identificador de Tipo de Tercero / Empresa

n_ID_TIPO_DOCUMENTO         AB6107T00.ID_TIPO_DOCUMENTO%TYPE;      -- Identificador de Tipo de Documento

n_ID_SEXO                   AB6120T00.ID_SEXO%TYPE;                -- Identificador del Sexo

n_ID_TIPO_CANAL_AVISO       AB6115T00.ID_TIPO_CANAL_AVISO%TYPE;    -- Identificador de Tipo de Canal de Aviso

n_ID_CANAL_AVISO            AB6116T00.ID_CANAL_AVISO%TYPE;         -- Identificador del Canal de Aviso
v_CANAL_AVISO               AB6116T00.CANAL_AVISO%TYPE;            -- Descripcin del Canal de Aviso

n_ID_DIRECCION              AB6136T00.ID_DIRECCION%TYPE;
v_DIRECCION                 AB6136T00.DIRECCION%TYPE;                       -- Direccin del Titular
v_NUMERO                    AB6136T00.NUMERO%TYPE;                          -- Nmero de la Direccin del Titular
v_ESCALERA                  AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Direccin del Titular
v_PISO                      AB6136T00.PISO%TYPE;                            -- Piso de la Direccin del Titular
v_LETRA                     AB6136T00.LETRA%TYPE;                           -- Letra de la Direccin del Titular
v_CODIGO_POSTAL             AB6136T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin del Titular
n_ID_PROVINCIA              AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin del Titular
n_ID_MUNICIPIO              AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin del Titular
n_ID_LOCALIDAD              AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin del Titular
v_DESCRIPCION_CIUDAD        AB6136T00.DESCRIPCION_CIUDAD%TYPE;              -- Descripcin de la Ciudad, para cuando la ciudad no est en NORA
v_DESCRIPCION_PROVINCIA	    AB6136T00.DESCRIPCION_PROVINCIA%TYPE;           -- Descripcin de la Provincia para cuando la ciudad no est en NORA
n_ID_PAIS	                  AB6136T00.ID_PAIS%TYPE;	                        -- Identificador del Pas

n_TEXTO           varchar2(500);
n_TXT_PAIS        varchar2(500);
n_TXT_PROVINCIA   varchar2(500);
n_TXT_MUNICIPIO   varchar2(500);
n_TXT_LOCALIDAD   varchar2(500);

xmltype_AUXILIAR XMLTYPE;           	  -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
n_NumeroNodos NUMBER;               	  -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
xmltype_AUXILIAR_CanalesAviso XMLTYPE;  -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud para los Canales de Aviso
n_NumeroNodos_CanalesAviso NUMBER;      -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar para los Canales de Aviso

BEGIN

n_ID_TIPO_TERCERO:= 1; -- SOLICITANTE
n_ID_TERCERO_REPRE := null;

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ApplicantInfoRRI') > 0) THEN
  xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI');

  -- REPRESENTANTE: representativeRRI
  IF (xmltype_AUXILIAR.EXISTSNODE('.//representativeRRI') > 0) THEN

    xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI/representativeRRI');

    v_DOCUMENTO := null;
    n_ID_TIPO_DOCUMENTO := null;
    v_NOMBRE := null;
    v_APELLIDO1 := null;
    v_APELLIDO2 := null;
    n_ID_SEXO := null;
    n_TIPO_PARTICIPANTE := 1; -- Representante

    IF (xmltype_AUXILIAR.EXISTSNODE('.//ID/text()') > 0) THEN
      v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('.//ID/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//personType/text()') > 0) THEN
      n_ID_TIPO_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('.//personType/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//name/text()') > 0) THEN
      v_NOMBRE := xmltype_AUXILIAR.EXTRACT('.//name/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//ape1/text()') > 0) THEN
      v_APELLIDO1 := xmltype_AUXILIAR.EXTRACT('.//ape1/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//ape2/text()') > 0) THEN
      v_APELLIDO2 := xmltype_AUXILIAR.EXTRACT('.//ape2/text()').getStringVal();
    END IF;
    IF (xmltype_AUXILIAR.EXISTSNODE('.//sexo/text()') > 0) THEN
      IF xmltype_AUXILIAR.EXTRACT('.//sexo/text()').getStringVal() = 'HOMBRE' THEN
        n_ID_SEXO := 1;
      END IF;
      IF xmltype_AUXILIAR.EXTRACT('.//sexo/text()').getStringVal() = 'MUJER' THEN
        n_ID_SEXO := 2;
      END IF;
    END IF;

    IF (xmltype_AUXILIAR.EXISTSNODE('.//language/text()') > 0) THEN
      IF ((xmltype_AUXILIAR.EXTRACT('.//language/text()').getStringVal() = 'es')
      OR (xmltype_AUXILIAR.EXTRACT('.//language/text()').getStringVal() = 'ES')) THEN
        n_IDIOMA := 0; -- Castellano
      ELSIF ((xmltype_AUXILIAR.EXTRACT('.//language/text()').getStringVal() = 'eu')
      OR (xmltype_AUXILIAR.EXTRACT('.//language/text()').getStringVal() = 'EU')) THEN
        n_IDIOMA := 1; -- Euskera
      END IF;
    END IF;

    -- Obtenemos el Identificador del Tercero a partir de la secuencia S_AB6135T00
    SELECT S_AB6135T00.NEXTVAL INTO n_ID_TERCERO_REPRE FROM DUAL;

    -- Almacenamos la informacin relacionada con el Tercero en la tabla AB6135T00
    INSERT INTO AB6135T00 (ID_TERCERO, DOCUMENTO, ID_TIPO_DOCUMENTO, NOMBRE, APELLIDO1, APELLIDO2, ID_SEXO, IDIOMA, TIPO_PARTICIPANTE, ID_REPRESENTANTE, FECHA_REGISTRO, USUARIO_REGISTRO)
    VALUES(n_ID_TERCERO_REPRE, v_DOCUMENTO, n_ID_TIPO_DOCUMENTO, v_NOMBRE, v_APELLIDO1, v_APELLIDO2, n_ID_SEXO, n_IDIOMA, n_TIPO_PARTICIPANTE, NULL, SYSDATE, 'PL/SQL');

    OUT_TAREAS := OUT_TAREAS || chr(13) || '-Tercero Almacenado (' || v_DOCUMENTO || ', Tipo Tercero: ' || n_ID_TIPO_TERCERO || ')';

    -- Obtenemos el Identificador de la Relacin del Expediente con el Tercero / la Empresa a partir de la secuencia S_AB6134T00
    SELECT S_AB6134T00.NEXTVAL INTO n_ID_REL_EXP_TER FROM DUAL;

    -- Almacenamos la informacin relacionada con la Relacin del Expediente con el Tercero / la Empresa en la tabla AB6103T00
    INSERT INTO AB6134T00 (ID_REL_EXP_TER, ID_TERCERO, ID_TIPO_TERCERO, ID_EXPEDIENTE, PARTICIPANT_ID, FECHA_REGISTRO, USUARIO_REGISTRO)
    VALUES (n_ID_REL_EXP_TER, n_ID_TERCERO_REPRE, n_ID_TIPO_TERCERO, IN_ID_EXPEDIENTE, 0, SYSDATE, 'PL/SQL');

    OUT_TAREAS := OUT_TAREAS || chr(13) || '-Relacin Expediente / Tercero Almacenada (Expediente:' || IN_ID_EXPEDIENTE || ' - Tercero:' || n_ID_TERCERO || ' )';

    -- Canales de aviso
    n_NumeroNodos_CanalesAviso := 1;
    WHILE xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']') = 1 LOOP

      -- Obtenemos los Canales de Aviso del Tercero
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()') > 0) THEN

        IF (xmltype_AUXILIAR.EXTRACT('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()').getStringVal() = 'EMAIL') THEN
            n_ID_TIPO_CANAL_AVISO := 2; -- Correo electrnico
            v_CANAL_AVISO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/value/emailAddress/text()').getStringVal();
        ELSIF (xmltype_AUXILIAR.EXTRACT('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()').getStringVal() = 'SMS') THEN
            n_ID_TIPO_CANAL_AVISO := 1; -- Telfono
            v_CANAL_AVISO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/value/smsNumber/text()').getStringVal();
        END IF;
         -- Obtenemos el Identificador del Canal de Aviso a partir de la secuencia S_AB6116T00
        SELECT S_AB6116T00.NEXTVAL INTO n_ID_CANAL_AVISO FROM DUAL;

        INSERT INTO AB6116T00 (ID_CANAL_AVISO, ID_DATO_TERCERO, ID_TIPO_CANAL_AVISO, CANAL_AVISO, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES (n_ID_CANAL_AVISO, n_ID_TERCERO_REPRE, n_ID_TIPO_CANAL_AVISO, v_CANAL_AVISO, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Canal de Aviso Almacenado (' || v_CANAL_AVISO || ')';

      END IF;
      n_NumeroNodos_CanalesAviso := n_NumeroNodos_CanalesAviso + 1;
    END LOOP;

    -- Canal comunicacin
    IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress') = 1) THEN
      -- Canal postal
      
      n_ID_PAIS := null;
      n_TXT_PAIS := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/pais/text()') > 0) THEN
        n_TXT_PAIS := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/pais/text()').getStringVal();
        IF INSTR(n_TXT_PAIS, '(') = 1 THEN
          n_ID_PAIS := SUBSTR( n_TXT_PAIS, 2, INSTR(n_TXT_PAIS, ')')-2);
        END IF;
      END IF;
      v_DIRECCION := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/direccion/text()') > 0) THEN
        v_DIRECCION := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/direccion/text()').getStringVal();
      END IF;

      n_ID_LOCALIDAD := null;
      n_TXT_LOCALIDAD := null;
      v_DESCRIPCION_CIUDAD := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/localidad/text()') > 0) THEN
        n_TXT_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/localidad/text()').getStringVal();
        IF INSTR(n_TXT_LOCALIDAD, '(') = 1 THEN
          n_ID_LOCALIDAD := SUBSTR( n_TXT_LOCALIDAD, 2, INSTR(n_TXT_LOCALIDAD, ')')-2);
        ELSE
          v_DESCRIPCION_CIUDAD := n_TXT_LOCALIDAD;
        END IF;
      END IF;

      n_ID_MUNICIPIO := null;
      n_TXT_MUNICIPIO := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/municipio/text()') > 0) THEN
        n_TXT_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/municipio/text()').getStringVal();
        IF INSTR(n_TXT_MUNICIPIO, '(') = 1 THEN
          n_ID_MUNICIPIO := SUBSTR( n_TXT_MUNICIPIO, 2, INSTR(n_TXT_MUNICIPIO, ')')-2);
        END IF;
      END IF;

      n_ID_PROVINCIA := null;
      n_TXT_PROVINCIA := null;
      v_DESCRIPCION_PROVINCIA := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/provincia/text()') > 0) THEN
        n_TXT_PROVINCIA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/provincia[language[@locale="es"]]/text()').getStringVal();
        IF INSTR(n_TXT_PROVINCIA, '(') = 1 THEN
          n_ID_PROVINCIA := SUBSTR( n_TXT_PROVINCIA, 2, INSTR(n_TXT_PROVINCIA, ')')-2);
        ELSE
          v_DESCRIPCION_PROVINCIA := n_TXT_PROVINCIA;
        END IF;
      END IF;

      v_NUMERO := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/portal/text()') > 0) THEN
        v_NUMERO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/portal/text()').getStringVal();
      END IF;
      v_ESCALERA := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/escalera/text()') > 0) THEN
        v_ESCALERA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/escalera/text()').getStringVal();
      END IF;
      v_PISO := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/piso/text()') > 0) THEN
        v_PISO := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/piso/text()').getStringVal();
      END IF;
      v_LETRA := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/letra/text()') > 0) THEN
        v_LETRA := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/letra/text()').getStringVal();
      END IF;
      v_CODIGO_POSTAL := null;
      IF (xmltype_AUXILIAR.EXISTSNODE('representativeRRI/account/channel/channelInfo/postalAddress/cp/text()') > 0) THEN
        v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('representativeRRI/account/channel/channelInfo/postalAddress/cp/text()').getStringVal();
      END IF;

      -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
      SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

      -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
      INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO, DESCRIPCION_CIUDAD, DESCRIPCION_PROVINCIA, ID_PAIS)
      VALUES(n_ID_DIRECCION, n_ID_TERCERO_REPRE, 4, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'PL/SQL', v_DESCRIPCION_CIUDAD, v_DESCRIPCION_PROVINCIA, n_ID_PAIS);

      OUT_TAREAS := OUT_TAREAS || chr(13) || '-Direccin canal postal ([' || n_ID_DIRECCION || '] Direccin: ' || v_DIRECCION || ')';


    END IF;

  END IF;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//interestedListRRI') > 0) THEN
    -- TITULAR: interestedListRRI

    n_NumeroNodos:= 1;

    xmltype_AUXILIAR:= IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/ApplicantInfoRRI/interestedListRRI');

    -- Obtenemos el nodo <body><ApplicantInfo><persons> para obtener el Solitante y/o representante
    WHILE xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']') = 1 LOOP
      v_DOCUMENTO := null;
      n_ID_TIPO_DOCUMENTO := null;
      v_NOMBRE := null;
      v_APELLIDO1 := null;
      v_APELLIDO2 := null;
      n_ID_SEXO := null;
      n_TIPO_PARTICIPANTE := 0; -- Titular
      n_IDIOMA := null;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ID/text()') > 0) THEN
        v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ID/text()').getStringVal();
      END IF;
      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/personType/text()') > 0) THEN
        n_ID_TIPO_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/personType/text()').getStringVal();
      END IF;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/name/text()') > 0) THEN
        v_NOMBRE := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/name/text()').getStringVal();
      END IF;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ape1/text()') > 0) THEN
        v_APELLIDO1 := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ape1/text()').getStringVal();
      END IF;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ape2/text()') > 0) THEN
        v_APELLIDO2 := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/ape2/text()').getStringVal();
      END IF;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/sexo/text()') > 0) THEN
        IF xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/sexo/text()').getStringVal() = 'HOMBRE' THEN
          n_ID_SEXO := 1;
        END IF;
        IF xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/sexo/text()').getStringVal() = 'MUJER' THEN
          n_ID_SEXO := 2;
        END IF;
      END IF;

      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/language/text()') > 0) THEN
        IF ((xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/language/text()').getStringVal() = 'es')
        OR (xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/language/text()').getStringVal() = 'ES')) THEN
          n_IDIOMA := 0; -- Castellano
        ELSIF ((xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/language/text()').getStringVal() = 'eu')
        OR (xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/language/text()').getStringVal() = 'EU')) THEN
          n_IDIOMA := 1; -- Euskera
        END IF;
      END IF;

      -- Obtenemos el Identificador del Tercero a partir de la secuencia S_AB6135T00
      SELECT S_AB6135T00.NEXTVAL INTO n_ID_TERCERO FROM DUAL;

      -- Almacenamos la informacin relacionada con el Tercero en la tabla AB6135T00
      INSERT INTO AB6135T00 (ID_TERCERO, DOCUMENTO, ID_TIPO_DOCUMENTO, NOMBRE, APELLIDO1, APELLIDO2, ID_SEXO, IDIOMA, TIPO_PARTICIPANTE, ID_REPRESENTANTE, FECHA_REGISTRO, USUARIO_REGISTRO)
      VALUES(n_ID_TERCERO, v_DOCUMENTO, n_ID_TIPO_DOCUMENTO, v_NOMBRE, v_APELLIDO1, v_APELLIDO2, n_ID_SEXO, n_IDIOMA, n_TIPO_PARTICIPANTE, n_ID_TERCERO_REPRE, SYSDATE, 'PL/SQL');

      OUT_TAREAS := OUT_TAREAS || chr(13) || '-Tercero Almacenado (' || v_DOCUMENTO || ', Tipo Tercero: ' || n_ID_TIPO_TERCERO || ')';

      -- Obtenemos el Identificador de la Relacin del Expediente con el Tercero / la Empresa a partir de la secuencia S_AB6134T00
      SELECT S_AB6134T00.NEXTVAL INTO n_ID_REL_EXP_TER FROM DUAL;

      -- Almacenamos la informacin relacionada con la Relacin del Expediente con el Tercero / la Empresa en la tabla AB6103T00
      INSERT INTO AB6134T00 (ID_REL_EXP_TER, ID_TERCERO, ID_TIPO_TERCERO, ID_EXPEDIENTE, PARTICIPANT_ID, FECHA_REGISTRO, USUARIO_REGISTRO)
      VALUES (n_ID_REL_EXP_TER, n_ID_TERCERO, n_ID_TIPO_TERCERO, IN_ID_EXPEDIENTE, 0, SYSDATE, 'PL/SQL');

      OUT_TAREAS := OUT_TAREAS || chr(13) || '-Relacin Expediente / Tercero Almacenada (Expediente:' || IN_ID_EXPEDIENTE || ' - Tercero:' || n_ID_TERCERO || ' )';

      -- El tercero que se devuelve es el del titular. Solo hay un titular.
      OUT_ID_TERCERO := n_ID_TERCERO;


      n_NumeroNodos_CanalesAviso := 1;

      WHILE xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']') = 1 LOOP

        -- Obtenemos los Canales de Aviso del Tercero
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()') > 0) THEN

          IF (xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()').getStringVal() = 'EMAIL') THEN
              n_ID_TIPO_CANAL_AVISO := 2; -- Correo electrnico
              v_CANAL_AVISO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/value/emailAddress/text()').getStringVal();
          ELSIF (xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/type/text()').getStringVal() = 'SMS') THEN
              n_ID_TIPO_CANAL_AVISO := 1; -- Telfono
              v_CANAL_AVISO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/contactList/contact[' || n_NumeroNodos_CanalesAviso || ']/value/smsNumber/text()').getStringVal();
          END IF;
           -- Obtenemos el Identificador del Canal de Aviso a partir de la secuencia S_AB6116T00
          SELECT S_AB6116T00.NEXTVAL INTO n_ID_CANAL_AVISO FROM DUAL;

          INSERT INTO AB6116T00 (ID_CANAL_AVISO, ID_DATO_TERCERO, ID_TIPO_CANAL_AVISO, CANAL_AVISO, FECHA_REGISTRO, USUARIO_REGISTRO)
          VALUES (n_ID_CANAL_AVISO, n_ID_TERCERO, n_ID_TIPO_CANAL_AVISO, v_CANAL_AVISO, SYSDATE, 'PL/SQL');

          OUT_TAREAS := OUT_TAREAS || chr(13) || '-Canal de Aviso Almacenado (' || v_CANAL_AVISO || ')';

        END IF;

        n_NumeroNodos_CanalesAviso := n_NumeroNodos_CanalesAviso + 1;

      END LOOP;

      -- Canal comunicacin
      IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress') = 1) THEN
        -- Canal postal
                        
        n_ID_PAIS := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/pais/text()') > 0) THEN
          n_TXT_PAIS := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/pais/text()').getStringVal();
          IF INSTR(n_TXT_PAIS, '(') = 1 THEN
            n_ID_PAIS := SUBSTR( n_TXT_PAIS, 2, INSTR(n_TXT_PAIS, ')')-2);
          END IF;
        END IF;

        v_DIRECCION := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/direccion/text()') > 0) THEN
          v_DIRECCION := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/direccion/text()').getStringVal();
        END IF;

        n_ID_LOCALIDAD := null;
        n_TXT_LOCALIDAD := null;
        v_DESCRIPCION_CIUDAD := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/localidad/text()') > 0) THEN
          n_TXT_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/localidad/text()').getStringVal();
          IF INSTR(n_TXT_LOCALIDAD, '(') = 1 THEN
            n_ID_LOCALIDAD := SUBSTR( n_TXT_LOCALIDAD, 2, INSTR(n_TXT_LOCALIDAD, ')')-2);
          ELSE
            v_DESCRIPCION_CIUDAD := n_TXT_LOCALIDAD;
          END IF;
        END IF;

        n_ID_MUNICIPIO := null;
        n_TXT_MUNICIPIO := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/municipio/text()') > 0) THEN
          n_TXT_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/municipio/text()').getStringVal();
          IF INSTR(n_TXT_MUNICIPIO, '(') = 1 THEN
            n_ID_MUNICIPIO := SUBSTR( n_TXT_MUNICIPIO, 2, INSTR(n_TXT_MUNICIPIO, ')')-2);
          END IF;
        END IF;

        n_ID_PROVINCIA := null;
        n_TXT_PROVINCIA := null;
        v_DESCRIPCION_PROVINCIA := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/provincia/language[@locale="es"]/text()') > 0) THEN
          n_TXT_PROVINCIA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/provincia/language[@locale="es"]/text()').getStringVal();
          IF INSTR(n_TXT_PROVINCIA, '(') = 1 THEN
            n_ID_PROVINCIA := SUBSTR( n_TXT_PROVINCIA, 2, INSTR(n_TXT_PROVINCIA, ')')-2);
          ELSE
            v_DESCRIPCION_PROVINCIA := n_TXT_PROVINCIA;
          END IF;
        END IF;

        v_NUMERO := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/portal/text()') > 0) THEN
          v_NUMERO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/portal/text()').getStringVal();
        END IF;
        v_ESCALERA := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/escalera/text()') > 0) THEN
          v_ESCALERA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/escalera/text()').getStringVal();
        END IF;
        v_PISO := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/piso/text()') > 0) THEN
          v_PISO := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/piso/text()').getStringVal();
        END IF;
        v_LETRA := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/letra/text()') > 0) THEN
          v_LETRA := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/letra/text()').getStringVal();
        END IF;
        v_CODIGO_POSTAL := null;
        IF (xmltype_AUXILIAR.EXISTSNODE('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/cp/text()') > 0) THEN
          v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('interestedListRRI/interestedRRI[' || n_NumeroNodos || ']/account/channel/channelInfo/postalAddress/cp/text()').getStringVal();
        END IF;

        -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
        SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

        -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
        INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO, DESCRIPCION_CIUDAD, DESCRIPCION_PROVINCIA, ID_PAIS)
        VALUES(n_ID_DIRECCION, n_ID_TERCERO, 4, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'PL/SQL', v_DESCRIPCION_CIUDAD, v_DESCRIPCION_PROVINCIA, n_ID_PAIS);
        
        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Direccin canal postal ([' || n_ID_DIRECCION || '] Direccin: ' || v_DIRECCION || ')';

      END IF;

      n_NumeroNodos := n_NumeroNodos + 1;

    END LOOP;

  END IF;

END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_PASO1_TOOLKIT;

/
