PROMPT Procedimiento (ALMACENAR_PERSONA_CONTACTO)

create or replace PROCEDURE ALMACENAR_PERSONA_CONTACTO (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB6102T00.ID_EXPEDIENTE%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_ID_REL_EXP_TER        AB6134T00.ID_REL_EXP_TER%TYPE;              -- Identificador de la RelaciÃƒÂ³n del Expediente con el Tercero / la Empresa

n_ID_TERCERO                AB6135T00.ID_TERCERO%TYPE;                      -- Identificador del Tercero
v_NOMBRE                    AB6135T00.NOMBRE%TYPE;                          -- Nombre del Tercero
v_APELLIDO1                 AB6135T00.APELLIDO1%TYPE;                       -- Primer Apellido del Tercero
v_APELLIDO2                 AB6135T00.APELLIDO2%TYPE;                       -- Segundo Apellido del Tercero
n_TELEFONO                  AB6135T00.TELEFONO%TYPE;                        -- TelÃƒÂ©fono del Tercero
v_EMAIL                     AB6135T00.EMAIL%TYPE;                           -- Email del Tercero

n_ID_TIPO_TERCERO           AB6106T00.ID_TIPO_TERCERO%TYPE;                 -- Identificador de Tipo de Tercero / Empresa

n_ID_SEXO                   AB6120T00.ID_SEXO%TYPE;                         -- Identificador del Sexo

xmltype_AUXILIAR XMLTYPE;           -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
n_NumeroNodos NUMBER;               -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar

BEGIN

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoRepeticionContacto') >  0) THEN

    xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('.//grupoRepeticionContacto');

    n_NumeroNodos := 1;

    WHILE xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']') = 1 LOOP

        n_ID_TERCERO := null;
        v_NOMBRE := null;
        v_APELLIDO1 := null;
        v_APELLIDO2 := null;
        v_EMAIL := null;
        n_TELEFONO := null;
        n_ID_SEXO := null;

        v_NOMBRE := xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoNombre/text()').getStringVal();
        v_APELLIDO1 := xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoApellido1/text()').getStringVal();
        IF (xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoApellido2/text()') >  0) THEN
            v_APELLIDO2 := xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoApellido2/text()').getStringVal();
        END IF;
        v_EMAIL := xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoEmail/text()').getStringVal();
        n_TELEFONO := xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoTlf/text()').getStringVal();
        n_ID_TIPO_TERCERO := 2; -- Persona de Contacto

        n_ID_SEXO := CORRELACION_SEXO(xmltype_AUXILIAR.EXTRACT('grupoRepeticionContacto/elementoGR[' || n_NumeroNodos || ']/contactoSexo/text()').getStringVal());

        -- Obtenemos el Identificador del Tercero a partir de la secuencia S_AB6104T00
        SELECT S_AB6135T00.NEXTVAL INTO n_ID_TERCERO FROM DUAL;

        -- Almacenamos la informaciÃƒÂ³n relacionada con el Tercero (Persona de Contacto) en la tabla AB6104T00
        INSERT INTO AB6135T00 (ID_TERCERO, NOMBRE, APELLIDO1, APELLIDO2, ID_SEXO, TELEFONO, EMAIL, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES(n_ID_TERCERO, v_NOMBRE, v_APELLIDO1, v_APELLIDO2, n_ID_SEXO, n_TELEFONO , v_EMAIL, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Persona de Contacto Almacenada (' || v_NOMBRE || ')';

        -- Obtenemos el Identificador de la RelaciÃƒÂ³n del Expediente con el Tercero a partir de la secuencia S_AB6103T00
        SELECT S_AB6134T00.NEXTVAL INTO n_ID_REL_EXP_TER FROM DUAL;

        -- Almacenamos la informaciÃƒÂ³n relacionada con la RelaciÃƒÂ³n del Expediente con el Tercero (Persona de Contacto) en la tabla AB6103T00
        INSERT INTO AB6134T00 (ID_REL_EXP_TER, ID_TERCERO, ID_TIPO_TERCERO, ID_EXPEDIENTE, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES (n_ID_REL_EXP_TER, n_ID_TERCERO, n_ID_TIPO_TERCERO, IN_ID_EXPEDIENTE, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-RelaciÃƒÂ³n Expediente / Persona de Contacto (Tercero) Almacenada (Expediente:' || IN_ID_EXPEDIENTE || ' - Tercero:' || n_ID_TERCERO || ' )';

        n_NumeroNodos :=  n_NumeroNodos + 1;

    END LOOP;

END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_PERSONA_CONTACTO;

/
