PROMPT Procedimiento (ALMACENAR_REPRESENTANTE_LEGAL)

create or replace PROCEDURE ALMACENAR_REPRESENTANTE_LEGAL(IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB6102T00.ID_EXPEDIENTE%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_ID_REL_EXP_TER            AB6134T00.ID_REL_EXP_TER%TYPE;              -- Identificador de la Relación del Expediente con el Tercero / la Empresa

n_ID_TERCERO                AB6135T00.ID_TERCERO%TYPE;                      -- Identificador del Tercero
v_DOCUMENTO                 AB6135T00.DOCUMENTO%TYPE;                       -- DNI, NIF o Pasaporte del tercero
v_NOMBRE                    AB6135T00.NOMBRE%TYPE;                          -- Nombre del Tercero
v_APELLIDO1                 AB6135T00.APELLIDO1%TYPE;                       -- Primer Apellido del Tercero
v_APELLIDO2                 AB6135T00.APELLIDO2%TYPE;                       -- Segundo Apellido del Tercero

n_ID_TIPO_TERCERO           AB6106T00.ID_TIPO_TERCERO%TYPE;                 -- Identificador de Tipo de Tercero / Empresa

n_ID_TIPO_DOCUMENTO         AB6107T00.ID_TIPO_DOCUMENTO%TYPE;               -- Identificador de Tipo de Documento

n_ID_SEXO                   AB6120T00.ID_SEXO%TYPE;                         -- Identificador del Sexo

xmltype_AUXILIAR XMLTYPE;           -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
n_NumeroNodos NUMBER;               -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar

BEGIN

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoRepeticionRL') =  1) THEN

    xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('.//grupoRepeticionRL');

    n_NumeroNodos := 1;

    WHILE xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']') = 1 LOOP

        n_ID_TERCERO := null;
        v_DOCUMENTO := null;
        n_ID_TIPO_DOCUMENTO := null;
        v_NOMBRE := null;
        v_APELLIDO1 := null;
        v_APELLIDO2 := null;
        n_ID_SEXO := null;

        v_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlNumero/text()').getStringVal();
        v_NOMBRE := xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlNombre/text()').getStringVal();
        IF (xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlApellido1/text()') > 0) THEN
            v_APELLIDO1 := xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlApellido1/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlApellido2/text()') > 0) THEN
            v_APELLIDO2 := xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlApellido2/text()').getStringVal();
        END IF;
        n_ID_TIPO_TERCERO := 6; -- Representante Legal

        IF (xmltype_AUXILIAR.EXISTSNODE('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlSexo/text()') >0) THEN
            n_ID_SEXO := CORRELACION_SEXO(xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlSexo/text()').getStringVal());
        END IF;

        n_ID_TIPO_DOCUMENTO := CORRELACION_TIPO_DOCUMENTO(xmltype_AUXILIAR.EXTRACT('grupoRepeticionRL/elementoGR[' || n_NumeroNodos || ']/rlTipoDocumento/text()').getStringVal());

         -- Obtenemos el Identificador del Tercero a partir de la secuencia S_AB6104T00
        SELECT S_AB6135T00.NEXTVAL INTO n_ID_TERCERO FROM DUAL;

        -- Almacenamos la información relacionada con el Tercero (Persona de Contacto) en la tabla AB6104T00
        INSERT INTO AB6135T00 (ID_TERCERO, DOCUMENTO, ID_TIPO_DOCUMENTO, NOMBRE, APELLIDO1, APELLIDO2, ID_SEXO, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES(n_ID_TERCERO, v_DOCUMENTO, n_ID_TIPO_DOCUMENTO, v_NOMBRE, v_APELLIDO1, v_APELLIDO2, n_ID_SEXO, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Representante Legal Almacenado (' || v_NOMBRE || ')';

        -- Obtenemos el Identificador de la Relación del Expediente con el Tercero a partir de la secuencia S_AB6103T00
        SELECT S_AB6134T00.NEXTVAL INTO n_ID_REL_EXP_TER FROM DUAL;

        -- Almacenamos la información relacionada con la Relación del Expediente con el Tercero (Persona de Contacto) en la tabla AB6103T00
        INSERT INTO AB6134T00 (ID_REL_EXP_TER, ID_TERCERO, ID_TIPO_TERCERO, ID_EXPEDIENTE, FECHA_REGISTRO, USUARIO_REGISTRO)
        VALUES (n_ID_REL_EXP_TER, n_ID_TERCERO, n_ID_TIPO_TERCERO, IN_ID_EXPEDIENTE, SYSDATE, 'PL/SQL');

        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Relación Expediente / Representante Legal (Tercero) Almacenada (Expediente:' || IN_ID_EXPEDIENTE || ' - Tercero:' || n_ID_TERCERO || ' )';

        n_NumeroNodos :=  n_NumeroNodos + 1;

    END LOOP;

END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_REPRESENTANTE_LEGAL;

/
