PROMPT Procedimiento (ACTUALIZAR_TITULO_EXP)

create or replace PROCEDURE ACTUALIZAR_TITULO_EXP (IN_xmltype_SOLICITUD IN XMLTYPE, IN_COD_PROCEDURE_ID IN AB6101T00.COD_PROCEDURE_ID%TYPE, IN_ID_EXPEDIENTE IN AB61.AB6102T00.ID_EXPEDIENTE%TYPE) AS

v_CAMPOS_TITULO_EXPEDIENTE  AB6101T00.CAMPOS_TITULO_EXPEDIENTE%TYPE;        -- Campos del Toolkit de Formularios que se utilizarán para generar el Título del Expediente
n_ID_PROCEDIMIENTO          AB6101T00.ID_PROCEDIMIENTO%TYPE;                -- Identificador del Procedimiento

n_ID_EXPEDIENTE             AB6102T00.ID_EXPEDIENTE%TYPE;                   -- Identificador del Expediente
n_ID_TERRITORIO_HISTORICO   AB6102T00.ID_TERRITORIO_HISTORICO%TYPE;         -- Identificador del Territorio Histórico
n_ID_PROVINCIA_FISCAL       AB6102T00.ID_PROVINCIA_FISCAL%TYPE;             -- Identificador de la Provincia Fiscal

n_PosicionInicial NUMBER;           -- Variable que utilizaremos para obtner la posición inicial a la hora de generar el Título del Expediente
n_PosicionFinal NUMBER;             -- Variable que utilizaremos para obtner la posición final a la hora de generar el Título del Expediente
v_Campo VARCHAR2(200);               -- Variable que utilizaremoa para obtner el campo a buscar en el XML de Solicitud a la hora de generar el Título del Expediente
v_ValorCampo  VARCHAR2(1200);        -- Variable que utilizaremoa para obtner el valor del campo obtenido del XML de Solicitud a la hora de generar el Título del Expediente
v_ValorCampo2 VARCHAR2(1200);        -- Variable que utilizaremoa para obtner el valor del campo obtenido del XML de Solicitud a la hora de generar el Título del Expediente
v_Texto VARCHAR2(1200);             -- Variable para operaciones intermedias

n_TH NUMBER;                        -- Variable para controlar el primer campo del TH
pais VARCHAR2(200);                 -- Variable para obtener la descripción del país
OUT_TITULO AB6102T00.TITULO%TYPE;

BEGIN

SELECT ID_PROCEDIMIENTO, CAMPOS_TITULO_EXPEDIENTE INTO n_ID_PROCEDIMIENTO, v_CAMPOS_TITULO_EXPEDIENTE FROM AB6101T00 WHERE COD_PROCEDURE_ID = IN_COD_PROCEDURE_ID;
-- Obtenemos la Provincia Fiscal del Expediente a partir de <body><detailInfo><datosBasicos><datosOtrosDatos><ComboProvincia>
n_ID_PROVINCIA_FISCAL := null;
IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosBasicos/datosOtrosDatos/ComboProvincia/text()') > 0 ) THEN
    n_ID_PROVINCIA_FISCAL := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosBasicos/datosOtrosDatos/ComboProvincia/text()').getStringVal();
END IF;

-- Obtenemos el título del Expediente (TITULO) a partir de los campos determinados en la columna CAMPOS_TITULO_EXPEDIENTE de la Tabla de Procedimientos
n_PosicionInicial := 1;
n_PosicionFinal := 0;

-- Igualamos el título con los Campos del Título, para ir obteniendo la información de estos campos en la XML de Solicitud e ir reemplazando
OUT_TITULO := v_CAMPOS_TITULO_EXPEDIENTE;

n_TH := 1;

-- Recorremos la variable v_TITULO mientras tengamos la etiqueta {{, ya que el campo a buscar en el XML tiene que estar entre {{ ... }}
WHILE  INSTR(OUT_TITULO,'{{', 1, 1) != 0 LOOP
    -- Iniciamos el valor del campo a vacío
    v_ValorCampo := '';
    v_ValorCampo2 := '';
    v_Texto := '';

    -- Obtenemos la posición inicial de la etiqueta {{
    n_PosicionInicial := INSTR(OUT_TITULO,'{{', n_PosicionInicial, 1);
    -- Obtenemos la posición inicial de la etiqueta }}
    n_PosicionFinal := INSTR(OUT_TITULO,'}}', n_PosicionInicial, 1);
    -- Obtenemos el campos que viene entre las dos etiquetas {{ ... }} (tenemos que sumar y restar 2 para no obtener las etiquetas {{ ... }}
    v_Campo := SUBSTR(OUT_TITULO, n_PosicionInicial + 2, n_PosicionFinal - n_PosicionInicial - 2);

    -- Buscamos en el XML de Solicitud el campo a sustituir para generar el Título, primero miramos si esta campo existe
    IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//' || v_campo ||'/text()') > 0) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//' || v_campo ||'/text()').getStringVal();
    END IF;

    IF (v_campo ='person[1]/name') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[1]/holderShip/text()') > 0) THEN
          v_Texto := IN_xmltype_SOLICITUD.EXTRACT('.//person[1]/holderShip/text()').getStringVal();
          IF ( v_Texto <> 'HOLDER') THEN
            IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[2]/name/text()') > 0) THEN
                v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//person[2]/name/text()').getStringVal();
            END IF;
          END IF;
      END IF;
    END IF;
    IF (v_campo ='person[1]/ape1') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[1]/holderShip/text()') > 0) THEN
          v_Texto := IN_xmltype_SOLICITUD.EXTRACT('.//person[1]/holderShip/text()').getStringVal();
          IF ( v_Texto <> 'HOLDER') THEN
            IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[2]/ape1/text()') > 0) THEN
                v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//person[2]/ape1/text()').getStringVal();
            END IF;
          END IF;
      END IF;
    END IF;
    IF (v_campo ='person[1]/ape2') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[1]/holderShip/text()') > 0) THEN
          v_Texto := IN_xmltype_SOLICITUD.EXTRACT('.//person[1]/holderShip/text()').getStringVal();
          IF ( v_Texto <> 'HOLDER') THEN
            IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//person[2]/ape2/text()') > 0) THEN
                v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//person[2]/ape2/text()').getStringVal();
            END IF;
          END IF;
      END IF;
    END IF;

    IF (v_campo ='radioTipoSolicitudDEC') THEN
      IF (v_ValorCampo = 1) THEN
        v_ValorCampo := '[AYU-UDAL]';
      ELSE
        v_ValorCampo := '[ASO-ERAK]';
      END IF;
    END IF;

    IF (v_campo ='radioTipoSolicitudEMP') THEN
      IF (v_ValorCampo = 1) THEN
        v_ValorCampo := '[AYU-UDAL] ';
      ELSE
        v_ValorCampo := '';
      END IF;
    END IF;

    IF (v_campo ='check_modifEsencial') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//check_modifEsencial/elementocheck_modifEsencial/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//check_modifEsencial/elementocheck_modifEsencial/text()').getStringVal();
      END IF;
      v_ValorCampo := '[' || v_ValorCampo || ']';
    END IF;


    IF (v_campo ='holderchoicedatosDomicilioUbiProvince') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//radio_ubiTitular/text()') > 0) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//radio_ubiTitular/text()').getStringVal();
      END IF;
      IF (v_ValorCampo = 1) THEN
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//holderchoicedatosDomicilioUbiProvince/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//holderchoicedatosDomicilioUbiProvince/text()').getStringVal();
        END IF;
      ELSE
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//holderchoicedatosDomicilioTitularProvince/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//holderchoicedatosDomicilioTitularProvince/text()').getStringVal();
        END IF;
      END IF;
    END IF;

    IF (v_campo ='ubiEstablecimientoProvincia') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//radio_ubiTitular/text()') > 0) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//radio_ubiTitular/text()').getStringVal();
      END IF;
      IF (v_ValorCampo = 1) THEN
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ubiEstablecimientoProvincia/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//ubiEstablecimientoProvincia/text()').getStringVal();
        END IF;
      ELSE
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ubiDireccionTitularProvincia/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//ubiDireccionTitularProvincia/text()').getStringVal();
        END IF;
      END IF;
    END IF;
    
    -- Cualquier dato que no sea 20-Gipuzkoa o 48-Bizkaia, será 01-Araba-Álava
    IF (n_TH=1) THEN
      IF (v_ValorCampo != '48' AND v_ValorCampo != '20') THEN
        v_ValorCampo := '01';
      END IF;
      n_ID_TERRITORIO_HISTORICO := v_ValorCampo;
    END IF;

    -- Para los expedientes del censo
    IF (v_campo ='correlativEstSign') THEN

      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//correlativEstSign/text()') > 0) THEN
        v_ValorCampo2 := IN_xmltype_SOLICITUD.EXTRACT('.//correlativEstSign/text()').getStringVal();
      END IF;
      v_ValorCampo2 := LPAD(v_ValorCampo2,5,'0');

    END IF;

    IF (v_campo ='tipoActividad') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//tipoActividad/*') > 0) THEN
        v_ValorCampo := '[' || IN_xmltype_SOLICITUD.EXTRACT('.//tipoActividad/*').getRootElement() || ']';
      END IF;
    END IF;

    IF (v_campo ='modalidad') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//modalidad/text()') > 0) THEN
        v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//modalidad/text()').getStringVal();
        IF (v_ValorCampo = 2) THEN
          v_ValorCampo := '[R]';
        ELSE
          v_ValorCampo := '';
        END IF;
      END IF;
    END IF;

    -- Para los expedientes de ITOURBASK
    IF (v_campo ='provinciaOf0') THEN

      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//provinciaOf0/text()') > 0) THEN
        v_ValorCampo2 := IN_xmltype_SOLICITUD.EXTRACT('.//provinciaOf0/text()').getStringVal();
        v_ValorCampo2 := LPAD(v_ValorCampo2,2,'0');
      ELSE
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//provincOf1/text()') > 0) THEN
          v_ValorCampo2 := IN_xmltype_SOLICITUD.EXTRACT('.//provincOf1/text()').getStringVal();
          v_ValorCampo2 := LPAD(v_ValorCampo2,2,'0');
        ELSE
          IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//countrOf1/text()') > 0) THEN
            v_ValorCampo2 := IN_xmltype_SOLICITUD.EXTRACT('.//countrOf1/text()').getStringVal();
            SELECT DS_O INTO PAIS FROM T17I.T17_PAIS WHERE ID=v_ValorCampo2;
            v_ValorCampo2 := pais;
          END IF;
          IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//towOf1/text()') > 0) THEN
            v_ValorCampo2 := v_ValorCampo2 || '/' || IN_xmltype_SOLICITUD.EXTRACT('.//towOf1/text()').getStringVal();
          END IF;
        END IF;
      END IF;
      v_ValorCampo := v_ValorCampo2;
    END IF;

    IF (v_campo ='interestedRRI[1]/name') THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//interestedRRI[1]/name/text()') > 0) THEN
          v_ValorCampo := IN_xmltype_SOLICITUD.EXTRACT('.//interestedRRI[1]/name/text()').getStringVal();
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//interestedRRI[1]/ape1/text()') > 0) THEN
          v_ValorCampo := v_ValorCampo || ' ' || IN_xmltype_SOLICITUD.EXTRACT('.//interestedRRI[1]/ape1/text()').getStringVal();
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//interestedRRI[1]/ape2/text()') > 0) THEN
          v_ValorCampo := v_ValorCampo || ' ' || IN_xmltype_SOLICITUD.EXTRACT('.//interestedRRI[1]/ape2/text()').getStringVal();
      END IF;
    END IF;

    -- Reemplazamos el campo por el valor obtenido del XML de Solicitud
    OUT_TITULO := REPLACE (OUT_TITULO, '{{' || v_Campo || '}}', v_ValorCampo);

    n_TH := n_TH + 1;
END LOOP;

-- Actualizamos la información relacionada con el Expediente en la tabla AB6102T00.
UPDATE AB6102T00 SET ID_TERRITORIO_HISTORICO=n_ID_TERRITORIO_HISTORICO, ID_PROVINCIA_FISCAL=n_ID_PROVINCIA_FISCAL, TITULO=OUT_TITULO, FECHA_ULTMODIFICACION = SYSDATE, USUARIO_ULTMODIFICACION = 'PL/SQL' WHERE ID_EXPEDIENTE = IN_ID_EXPEDIENTE;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ACTUALIZAR_TITULO_EXP;

/
