PROMPT Procedimiento (TRATAMIENTO_TAREAS)

create or replace PROCEDURE TRATAMIENTO_TAREAS (IN_ID_MENSAJE AB61.AB6117T00.ID_MENSAJE%TYPE) AS 

n_COD_PROCEDURE_ID          AB61.AB6101T00.COD_PROCEDURE_ID%TYPE;               -- Cdigo de Procedimiento de PLATEA

n_ID_EXPEDIENTE             AB61.AB6102T00.ID_EXPEDIENTE%TYPE;                  -- Cdigo de Identificador del Expediente

clob_MENSAJE                AB61.AB6117T00.MENSAJE%TYPE;                        -- Mensaje (XML) de la TAREA

v_FOLDER_ID                 AB61.AB6118T00.FOLDER_ID%TYPE;                      -- Identificador del Expediente en PLATEA

n_ID_TRAZA                  AB61.AB6121T00.ID_TRAZA%TYPE;                       -- Identificador de la Traza
v_EXCEPCION                 AB61.AB6121T00.EXCEPCION%TYPE;                      -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_METODO                    AB61.AB6121T00.METODO%TYPE;                         -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin
v_TAREAS                    AB61.AB6121T00.TAREAS%TYPE;


xmltype_MENSAJE XMLTYPE;
xmltype_AUXILIAR XMLTYPE;
n_NumeroNodos NUMBER;               -- Variable que utilizaremos para recorrer los nodos del XMLTYPE Auxiliar
n_PosicionTipoDokusi NUMBER;
n_PosicionSubTipoDokusi NUMBER;


f_FECHA_TAREA DATE;

v_TASK_ID                   AB61.AB6144T00.TASK_ID%TYPE;
v_PLATEA_TYPE               AB61.AB6144T00.PLATEA_TYPE%TYPE; -- Tareas que PLATEA dispone: APERTURA
                                                            -- SOLDOCU
                                                            -- NOTIFICACION
                                                            -- APORDOCU
                                                            -- ESTDOCU
                                                            -- RECINOTI
                                                            -- CERREXP
                                                            -- REGISTRANOTI
                                                            -- LIQTASA
                                                            -- COMUNICACION 
                                                            -- REGISTRDOC
                                                            -- TRASPASOEXPEDIENTES
                                                            -- GENERICA
v_SITUACION_ID             AB61.AB6144T00.SITUACION_ID%TYPE;
n_STATUS                   AB61.AB6144T00.STATUS%TYPE;  -- Estado del evento: 1 - Tarea Sugerida
                                                            -- 3 - Tarea Rechazada
                                                            -- 4 - Tarea Ejecutada
                                                            -- 6 - Tarea Anulada
                                                            -- 7 - Tarea Reasignada a otro usuario y en estado pendiente
v_TIPO_DOKUSI               AB61.AB6144T00.TIPO_DOKUSI%TYPE;
v_SUBTIPO_DOKUSI            AB61.AB6144T00.SUBTIPO_DOKUSI%TYPE;
v_ASUNTO_DOCUMENTAL         AB61.AB6144T00.ASUNTO_DOCUMENTAL%TYPE;

v_ROLE_DOCUMENTO VARCHAR2(500);

BEGIN

-- Obtenemos el XML (CLOB) de la tabla AB6118T00 a partir del Identificador del Solicitud
SELECT MENSAJE INTO clob_MENSAJE FROM AB61.AB6117T00 WHERE ID_MENSAJE = IN_ID_MENSAJE;
-- Convertimos el CLOB (que tiene el XML de la Tarea) en el tipo XMLTYPE
xmltype_MENSAJE := XMLTYPE.createXML(clob_MENSAJE);

IF (xmltype_MENSAJE.EXISTSNODE('.//folderID/text()') > 0) THEN
    v_FOLDER_ID := xmltype_MENSAJE.EXTRACT('.//folderID/text()').getStringVal();
END IF;

    BEGIN
        -- Una vez que tenemos el FOLDERID obtenemos el Identificador de Expediente (ID_EXPEDIENTE)
SELECT ID_EXPEDIENTE INTO n_ID_EXPEDIENTE FROM AB61.AB6102T00 WHERE FOLDER_ID = v_FOLDER_ID;
    EXCEPTION WHEN NO_DATA_FOUND THEN

        BEGIN
            v_TAREAS := v_FOLDER_ID;
            RAISE;
        END;

    END;

IF ((xmltype_MENSAJE.EXISTSNODE('.//doTimestamp/text()') > 0) AND (xmltype_MENSAJE.EXISTSNODE('.//taskLanguage/text()') > 0)) THEN
    f_FECHA_TAREA := FORMATEAR_FECHA(xmltype_MENSAJE.EXTRACT('.//doTimestamp/text()').getStringVal(), xmltype_MENSAJE.EXTRACT('.//taskLanguage/text()').getStringVal());
END IF;

IF (xmltype_MENSAJE.EXISTSNODE('.//taskID/text()') > 0) THEN
    v_TASK_ID := xmltype_MENSAJE.EXTRACT('.//taskID/text()').getStringVal();
END IF;

n_NumeroNodos := 1;

WHILE xmltype_MENSAJE.EXISTSNODE('NotificationBody/Property[' || n_NumeroNodos || ']') = 1 LOOP

    IF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'PlateaType') THEN

        v_PLATEA_TYPE := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'Status') THEN

        n_STATUS := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    ELSIF (xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Name/text()').getStringVal() = 'ProcedureID') THEN

        n_COD_PROCEDURE_ID := xmltype_MENSAJE.EXTRACT('NotificationBody/Property[' || n_NumeroNodos || ']/Value/text()').getStringVal();

    END IF;

    n_NumeroNodos :=  n_NumeroNodos + 1;

END LOOP;

IF (xmltype_MENSAJE.EXISTSNODE('.//situacionID/text()') > 0) THEN
    v_SITUACION_ID := xmltype_MENSAJE.EXTRACT('.//situacionID/text()').getStringVal();
END IF;

IF (xmltype_MENSAJE.EXISTSNODE('.//documents') >  0) THEN

    xmltype_AUXILIAR := xmltype_MENSAJE.EXTRACT('.//documents');

    n_NumeroNodos := 1;

    WHILE xmltype_AUXILIAR.EXISTSNODE('documents/document[' || n_NumeroNodos || ']') = 1 LOOP

        v_ROLE_DOCUMENTO := NULL;
        v_TIPO_DOKUSI := NULL;
        v_SUBTIPO_DOKUSI := NULL;
        v_ASUNTO_DOCUMENTAL := NULL;

        v_ROLE_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('documents/document[' || n_NumeroNodos || ']/rolID/text()').getStringVal(); 
        
        n_PosicionTipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.');
        
        v_TIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, 0, n_PosicionTipoDokusi - 1);
        
        n_PosicionSubtipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.', n_PosicionTipoDokusi + 1);
        
        v_SUBTIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, n_PosicionTipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - (LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi + 1) - n_PosicionTipoDokusi);
        
        v_ASUNTO_DOCUMENTAL := SUBSTR(v_ROLE_DOCUMENTO,n_PosicionSubtipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi);
        
    
    AB61.ALMACENAR_FECHA (IN_ID_MENSAJE, 'R02_TASK', v_TASK_ID, v_PLATEA_TYPE, NULL, v_SITUACION_ID, n_STATUS, NULL, v_TIPO_DOKUSI, v_SUBTIPO_DOKUSI, v_ASUNTO_DOCUMENTAL,
                                    f_FECHA_TAREA, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID);
                                             
    n_NumeroNodos :=  n_NumeroNodos + 1;

    END LOOP;

ELSIF (xmltype_MENSAJE.EXISTSNODE('.//documentsStorageList') >  0) THEN
   
    xmltype_AUXILIAR := xmltype_MENSAJE.EXTRACT('.//documentsStorageList');

    n_NumeroNodos := 1;

    WHILE xmltype_AUXILIAR.EXISTSNODE('documentsStorageList/documentStorageInfo[' || n_NumeroNodos || ']') = 1 LOOP

        v_ROLE_DOCUMENTO := NULL;
        v_TIPO_DOKUSI := NULL;
        v_SUBTIPO_DOKUSI := NULL;
        v_ASUNTO_DOCUMENTAL := NULL;

        v_ROLE_DOCUMENTO := xmltype_AUXILIAR.EXTRACT('documentsStorageList/documentStorageInfo[' || n_NumeroNodos || ']/roleID/text()').getStringVal(); 
        
        n_PosicionTipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.');
        
        v_TIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, 0, n_PosicionTipoDokusi - 1);
        
        n_PosicionSubtipoDokusi := INSTR(v_ROLE_DOCUMENTO, '.', n_PosicionTipoDokusi + 1);
        
        v_SUBTIPO_DOKUSI := SUBSTR(v_ROLE_DOCUMENTO, n_PosicionTipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - (LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi + 1) - n_PosicionTipoDokusi);
        
        v_ASUNTO_DOCUMENTAL := SUBSTR(v_ROLE_DOCUMENTO,n_PosicionSubtipoDokusi + 1, LENGTH(v_ROLE_DOCUMENTO) - n_PosicionSubtipoDokusi);
        
    
    AB61.ALMACENAR_FECHA (IN_ID_MENSAJE, 'R02_TASK', v_TASK_ID, v_PLATEA_TYPE, NULL, v_SITUACION_ID, n_STATUS, NULL, v_TIPO_DOKUSI, v_SUBTIPO_DOKUSI, v_ASUNTO_DOCUMENTAL,
                                    f_FECHA_TAREA, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID);
                                             
    n_NumeroNodos :=  n_NumeroNodos + 1;

    END LOOP;
ELSE

 AB61.ALMACENAR_FECHA (IN_ID_MENSAJE, 'R02_TASK', v_TASK_ID, v_PLATEA_TYPE, NULL, v_SITUACION_ID, n_STATUS, NULL, NULL , NULL, NULL,
                                    f_FECHA_TAREA, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID);

END IF;

COMMIT;

EXCEPTION
WHEN NO_DATA_FOUND THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

     v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000) || ' (ID_MENSAJE: ' || IN_ID_MENSAJE || ')';

    v_METODO:= 'TRATAMIENTO_TAREAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

END;  

WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;  

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    v_METODO:= 'TRATAMIENTO_TAREAS';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_MENSAJE, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, IN_ID_MENSAJE, n_ID_EXPEDIENTE, n_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

END;  

END TRATAMIENTO_TAREAS;

/
