PROMPT Procedimiento (ALMACENAR_FECHAS_COMUNICACION)

create or replace PROCEDURE ALMACENAR_FECHAS_COMUNICACION (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB61.AB6102T00.ID_EXPEDIENTE%TYPE, OUT_TAREAS IN OUT AB61.AB6121T00.TAREAS%TYPE) AS

n_ID_FEC_COM_COM            AB61.AB6145T00.ID_FEC_COM_COM%TYPE;      -- Identificador interno de la Fecha de Comunicación de Comercio
d_FECHA_INI	                AB61.AB6145T00.FECHA_INICIO%TYPE;        -- Fecha de inicio
d_FECHA_FIN	                AB61.AB6145T00.FECHA_FIN%TYPE;           -- Fecha de fin
fecha                       varchar2(20);

BEGIN
-- FECHAS

  d_FECHA_INI := null;
  d_FECHA_FIN := null;
  fecha := null;

  --0092101
  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaInicio/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//fechaInicio/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaFin/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//fechaFin/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;
  
  --0092102
  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaDesde/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//fechaDesde/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//fechaHasta/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//fechaHasta/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;
  
  --0092103
  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ubiFechaDesde/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//ubiFechaDesde/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_INI := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;

  IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ubiFechaHasta/text()') > 0) THEN
    fecha := IN_xmltype_SOLICITUD.EXTRACT('.//ubiFechaHasta/text()').getStringVal();
    IF ( INSTR(fecha, '/', 1, 1) > 3 ) THEN
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'eu');
    ELSE
      d_FECHA_FIN := AB61.FORMATEAR_FECHA(fecha,'es');
    END IF;
  END IF;

  -- Obtenemos el Identificador de la fecha a partir de la secuencia S_AB6145T00
  SELECT AB61.S_AB6145T00.NEXTVAL INTO n_ID_FEC_COM_COM FROM DUAL;

  -- Almacenamos la información relacionada con la Empresa en la tabla AB6105T00
  INSERT INTO AB61.AB6145T00 (ID_FEC_COM_COM,ID_EXPEDIENTE,FECHA_INICIO,FECHA_FIN,FECHA_REGISTRO,USUARIO_REGISTRO)
  VALUES(n_ID_FEC_COM_COM, IN_ID_EXPEDIENTE, d_FECHA_INI, d_FECHA_FIN, SYSDATE, 'PL/SQL');

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_FECHAS_COMUNICACION;

/