PROMPT Creacion Tabla (AB6105T00)

CREATE TABLE AB6105T00
(
	ID_REL_LIS_PRO       NUMBER(8) NOT NULL ,
	ID_LISTADO           NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	DESCRIPCION_CASTELLANO VARCHAR2(200 CHAR) NULL ,
	DESCRIPCION_EUSKERA  VARCHAR2(200 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL ,
	FECHA_ULTMODIFICACION DATE NULL ,
	USUARIO_ULTMODIFICACION VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6105T00 IS 'Tabla que permite relacionar los Listados y los Procedimientos';
COMMENT ON COLUMN AB6105T00.ID_REL_LIS_PRO IS 'Identificador interno de la Relacin entre el Listado y el Procedimiento';
COMMENT ON COLUMN AB6105T00.ID_LISTADO IS 'Identificador interno del Listado';
COMMENT ON COLUMN AB6105T00.ID_PROCEDIMIENTO IS 'Identificador interno del Procedimiento';
COMMENT ON COLUMN AB6105T00.DESCRIPCION_CASTELLANO IS 'Descripcin en Castellano del Listado';
COMMENT ON COLUMN AB6105T00.DESCRIPCION_EUSKERA IS 'Descripcin en Euskera del Listado';
COMMENT ON COLUMN AB6105T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6105T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6105T00.FECHA_ULTMODIFICACION IS 'Fecha de la ltima modificacin del registro';
COMMENT ON COLUMN AB6105T00.USUARIO_ULTMODIFICACION IS 'Usuario que ha realizado la ltima modificacin del registro';


CREATE SYNONYM REL_LIS_PRO	 FOR AB6105T00;


CREATE UNIQUE INDEX PK_AB6105T00 ON AB6105T00(ID_REL_LIS_PRO   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6105T00	ADD CONSTRAINT  PK_AB6105T00 PRIMARY KEY (ID_REL_LIS_PRO);


CREATE  INDEX FK_AB6105T00 ON AB6105T00(ID_LISTADO   ASC)	TABLESPACE AB6102E00;
CREATE  INDEX PK_AB6105T01 ON AB6105T00(ID_PROCEDIMIENTO   ASC)	TABLESPACE AB6102E00;

ALTER TABLE AB6105T00	ADD (CONSTRAINT FK_AB6108T00_AB6105T00 FOREIGN KEY (ID_LISTADO) REFERENCES AB6108T00 (ID_LISTADO));
ALTER TABLE AB6105T00	ADD (CONSTRAINT FK_AB6101T00_AB6105T00 FOREIGN KEY (ID_PROCEDIMIENTO) REFERENCES AB6101T00 (ID_PROCEDIMIENTO));