PROMPT Actualizacin ALMACENAR_DOMICILIO_TITULAR

create or replace PROCEDURE ALMACENAR_DOMICILIO_TITULAR (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_TERCERO IN OUT AB6134T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB6121T00.TAREAS%TYPE) AS

n_ID_DIRECCION              AB6136T00.ID_DIRECCION%TYPE;
v_DIRECCION                 AB6136T00.DIRECCION%TYPE;                       -- Direccin del Titular
v_NUMERO                    AB6136T00.NUMERO%TYPE;                          -- Nmero de la Direccin del Titular
v_ESCALERA                  AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Direccin del Titular
v_PISO                      AB6136T00.PISO%TYPE;                            -- Piso de la Direccin del Titular
v_LETRA                     AB6136T00.LETRA%TYPE;                           -- Letra de la Direccin del Titular
v_CODIGO_POSTAL             AB6136T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin del Titular
n_ID_PROVINCIA              AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccin del Titular
n_ID_MUNICIPIO              AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin del Titular
n_ID_LOCALIDAD              AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin del Titular

BEGIN

IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//domicilioTitular') =  1) THEN



        v_DIRECCION := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularDomicilio/text()').getStringVal();
        v_NUMERO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPortal/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()') > 0) THEN
            v_ESCALERA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularEscalera/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()') > 0) THEN
            v_PISO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularPiso/text()').getStringVal();
        END IF;
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()') > 0) THEN
            v_LETRA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLetra/text()').getStringVal();
        END IF;
        v_CODIGO_POSTAL := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularCP/text()').getStringVal();
        n_ID_PROVINCIA := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularProvince/text()').getStringVal();
        n_ID_MUNICIPIO := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularMunicipio/text()').getStringVal();
        IF (IN_xmltype_SOLICITUD.EXISTSNODE('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()') > 0) THEN
            n_ID_LOCALIDAD := IN_xmltype_SOLICITUD.EXTRACT('/ejgvDocument/body/detailInfo/datosComplementarios/domicilioTitular/datosDomicilioTitular/holderchoicedatosDomicilioTitularLocalidad/text()').getStringVal();
        END IF;

        -- Obtenemos el Identificador de la Empresa a partir de la secuencia S_AB6105T00
SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

-- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
VALUES(n_ID_DIRECCION, IN_ID_TERCERO, 1, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'PL/SQL');


        OUT_TAREAS := OUT_TAREAS || chr(13) || '-Domicilio del Titular Actualizado (' || v_DIRECCION || ')';


END IF;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_DOMICILIO_TITULAR;

/