PROMPT Actualizacin ALMACENAR_DIRECCION

create or replace PROCEDURE ALMACENAR_DIRECCION (IN_xmltype_SOLICITUD IN XMLTYPE, IN_ID_EXPEDIENTE IN AB61.AB6102T00.ID_EXPEDIENTE%TYPE,
                                                 IN_ID_TERCERO IN AB61.AB6135T00.ID_TERCERO%TYPE, OUT_TAREAS IN OUT AB61.AB6121T00.TAREAS%TYPE) AS

n_ID_DIRECCION              AB61.AB6136T00.ID_DIRECCION%TYPE;                    -- Identificador de la Empresa
n_ID_TIPO_DIRECCION         AB61.AB6136T00.ID_TIPO_DIRECCION%TYPE;
v_ESTABLECIMIENTO           AB61.AB6136T00.ESTABLECIMIENTO%TYPE;                 -- Nombre de la Empresa / Establecimiento
v_DIRECCION                 AB61.AB6136T00.DIRECCION%TYPE;                       -- Direccin de la Empresa / Establecimiento
v_NUMERO                    AB61.AB6136T00.NUMERO%TYPE;                          -- NÃºmero de la Direccin de la Empresa / Establecimiento
v_ESCALERA                  AB61.AB6136T00.ESCALERA%TYPE;                        -- Escalera de la Direccin de la Empresa / Establecimiento
v_PISO                      AB61.AB6136T00.PISO%TYPE;                            -- Piso de la Direccin de la Empresa / Establecimiento
v_LETRA                     AB61.AB6136T00.LETRA%TYPE;                           -- Letra de la Direccin de la Empresa / Establecimiento
v_CODIGO_POSTAL             AB61.AB6136T00.CODIGO_POSTAL%TYPE;                   -- Cdigo Postal de la Direccin de la Empresa / Establecimiento
n_ID_PROVINCIA              AB61.AB6136T00.ID_PROVINCIA%TYPE;                    -- Identificador de la Provincia de la Direccivn de la Empresa / Establecimiento
n_ID_MUNICIPIO              AB61.AB6136T00.ID_MUNICIPIO%TYPE;                    -- Identificador del Municipio de la Direccin de la Empresa / Establecimiento
n_ID_LOCALIDAD              AB61.AB6136T00.ID_LOCALIDAD%TYPE;                    -- Identificador de la Localidad de la Direccin de la Empresa / Establecimiento
v_ID_ESTABLECIMIENTO        AB61.AB6136T00.IDENTIFICADOR_ESTABLECIMIENTO%TYPE;   -- Nmero de Registro

xmltype_AUXILIAR            XMLTYPE;                                    -- Variable XMLTYPE auxiliar que utilizaremos para obtener nodos concretos del XML de la Solicitud
v_NUMERO_REGISTRO_1         VARCHAR(1);                 					      -- Nmero de Registro (EMET)_tipoEstSign
v_NUMERO_REGISTRO_2         VARCHAR(2);                 					      -- Nmero de Registro (EMET)_territEstSign
v_NUMERO_REGISTRO_3         VARCHAR(5);						                      -- Nmero de Registro (EMET)_correlativEstSign

ubi                         number;

BEGIN

  FOR n_ID_TIPO_DIRECCION IN 1..3 LOOP

    v_NUMERO_REGISTRO_1 := null;
    v_NUMERO_REGISTRO_2 := null;
    v_NUMERO_REGISTRO_3 := null;

    v_ESTABLECIMIENTO := null;
    v_ID_ESTABLECIMIENTO := null;
    v_DIRECCION := null;
    v_NUMERO := null;
    v_ESCALERA := null;
    v_PISO := null;
    v_LETRA := null;
    v_CODIGO_POSTAL := null;
    n_ID_PROVINCIA := null;
    n_ID_MUNICIPIO := null;
    n_ID_LOCALIDAD := null;
    ubi := 0;

    -----------------------------------------------------------------------------------------------------------
    -- Direccin del titular
    -----------------------------------------------------------------------------------------------------------
    IF n_ID_TIPO_DIRECCION = 1 THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoDireccionTitular') >  0) THEN
        xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//grupoDireccionTitular');

        IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//nombreRazonsocial/text()') > 0) THEN
          v_ESTABLECIMIENTO := IN_xmltype_SOLICITUD.EXTRACT('.//nombreRazonsocial/text()').getStringVal();
        END IF;

        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularDomicilio/text()') > 0) THEN
          v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularDomicilio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularPortal/text()') > 0) THEN
          v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularPortal/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularEscalera/text()') > 0) THEN
          v_ESCALERA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularEscalera/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularPiso/text()') > 0) THEN
          v_PISO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularPiso/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularLetra/text()') > 0) THEN
          v_LETRA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularLetra/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularCP/text()') > 0) THEN
          v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularCP/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularProvincia/text()') > 0) THEN
          n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularProvincia/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularMunicipio/text()') > 0) THEN
          n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularMunicipio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularLocalidad/text()') > 0) THEN
          n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularLocalidad/text()').getStringVal();
        END IF;

        ubi := 1;
      END IF;
    END IF;

    -----------------------------------------------------------------------------------------------------------
    -- Direccin del establecimiento
    -----------------------------------------------------------------------------------------------------------
    IF n_ID_TIPO_DIRECCION = 2 THEN

      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoEstablecimiento') >  0) THEN
        xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//grupoEstablecimiento');

        -- Grupo establecimiento
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoDomicilio/text()') > 0) THEN
          v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoDomicilio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoPortal/text()') > 0) THEN
          v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoPortal/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoEscalera/text()') > 0) THEN
          v_ESCALERA := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoEscalera/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoPiso/text()') > 0) THEN
          v_PISO := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoPiso/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoLetra/text()') > 0) THEN
          v_LETRA := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoLetra/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoCP/text()') > 0) THEN
          v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoCP/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoProvincia/text()') > 0) THEN
          n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoProvincia/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoMunicipio/text()') > 0) THEN
          n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoMunicipio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiEstablecimientoLocalidad/text()') > 0) THEN
          n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('.//ubiEstablecimientoLocalidad/text()').getStringVal();
        END IF;

        ubi := 1;
      END IF;

      -- Formulario con check que indica que los datos del establecimiento son los mismos que los del titular
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//radio_ubiTitular/text()') > 0) THEN
        IF (IN_xmltype_SOLICITUD.EXTRACT('.//radio_ubiTitular/text()').getStringVal() = 0) THEN

          -- Los datos son los mismos que la direccin del titular
          IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoDireccionTitular') >  0) THEN
            xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//grupoDireccionTitular');

            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularDomicilio/text()') > 0) THEN
              v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularDomicilio/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularPortal/text()') > 0) THEN
              v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularPortal/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularEscalera/text()') > 0) THEN
              v_ESCALERA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularEscalera/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularPiso/text()') > 0) THEN
              v_PISO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularPiso/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularLetra/text()') > 0) THEN
              v_LETRA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularLetra/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularCP/text()') > 0) THEN
              v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularCP/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularProvincia/text()') > 0) THEN
              n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularProvincia/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularMunicipio/text()') > 0) THEN
              n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularMunicipio/text()').getStringVal();
            END IF;
            IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiDireccionTitularLocalidad/text()') > 0) THEN
              n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('.//ubiDireccionTitularLocalidad/text()').getStringVal();
            END IF;

            ubi := 1;
          END IF;

        END IF;
      END IF;

      -- Formulario con nombre comercial del establecimiento
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//establecimientoNombre/text()') > 0) THEN
        v_ESTABLECIMIENTO := IN_xmltype_SOLICITUD.EXTRACT('.//establecimientoNombre/text()').getStringVal();
      END IF;

      -- Formulario de EMET
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ayudas_tipoEstSign/text()') > 0) THEN
        v_NUMERO_REGISTRO_1 := IN_xmltype_SOLICITUD.EXTRACT('.//ayudas_tipoEstSign/text()').getStringVal();
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ayudas_territEstSign/text()') > 0) THEN
        v_NUMERO_REGISTRO_2 := IN_xmltype_SOLICITUD.EXTRACT('.//ayudas_territEstSign/text()').getStringVal();
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//ayudas_correlativEstSign/text()') > 0) THEN
        v_NUMERO_REGISTRO_3 := IN_xmltype_SOLICITUD.EXTRACT('.//ayudas_correlativEstSign/text()').getStringVal();
        v_NUMERO_REGISTRO_3 := LPAD(v_NUMERO_REGISTRO_3,5,'0');
      END IF;
      
      -- Formularios del CENSO
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//tipoEstSign/text()') > 0) THEN
        v_NUMERO_REGISTRO_1 := IN_xmltype_SOLICITUD.EXTRACT('.//tipoEstSign/text()').getStringVal();
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//signature/text()') > 0) THEN
        v_NUMERO_REGISTRO_2 := IN_xmltype_SOLICITUD.EXTRACT('.//signature/text()').getStringVal();
        ubi := 1;
      END IF;
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//correlativEstSign/text()') > 0) THEN
        v_NUMERO_REGISTRO_3 := IN_xmltype_SOLICITUD.EXTRACT('.//correlativEstSign/text()').getStringVal();
        v_NUMERO_REGISTRO_3 := LPAD(v_NUMERO_REGISTRO_3,5,'0');
      END IF;
      
      v_ID_ESTABLECIMIENTO := v_NUMERO_REGISTRO_1 || v_NUMERO_REGISTRO_2 || v_NUMERO_REGISTRO_3;

    END IF;

    -----------------------------------------------------------------------------------------------------------
    -- Direccin del lugar
    -----------------------------------------------------------------------------------------------------------
    IF n_ID_TIPO_DIRECCION = 3 THEN
      IF (IN_xmltype_SOLICITUD.EXISTSNODE('.//grupoLugar') >  0) THEN
        xmltype_AUXILIAR := IN_xmltype_SOLICITUD.EXTRACT('//grupoLugar');

        -- Grupo genÃ©rico de datos de ubicacin
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarDomicilio/text()') > 0) THEN
          v_DIRECCION := xmltype_AUXILIAR.EXTRACT('.//ubiLugarDomicilio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarPortal/text()') > 0) THEN
          v_NUMERO := xmltype_AUXILIAR.EXTRACT('.//ubiLugarPortal/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarEscalera/text()') > 0) THEN
          v_ESCALERA := xmltype_AUXILIAR.EXTRACT('.//ubiLugarEscalera/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarPiso/text()') > 0) THEN
          v_PISO := xmltype_AUXILIAR.EXTRACT('.//ubiLugarPiso/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarLetra/text()') > 0) THEN
          v_LETRA := xmltype_AUXILIAR.EXTRACT('.//ubiLugarLetra/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarCP/text()') > 0) THEN
          v_CODIGO_POSTAL := xmltype_AUXILIAR.EXTRACT('.//ubiLugarCP/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarProvincia/text()') > 0) THEN
          n_ID_PROVINCIA := xmltype_AUXILIAR.EXTRACT('.//ubiLugarProvincia/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarMunicipio/text()') > 0) THEN
          n_ID_MUNICIPIO := xmltype_AUXILIAR.EXTRACT('.//ubiLugarMunicipio/text()').getStringVal();
        END IF;
        IF (xmltype_AUXILIAR.EXISTSNODE('.//ubiLugarLocalidad/text()') > 0) THEN
          n_ID_LOCALIDAD := xmltype_AUXILIAR.EXTRACT('.//ubiLugarLocalidad/text()').getStringVal();
        END IF;

        ubi := 1;
      END IF;
    END IF;

    IF ubi = 1 THEN
      -- Obtenemos el Identificador de la direccin a partir de la secuencia S_AB6105T00
      SELECT AB61.S_AB6136T00.NEXTVAL INTO n_ID_DIRECCION FROM DUAL;

      -- Almacenamos la informacin relacionada con la Empresa en la tabla AB6105T00
      INSERT INTO AB61.AB6136T00 (ID_DIRECCION, ID_TERCERO, ID_TIPO_DIRECCION, ESTABLECIMIENTO, IDENTIFICADOR_ESTABLECIMIENTO, DIRECCION, NUMERO, ESCALERA, PISO, LETRA, CODIGO_POSTAL, ID_PROVINCIA, ID_MUNICIPIO, ID_LOCALIDAD,FECHA_REGISTRO, USUARIO_REGISTRO)
      VALUES(n_ID_DIRECCION, IN_ID_TERCERO, n_ID_TIPO_DIRECCION, v_ESTABLECIMIENTO, v_ID_ESTABLECIMIENTO, v_DIRECCION, v_NUMERO, v_ESCALERA, v_PISO, v_LETRA, v_CODIGO_POSTAL, n_ID_PROVINCIA, n_ID_MUNICIPIO, n_ID_LOCALIDAD, SYSDATE, 'PL/SQL');

      OUT_TAREAS := OUT_TAREAS || chr(13) || '-Datos de la direccin almacenada ([' || n_ID_DIRECCION || '] Nombre: ' || v_ESTABLECIMIENTO || ')';

    END IF;

  END LOOP;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    RAISE;

    END;

END ALMACENAR_DIRECCION;

/