PROMPT Actualizacin COPIA_CONVOCATORIA_BASICA

create or replace PROCEDURE COPIA_CONVOCATORIA_BASICA (IN_ID_PROCEDIMIENTO IN AB61.AB6101T00.ID_PROCEDIMIENTO%TYPE,
IN_COD_PROCEDURE_ID IN  AB61.AB6101T00.COD_PROCEDURE_ID%TYPE,
IN_ANYO_CONVOCATORIA IN AB60.AB6001T00.CONVOCATORIA%TYPE) AS

n_ID_TRAZA            AB61.AB6121T00.ID_TRAZA%TYPE;          -- Identificador de la Traza
v_EXCEPCION           AB61.AB6121T00.EXCEPCION%TYPE;         -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_TAREAS              AB61.AB6121T00.TAREAS%TYPE;            -- Tareas de la carga de la Solicitud que se han desarrollado
v_METODO              AB61.AB6121T00.METODO%TYPE;            -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin

n_ID_PROCEDIMIENTO    AB61.AB6101T00.ID_PROCEDIMIENTO%TYPE;

n_ID_CONVOCATORIA     AB60.AB6001T00.ID_CONVOCATORIA%TYPE;

BEGIN

v_METODO := 'COPIA_CONV_PROC_CONFIG';
n_ID_PROCEDIMIENTO := AB60.COPIA_CONV_PROC_CONFIG(IN_ID_PROCEDIMIENTO, IN_COD_PROCEDURE_ID);

v_METODO := 'COPIA_CONV_PLAN_LIST';
AB60.COPIA_CONV_PLAN_LIST(IN_ID_PROCEDIMIENTO, n_ID_PROCEDIMIENTO);

-- Una vez que hayamos almacenado toda la informacin, guardamos una Traza con las Tareas Realizadas en la tbala AB6121T00
SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

-- En este caso el Estado ser igual a 1 ya que todo ha ido bien
v_METODO := 'COPIA_CONVOCATORIA_BASICA';
INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
VALUES (n_ID_TRAZA, NULL, NULL, IN_COD_PROCEDURE_ID, '', v_METODO, 1, v_TAREAS, SYSDATE);

-- Haremos COMMIT cuando hayamos almacenado toda la informacin relacionada con la Solicitud
COMMIT;

EXCEPTION
WHEN NO_DATA_FOUND THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, NULL, NULL, IN_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

    END;

WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, ID_SOLICITUD, ID_EXPEDIENTE, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, TAREAS, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, NULL, NULL, IN_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, v_TAREAS, SYSDATE);

    COMMIT;

    END;

END COPIA_CONVOCATORIA_BASICA;

/