PROMPT Creacion de 	Tabla (AB6103T00)

CREATE TABLE AB6103T00
(
	ID_REL_INI_OFI_ORI   NUMBER(8) NOT NULL ,
	ID_PROC_ORIGEN       NUMBER(8) NOT NULL ,
	ID_PROC_INICIO_OFICIO NUMBER(8) NOT NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6103T00 IS 'Tabla para relacionar los Procedimientos de Inicio de Oficio con sus Procedimientos de Origen';
COMMENT ON COLUMN AB6103T00.ID_PROC_ORIGEN IS 'Identificador interno del Procedimiento de Origen';
COMMENT ON COLUMN AB6103T00.ID_PROC_INICIO_OFICIO IS 'Identificador interno del Procedimiento de Inicio de Oficio';
COMMENT ON COLUMN AB6103T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6103T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6103T00.ID_REL_INI_OFI_ORI IS 'Identificador de Relacin entre el Procedimiento Origen y el Procedimiento de Inicio de Oficio';


CREATE SYNONYM REL_INI_OFI_ORI	 FOR AB6103T00;


CREATE UNIQUE INDEX PK_AB6103T00 ON AB6103T00(ID_REL_INI_OFI_ORI   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6103T00	ADD CONSTRAINT  PK_AB6103T00 PRIMARY KEY (ID_REL_INI_OFI_ORI);


CREATE  INDEX FK_AB6103T00 ON AB6103T00(ID_PROC_ORIGEN   ASC)	TABLESPACE AB6102E00;
CREATE  INDEX FK_AB6103T01 ON AB6103T00(ID_PROC_INICIO_OFICIO   ASC)	TABLESPACE AB6102E00;


ALTER TABLE AB6103T00	ADD (CONSTRAINT FK_AB6101T00_AB6103T00_2 FOREIGN KEY (ID_PROC_ORIGEN) REFERENCES AB6101T00 (ID_PROCEDIMIENTO));
ALTER TABLE AB6103T00	ADD (CONSTRAINT FK_AB6101T00_AB6103T00 FOREIGN KEY (ID_PROC_INICIO_OFICIO) REFERENCES AB6101T00 (ID_PROCEDIMIENTO));