PROMPT Creacion de 	Tabla (AB6104T00)

CREATE TABLE AB6104T00
(
	ID_DOC_MODIFICADO    NUMBER(8) NOT NULL ,
	ID_DOCUMENTO         NUMBER(8) NOT NULL ,
	NOMBRE_ARCHIVO       VARCHAR2(200 CHAR) NULL ,
	ARCHIVO              BLOB NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6104T00 IS 'Tabla para almacenar los Documentos modificador en el Mantenimiento de Plantillas';
COMMENT ON COLUMN AB6104T00.NOMBRE_ARCHIVO IS 'Nombre del Archivo del Documento Modificado';
COMMENT ON COLUMN AB6104T00.ARCHIVO IS 'Archivo del Documento Modificado';
COMMENT ON COLUMN AB6104T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6104T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6104T00.ID_DOC_MODIFICADO IS 'Identificador interno del Documento Modificado';
COMMENT ON COLUMN AB6104T00.ID_DOCUMENTO IS 'Identificador interno del Documento';


CREATE SYNONYM DOC_MODIFICADOS	 FOR AB6104T00;


CREATE UNIQUE INDEX PK_AB6104T00 ON AB6104T00(ID_DOC_MODIFICADO   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6104T00	ADD CONSTRAINT  PK_AB6104T00 PRIMARY KEY (ID_DOC_MODIFICADO);


CREATE  INDEX FK_AB6104T00 ON AB6104T00(ID_DOCUMENTO   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6104T00	ADD (CONSTRAINT FK_AB6139T00_AB6104T00 FOREIGN KEY (ID_DOCUMENTO) REFERENCES AB6139T00 (ID_DOCUMENTO));