PROMPT Creacion Tabla (AB6125T00)

CREATE TABLE AB6125T00
(
	ID_REL_EXP_ORI_DES   NUMBER(8) NOT NULL ,
	ID_EXPEDIENTE_ORIGEN NUMBER(8) NOT NULL ,
	FOLDER_ID_ORIGEN     VARCHAR2(64 CHAR) NULL ,
	FOLDER_ID_DESTINO    VARCHAR2(64 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;


COMMENT ON TABLE AB6125T00 IS 'Tabla para relacionar los Expedientes de Origen con los Expedientes de Destisno (Inicio de Oficio)';
COMMENT ON COLUMN AB6125T00.ID_REL_EXP_ORI_DES IS 'Identificador de la Relacin del Expediente de Origen y el Expediente de Destino';
COMMENT ON COLUMN AB6125T00.FOLDER_ID_ORIGEN IS 'FOLDER_ID del Expediente de Origen';
COMMENT ON COLUMN AB6125T00.FOLDER_ID_DESTINO IS 'FOLDER_ID del Expediente de Destino';
COMMENT ON COLUMN AB6125T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6125T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';
COMMENT ON COLUMN AB6125T00.ID_EXPEDIENTE_ORIGEN IS 'Identificador interno del Expediente de Origen';


CREATE SYNONYM REL_EXP_ORI_DES	 FOR AB6125T00;

CREATE UNIQUE INDEX PK_AB6125T00 ON AB6125T00(ID_REL_EXP_ORI_DES   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6125T00	ADD CONSTRAINT  PK_AB6125T00 PRIMARY KEY (ID_REL_EXP_ORI_DES);

CREATE  INDEX FK_AB6125T00 ON AB6125T00(ID_EXPEDIENTE_ORIGEN   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6125T00	ADD (CONSTRAINT FK_AB6102T00_AB6125T00 FOREIGN KEY (ID_EXPEDIENTE_ORIGEN) REFERENCES AB6102T00 (ID_EXPEDIENTE));