PROMPT Creacion Tabla (AB6127T00)

CREATE TABLE AB6127T00
(
	ID_ERROR_FOLDER_NUMBER NUMBER(8) NOT NULL ,
	ID_PROCEDIMIENTO     NUMBER(8) NOT NULL ,
	FOLDER_NUMBER        VARCHAR2(24 CHAR) NULL ,
	FECHA_REGISTRO       DATE NULL ,
	USUARIO_REGISTRO     VARCHAR2(20 CHAR) NULL 
)
	TABLESPACE AB6101E00;

COMMENT ON TABLE AB6127T00 IS 'Tabla para almacenar los saltos de FOLDER_NUMBER en los Expedientes existentes en la aplicacin';
COMMENT ON COLUMN AB6127T00.ID_ERROR_FOLDER_NUMBER IS 'Identificador interno del Error de FOLDER_NUMBER';
COMMENT ON COLUMN AB6127T00.FOLDER_NUMBER IS 'FOLDER_NUMBER del Error';
COMMENT ON COLUMN AB6127T00.ID_PROCEDIMIENTO IS 'Identificador interno del Procedimiento';
COMMENT ON COLUMN AB6127T00.FECHA_REGISTRO IS 'Fecha cuando se ha almacenado el registro';
COMMENT ON COLUMN AB6127T00.USUARIO_REGISTRO IS 'Usuario que ha almacenado el registro';


CREATE SYNONYM ERROR_FOLDER_NUMBER	 FOR AB6127T00;


CREATE UNIQUE INDEX PK_AB6127T00 ON AB6127T00(ID_ERROR_FOLDER_NUMBER   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6127T00	ADD CONSTRAINT  PK_AB6127T00 PRIMARY KEY (ID_ERROR_FOLDER_NUMBER);


CREATE  INDEX FK_AB6127T00 ON AB6127T00(ID_PROCEDIMIENTO   ASC)	TABLESPACE AB6102E00;
ALTER TABLE AB6127T00	ADD (CONSTRAINT FK_AB6101T00_AB6127T00 FOREIGN KEY (ID_PROCEDIMIENTO) REFERENCES AB6101T00 (ID_PROCEDIMIENTO));