PROMPT OBTENER_ERRORES_FOLDER_NUMBER

create or replace PROCEDURE OBTENER_ERRORES_FOLDER_NUMBER AS 

n_ID_TRAZA                  AB61.AB6121T00.ID_TRAZA%TYPE;                   -- Identificador de la Traza
v_EXCEPCION                 AB61.AB6121T00.EXCEPCION%TYPE;                  -- Excepcin dentro de la Traza en caso de que tengamos un Error
v_METODO                    AB61.AB6121T00.METODO%TYPE;                     -- Mtodo (Funcin o Procedimiento) donde ha dado la Excepcin
v_COD_PROCEDURE_ID          AB61.AB6121T00.COD_PROCEDURE_ID%TYPE;

v_FOLDER_NUMBER  AB6127T00.FOLDER_NUMBER%TYPE;
n_NUMERO_FOLDER_NUMBER NUMBER(8);
n_EXISTE NUMBER(1);

BEGIN
  -- En primer lugar borramos la tabla donde almacenaremos los Errores (AB6127T00)
  DELETE AB6127T00;
  
FOR PROCEDIMIENTO IN (SELECT MAX(TO_NUMBER(SUBSTR(FOLDER_NUMBER,0,INSTR(FOLDER_NUMBER,'-')-1))) AS NUMERO_MAXIMO,
                        ID_PROCEDIMIENTO FROM AB6102T00 GROUP BY ID_PROCEDIMIENTO ORDER BY ID_PROCEDIMIENTO)
LOOP

    n_NUMERO_FOLDER_NUMBER := 1;
    
    SELECT COD_PROCEDURE_ID INTO v_COD_PROCEDURE_ID FROM AB6101T00 WHERE ID_PROCEDIMIENTO = PROCEDIMIENTO.ID_PROCEDIMIENTO;
    
    BEGIN
        SELECT FOLDER_NUMBER INTO v_FOLDER_NUMBER FROM AB6102T00 WHERE ID_PROCEDIMIENTO = PROCEDIMIENTO.ID_PROCEDIMIENTO AND FOLDER_NUMBER IS NOT NULL ORDER BY FOLDER_NUMBER FETCH FIRST ROW ONLY;
        
        v_FOLDER_NUMBER := SUBSTR(v_FOLDER_NUMBER,INSTR(v_FOLDER_NUMBER,'-'),LENGTH(v_FOLDER_NUMBER));

        WHILE (n_NUMERO_FOLDER_NUMBER <= PROCEDIMIENTO.NUMERO_MAXIMO)
        LOOP
            
            BEGIN
                SELECT 1 INTO n_EXISTE FROM AB6102T00 WHERE ID_PROCEDIMIENTO = PROCEDIMIENTO.ID_PROCEDIMIENTO AND TO_NUMBER(SUBSTR(FOLDER_NUMBER,0,INSTR(FOLDER_NUMBER,'-')-1)) = n_NUMERO_FOLDER_NUMBER;
            EXCEPTION
            WHEN NO_DATA_FOUND THEN
            
                INSERT INTO AB6127T00 (ID_ERROR_FOLDER_NUMBER, ID_PROCEDIMIENTO, FOLDER_NUMBER, FECHA_REGISTRO, USUARIO_REGISTRO) 
                VALUES (S_AB6127T00.NEXTVAL, PROCEDIMIENTO.ID_PROCEDIMIENTO, LPAD(n_NUMERO_FOLDER_NUMBER, 4, '0') || v_FOLDER_NUMBER, SYSDATE, 'PL/SQL');
                
                COMMIT;
        
            WHEN OTHERS THEN
            BEGIN
                ROLLBACK;
            
                SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;
            
                v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);
            
                v_METODO:= 'OBTENER_ERRORES_FOLDER_NUMBER';
            
                INSERT INTO AB61.AB6121T00 (ID_TRAZA, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, FECHA_REGISTRO)
                VALUES (n_ID_TRAZA, v_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, SYSDATE);
            
                COMMIT;
            
                END;
            END;
            
            n_NUMERO_FOLDER_NUMBER := n_NUMERO_FOLDER_NUMBER + 1;
    
        END LOOP;

    EXCEPTION
        WHEN NO_DATA_FOUND THEN
        NULL;
    END;
    
    
END LOOP;

EXCEPTION
WHEN OTHERS THEN
BEGIN
    ROLLBACK;

    SELECT AB61.S_AB6121T00.NEXTVAL INTO n_ID_TRAZA FROM DUAL;

    v_EXCEPCION:= SUBSTR(SQLERRM, 1, 2000);

    v_METODO:= 'OBTENER_ERRORES_FOLDER_NUMBER';

    INSERT INTO AB61.AB6121T00 (ID_TRAZA, COD_PROCEDURE_ID, EXCEPCION, METODO, ESTADO_SOLICITUD, FECHA_REGISTRO)
    VALUES (n_ID_TRAZA, v_COD_PROCEDURE_ID, v_EXCEPCION, v_METODO, 2, SYSDATE);

    COMMIT;

    END;
    
END OBTENER_ERRORES_FOLDER_NUMBER;

/