/**
 * 
 */
package com.ejie.ab61.adaptadores;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab61.adaptadores.service.X43ProcedimientosService;
import com.ejie.ab61.clientesWS.X43Procedimientos.AExtensionPoint;
import com.ejie.ab61.clientesWS.X43Procedimientos.TConsultationContext;
import com.ejie.ab61.clientesWS.X43Toolkit.Exception_Exception;

/**
 *  
 * 
 */
@Service(value = "X43ProcedimientosAdaptadorServiceImpl")
public class X43ProcedimientosAdaptadorServiceImpl implements X43ProcedimientosAdaptadorService {

	public static final Logger logger = LoggerFactory.getLogger(X43ProcedimientosAdaptadorServiceImpl.class);

	@Autowired()
	private X43ProcedimientosService x43ProcedimientosService;

	/**
	 * Metodo que devuelve información sobre un procedimiento.
	 * 
	 * @param procedureID:
	 *            String
	 * 
	 * @param ep
	 *            AExtensionPoint
	 * 
	 * @return TConsultationContext
	 * 
	 */
	public TConsultationContext getConsultationContext(String procedureID, AExtensionPoint ep)
			throws Exception_Exception {

		X43ProcedimientosAdaptadorServiceImpl.logger
				.info("X43ProcedimientosAdaptadorServiceImpl.getConsultationContext - Inicio");

		TConsultationContext respuesta = this.x43ProcedimientosService.getConsultationContext(procedureID, ep);
		X43ProcedimientosAdaptadorServiceImpl.logger
				.debug("X43ProcedimientosAdaptadorServiceImpl.getConsultationContext - Return: " + respuesta);
		return respuesta;

	}

}
