package com.ejie.ab61.dao.expedientes;

import java.util.List;

import com.ejie.ab61.model.expedientes.FechasExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * FechasExpedienteDao  
 * 
 *  
 */

public interface FechasExpedienteDao {

	/**
	 * Inserts a single row in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente add(FechasExpediente fechasexpediente);

	/**
	 * Updates a single row in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente update(FechasExpediente fechasexpediente);

	/**
	 * Finds a single row in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente find(FechasExpediente fechasexpediente);

	/**
	 * Removes a single row in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 */
	void remove(FechasExpediente fechasexpediente);

	/**
	 * Finds a List of rows in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<FechasExpediente> findAll(FechasExpediente fechasexpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the FechasExpediente table using like.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<FechasExpediente> findAllLike(FechasExpediente fechasexpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(FechasExpediente filterFechasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the FechasExpediente table using like.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(FechasExpediente fechasexpediente, Boolean startsWith);

	/**
	 * Counts rows in the FechasExpediente table.
	 *
	 * @param fechasexpediente
	 *            FechasExpediente
	 * @return Long
	 */
	Long findAllCount(FechasExpediente fechasexpediente);

	/**
	 * Reorder selection.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FechasExpediente>>
	 */
	List<TableRowDto<FechasExpediente>> reorderSelection(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param searchFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FechasExpediente>>
	 */
	List<TableRowDto<FechasExpediente>> search(FechasExpediente filterFechasExpediente,
			FechasExpediente searchFechasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<FechasExpediente>>
	 */
	List<JerarquiaDto<FechasExpediente>> findAllLikeJerarquia(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(FechasExpediente filterFechasExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<FechasExpediente>>
	 */
	List<TableRowDto<FechasExpediente>> findAllChild(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto);

	Integer getNumeroRelExpFech(FechasExpediente fechasExpediente);

}
