package com.ejie.ab61.dao.expedientes;

import java.util.List;

import com.ejie.ab61.model.expedientes.RelExpPla;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpPlaDao  
 * 
 *  
 */

public interface RelExpPlaDao {

	/**
	 * Inserts a single row in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return RelExpPla
	 */
	RelExpPla add(RelExpPla relexppla);

	/**
	 * Updates a single row in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return RelExpPla
	 */
	RelExpPla update(RelExpPla relexppla);

	/**
	 * Finds a single row in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return RelExpPla
	 */
	RelExpPla find(RelExpPla relexppla);

	/**
	 * obtener la ruta del archivo para poder modificar o aportar a tramitagune
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return RelExpPla
	 */

	RelExpPla obtenerDatosAportarDocumento(RelExpPla relexppla);

	/**
	 * obtener la ruta del archivo para poder modificar o aportar a tramitagune,
	 * desde procedimiento
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return RelExpPla
	 */

	RelExpPla obtenerDocumentoDesdeProcedimiento(RelExpPla relexppla);

	/**
	 * Removes a single row in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 */
	void remove(RelExpPla relexppla);

	/**
	 * Finds a List of rows in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelExpPla> findAll(RelExpPla relexppla, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpPla table using like.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelExpPla> findAllLike(RelExpPla relexppla, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelExpPla table.
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpPla filterRelExpPla, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelExpPla table using like.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelExpPla relexppla, Boolean startsWith);

	/**
	 * Counts rows in the RelExpPla table.
	 *
	 * @param relexppla
	 *            RelExpPla
	 * @return Long
	 */
	Long findAllCount(RelExpPla relexppla);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpPla>>
	 */
	List<TableRowDto<RelExpPla>> reorderSelection(RelExpPla filterRelExpPla, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param searchRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpPla>>
	 */
	List<TableRowDto<RelExpPla>> search(RelExpPla filterRelExpPla, RelExpPla searchRelExpPla,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelExpPla table.
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelExpPla>>
	 */
	List<JerarquiaDto<RelExpPla>> findAllLikeJerarquia(RelExpPla filterRelExpPla, JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelExpPla filterRelExpPla, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelExpPla
	 *            RelExpPla
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelExpPla>>
	 */
	List<TableRowDto<RelExpPla>> findAllChild(RelExpPla filterRelExpPla, JQGridRequestDto jqGridRequestDto);

}
