package com.ejie.ab61.dao.listados;

import java.util.List;

import com.ejie.ab61.model.listados.Listados;
import com.ejie.ab61.model.listados.RelLisPro;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ListadosDao  
 * 
 *  
 */

public interface ListadosDao {

	/**
	 * Inserts a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Listados
	 */
	Listados add(Listados listados);

	/**
	 * Updates a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Listados
	 */
	Listados update(Listados listados);

	/**
	 * Finds a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Listados
	 */
	Listados find(Listados listados);

	/**
	 * Removes a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 */
	void remove(Listados listados);

	/**
	 * Finds a List of rows in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Listados> findAll(Listados listados, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Listados> findAllLike(Listados listados, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Listados listados, Boolean startsWith);

	/**
	 * Counts rows in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Long
	 */
	Long findAllCount(Listados listados);

	/**
	 * Reorder selection.
	 *
	 * @param filterListados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Listados>>
	 */
	List<TableRowDto<Listados>> reorderSelection(Listados filterListados, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	Listados borrarFichero(Listados listados);

	Listados updateSinFichero(Listados listados);

	/**
	 * Finds rows in the RelLisPro table using like.
	 *
	 * @param relLisPro
	 *            RelLisPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelLisPro> findListadosRelLisPro(RelLisPro relLisPro, JQGridRequestDto jqGridRequestDto);

	/**
	 * Counts rows in the RelLisPro table.
	 *
	 * @param relLisPro
	 *            RelLisPro
	 * @return Long
	 */
	Long findListadosRelLisProCount(RelLisPro relLisPro);

	/**
	 * Finds a single row in the RelLisPro table.
	 *
	 * @param idRelLisPro
	 *            Integer
	 * @return RelLisPro
	 */
	RelLisPro findRelLisPro(Integer idRelLisPro);

	/**
	 * Inserts a single row in the RelLisPro table.
	 *
	 * @param relLisPro
	 *            RelLisPro
	 * @return RelLisPro
	 */
	RelLisPro addRelLisPro(RelLisPro relLisPro);

	/**
	 * Updates a single row in the RelLisPro table.
	 *
	 * @param relLisPro
	 *            RelLisPro
	 * @return RelLisPro
	 */
	RelLisPro updateRelLisPro(RelLisPro relLisPro);

	/**
	 * Removes a single row in the RelLisPro table.
	 *
	 * @param idRelLisPro
	 *            Integer
	 * 
	 * @return
	 */
	void removeRelLisPro(Integer idRelLisPro);
}
