package com.ejie.ab61.dao.parametros;

import java.util.List;

import com.ejie.ab61.model.parametros.Parametros;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ParametrosDao  
 * 
 *  
 */

public interface ParametrosDao {

	/**
	 * Inserts a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros add(Parametros parametros);

	/**
	 * Updates a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros update(Parametros parametros);

	/**
	 * Finds a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros find(Parametros parametros);

	/**
	 * Removes a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 */
	void remove(Parametros parametros);

	/**
	 * Elimina todos los parametros de una busqueda.
	 *
	 * @param idBusqueda
	 *            Integer
	 */
	void removeList(Integer idBusqueda);

	/**
	 * Finds a List of rows in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Parametros> findAll(Parametros parametros, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Parametros table using like.
	 *
	 * @param parametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Parametros> findAllLike(Parametros parametros, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Parametros table using like.
	 *
	 * @param parametros
	 *            Parametros
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Parametros parametros, Boolean startsWith);

	/**
	 * Counts rows in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Long
	 */
	Long findAllCount(Parametros parametros);

	/**
	 * Reorder selection.
	 *
	 * @param filterParametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Parametros>>
	 */
	List<TableRowDto<Parametros>> reorderSelection(Parametros filterParametros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);
}
