package com.ejie.ab61.dao.plantillas;

import java.util.List;

import com.ejie.ab61.model.plantillas.ParametrosConfig;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ParametrosConfigDao  
 * 
 *  
 */

public interface ParametrosConfigDao {

	/**
	 * Inserts a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig add(ParametrosConfig parametrosConfig);

	/**
	 * Updates a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig update(ParametrosConfig parametrosConfig);

	/**
	 * Finds a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig find(ParametrosConfig parametrosConfig);

	/**
	 * Buscamos el valor para saber la configuacion de la vista de plantilla
	 * 
	 * @return ParametrosConfig parametrosConfig
	 */
	ParametrosConfig findByDescripcion(ParametrosConfig parametrosConfig);

	/**
	 * Removes a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 */
	void remove(ParametrosConfig parametrosConfig);

	/**
	 * Finds rows in the ParametrosConfig table using like.
	 *
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<ParametrosConfig> findAllLike(ParametrosConfig parametrosConfig, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the ParametrosConfig table using like.
	 *
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(ParametrosConfig parametrosConfig, Boolean startsWith);

	/**
	 * Reorder selection.
	 *
	 * @param filterParametrosConfig
	 *            ParametrosConfig
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ParametrosConfig>>
	 */
	List<TableRowDto<ParametrosConfig>> reorderSelection(ParametrosConfig filterParametrosConfig,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

}
