package com.ejie.ab61.dao.terceros;

import com.ejie.ab61.model.terceros.TiposCanalAviso;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposCanalAvisoDao  
 *  
 */

public interface TiposCanalAvisoDao {
    
    /**
     * Inserts a single row in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @return TiposCanalAviso
     */
    TiposCanalAviso add(TiposCanalAviso tiposcanalaviso);

    /**
     * Updates a single row in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @return TiposCanalAviso
     */
    TiposCanalAviso update(TiposCanalAviso tiposcanalaviso);

    /**
     * Finds a single row in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @return TiposCanalAviso
     */
    TiposCanalAviso find(TiposCanalAviso tiposcanalaviso);

    /**
     * Removes a single row in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     */
    void remove(TiposCanalAviso tiposcanalaviso);

    /**
     * Finds a List of rows in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<TiposCanalAviso> findAll(TiposCanalAviso tiposcanalaviso, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the TiposCanalAviso table using like.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<TiposCanalAviso> findAllLike(TiposCanalAviso tiposcanalaviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the TiposCanalAviso table using like.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(TiposCanalAviso tiposcanalaviso, Boolean startsWith);
    
    /**
     * Counts rows in the TiposCanalAviso table.
     *
     * @param tiposcanalaviso TiposCanalAviso
     * @return Long
     */
    Long findAllCount(TiposCanalAviso tiposcanalaviso);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposCanalAviso>>
	 */	
    List<TableRowDto<TiposCanalAviso>> reorderSelection(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param searchTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposCanalAviso>>	 
	 */	
    List<TableRowDto<TiposCanalAviso>> search(TiposCanalAviso filterTiposCanalAviso, TiposCanalAviso searchTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<TiposCanalAviso>>
	 */	
	List<JerarquiaDto<TiposCanalAviso>> findAllLikeJerarquia(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<TiposCanalAviso>>
	 */	
	List<TableRowDto<TiposCanalAviso>> findAllChild(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto);
	
	
}

