package com.ejie.ab61.dao.terceros;

import com.ejie.ab61.model.terceros.TiposDireccion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposDireccionDao  
 * 
 *  
 */

public interface TiposDireccionDao {

	/**
	 * Inserts a single row in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @return TiposDireccion
	 */
	TiposDireccion add(TiposDireccion tiposdireccion);

	/**
	 * Updates a single row in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @return TiposDireccion
	 */
	TiposDireccion update(TiposDireccion tiposdireccion);

	/**
	 * Finds a single row in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @return TiposDireccion
	 */
	TiposDireccion find(TiposDireccion tiposdireccion);

	/**
	 * Removes a single row in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 */
	void remove(TiposDireccion tiposdireccion);

	/**
	 * Finds a List of rows in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposDireccion> findAll(TiposDireccion tiposdireccion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposDireccion table using like.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposDireccion> findAllLike(TiposDireccion tiposdireccion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposDireccion table.
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposDireccion filterTiposDireccion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposDireccion table using like.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposDireccion tiposdireccion, Boolean startsWith);

	/**
	 * Counts rows in the TiposDireccion table.
	 *
	 * @param tiposdireccion
	 *            TiposDireccion
	 * @return Long
	 */
	Long findAllCount(TiposDireccion tiposdireccion);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposDireccion>>
	 */
	List<TableRowDto<TiposDireccion>> reorderSelection(TiposDireccion filterTiposDireccion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param searchTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposDireccion>>
	 */
	List<TableRowDto<TiposDireccion>> search(TiposDireccion filterTiposDireccion, TiposDireccion searchTiposDireccion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposDireccion table.
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposDireccion>>
	 */
	List<JerarquiaDto<TiposDireccion>> findAllLikeJerarquia(TiposDireccion filterTiposDireccion,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposDireccion filterTiposDireccion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposDireccion
	 *            TiposDireccion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposDireccion>>
	 */
	List<TableRowDto<TiposDireccion>> findAllChild(TiposDireccion filterTiposDireccion,
			JQGridRequestDto jqGridRequestDto);

}
