package com.ejie.ab61.dao.terceros;

import com.ejie.ab61.model.terceros.TiposDocumento;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposDocumentoDao  
 * 
 *  
 */

public interface TiposDocumentoDao {

	/**
	 * Inserts a single row in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @return TiposDocumento
	 */
	TiposDocumento add(TiposDocumento tiposdocumento);

	/**
	 * Updates a single row in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @return TiposDocumento
	 */
	TiposDocumento update(TiposDocumento tiposdocumento);

	/**
	 * Finds a single row in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @return TiposDocumento
	 */
	TiposDocumento find(TiposDocumento tiposdocumento);

	/**
	 * Finds id_tipo_documento
	 *
	 * @param nombreDocumento
	 *            String
	 * @return IdTipoDocumento Integer
	 */
	TiposDocumento findIdTipoDocumento(String nombreDocumento);

	/**
	 * Removes a single row in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 */
	void remove(TiposDocumento tiposdocumento);

	/**
	 * Finds a List of rows in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposDocumento> findAll(TiposDocumento tiposdocumento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposDocumento table using like.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposDocumento> findAllLike(TiposDocumento tiposdocumento, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposDocumento table.
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposDocumento table using like.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposDocumento tiposdocumento, Boolean startsWith);

	/**
	 * Counts rows in the TiposDocumento table.
	 *
	 * @param tiposdocumento
	 *            TiposDocumento
	 * @return Long
	 */
	Long findAllCount(TiposDocumento tiposdocumento);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposDocumento>>
	 */
	List<TableRowDto<TiposDocumento>> reorderSelection(TiposDocumento filterTiposDocumento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param searchTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposDocumento>>
	 */
	List<TableRowDto<TiposDocumento>> search(TiposDocumento filterTiposDocumento, TiposDocumento searchTiposDocumento,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposDocumento table.
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposDocumento>>
	 */
	List<JerarquiaDto<TiposDocumento>> findAllLikeJerarquia(TiposDocumento filterTiposDocumento,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposDocumento
	 *            TiposDocumento
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposDocumento>>
	 */
	List<TableRowDto<TiposDocumento>> findAllChild(TiposDocumento filterTiposDocumento,
			JQGridRequestDto jqGridRequestDto);

}
