package com.ejie.ab61.dao.terceros;

import com.ejie.ab61.model.terceros.TiposTercero;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposTerceroDao  
 * 
 *  
 */

public interface TiposTerceroDao {

	/**
	 * Inserts a single row in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @return TiposTercero
	 */
	TiposTercero add(TiposTercero tipostercero);

	/**
	 * Updates a single row in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @return TiposTercero
	 */
	TiposTercero update(TiposTercero tipostercero);

	/**
	 * Finds a single row in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @return TiposTercero
	 */
	TiposTercero find(TiposTercero tipostercero);

	/**
	 * Removes a single row in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 */
	void remove(TiposTercero tipostercero);

	/**
	 * Finds a List of rows in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<TiposTercero> findAll(TiposTercero tipostercero, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposTercero table using like.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<TiposTercero> findAllLike(TiposTercero tipostercero, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finds a idTipoTercero in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @return TiposTercero
	 */
	TiposTercero findIdTipoTercero(String role);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the TiposTercero table.
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(TiposTercero filterTiposTercero, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the TiposTercero table using like.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(TiposTercero tipostercero, Boolean startsWith);

	/**
	 * Counts rows in the TiposTercero table.
	 *
	 * @param tipostercero
	 *            TiposTercero
	 * @return Long
	 */
	Long findAllCount(TiposTercero tipostercero);

	/**
	 * Reorder selection.
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposTercero>>
	 */
	List<TableRowDto<TiposTercero>> reorderSelection(TiposTercero filterTiposTercero, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param searchTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposTercero>>
	 */
	List<TableRowDto<TiposTercero>> search(TiposTercero filterTiposTercero, TiposTercero searchTiposTercero,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical TiposTercero table.
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<TiposTercero>>
	 */
	List<JerarquiaDto<TiposTercero>> findAllLikeJerarquia(TiposTercero filterTiposTercero,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(TiposTercero filterTiposTercero, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposTercero
	 *            TiposTercero
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<TiposTercero>>
	 */
	List<TableRowDto<TiposTercero>> findAllChild(TiposTercero filterTiposTercero, JQGridRequestDto jqGridRequestDto);

}
