package com.ejie.ab61.service.listados;

import java.util.List;

import com.ejie.ab61.model.listados.Listados;
import com.ejie.x38.dto.JQGridRequestDto;

/**
 * ListadosService  
 * 
 *  
 */

public interface ListadosClienteService {

	/**
	 * Finds a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Listados
	 */
	Listados find(Listados listados);

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Listados>
	 */
	List<Listados> findAllLike(Listados listados, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * llama al webService que genera un XLS con las busquedas seleccionadas
	 * 
	 * @param listados
	 * @return string ruta fichero pif
	 * @throws Exception
	 */
	String gerenarXLS(Listados listados) throws Exception;

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param idProcedimiento
	 *            Integer
	 * 
	 * @return List<Listados>
	 */
	List<Listados> findAllRelLisProByProc(Integer idProcedimiento);
}
