package com.ejie.ab61.service.parametros;

import java.util.List;

import com.ejie.ab61.model.parametros.Parametros;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ParametrosService  
 * 
 *  
 */

public interface ParametrosService {

	/**
	 * Inserts a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros add(Parametros parametros);

	/**
	 * Updates a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros update(Parametros parametros);

	/**
	 * Finds a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @return Parametros
	 */
	Parametros find(Parametros parametros);

	/**
	 * Deletes a single row in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 */
	void remove(Parametros parametros);

	/**
	 * Finds a list of rows in the Parametros table.
	 *
	 * @param parametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Parametros>
	 */
	List<Parametros> findAll(Parametros parametros, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Parametros table using like.
	 *
	 * @param parametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Parametros>
	 */
	List<Parametros> findAllLike(Parametros parametros, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the Parametros table.
	 *
	 * @param filterParametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Parametros>
	 */
	JQGridResponseDto<Parametros> filter(Parametros filterParametros, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Reorder the selection made in Parametros table.
	 *
	 * @param filterParametros
	 *            Parametros
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Parametros filterParametros, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
}
