package com.ejie.ab61.service.plantillas;

import com.ejie.ab61.model.plantillas.ParametrosConfig;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * CamposPlantillaService  
 * 
 *  
 */

public interface ParametrosConfigService {

	/**
	 * Inserts a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig add(ParametrosConfig parametrosConfig);

	/**
	 * Updates a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig update(ParametrosConfig parametrosConfig);

	/**
	 * Finds a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 * @return ParametrosConfig
	 */
	ParametrosConfig find(ParametrosConfig parametrosConfig);

	/**
	 * Buscamos el valor para saber la configuacion de la vista de plantilla
	 * 
	 * @return ParametrosConfig parametrosConfig
	 */
	ParametrosConfig findByDescripcion(ParametrosConfig parametrosConfig);

	/**
	 * Deleets a single row in the ParametrosConfig table.
	 * 
	 * @param parametrosConfig
	 *            ParametrosConfig
	 */
	void remove(ParametrosConfig parametrosConfig);

	/**
	 * Filter method in the ParametrosConfig table.
	 *
	 * @param filterParametrosConfig
	 *            ParametrosConfig
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<ParametrosConfig>
	 */
	JQGridResponseDto<ParametrosConfig> filter(ParametrosConfig filterParametrosConfig,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

}
