package com.ejie.ab61.service.solicitudes;

import com.ejie.ab61.model.procedimientos.Procedimientos;
import com.ejie.ab61.model.solicitudes.Configuracion;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * ConfiguracionService  
 * 
 *  
 */

public interface ConfiguracionService {

	/**
	 * Inserts a single row in the Configuracion table.
	 *
	 * @param configuracion
	 *            Configuracion
	 * @return Configuracion
	 */
	Configuracion add(Configuracion configuracion);

	/**
	 * Updates a single row in the Configuracion table.
	 *
	 * @param configuracion
	 *            Configuracion
	 * @return Configuracion
	 */
	Configuracion update(Configuracion configuracion);

	/**
	 * Finds a single row in the Configuracion table.
	 *
	 * @param configuracion
	 *            Configuracion
	 * @return Configuracion
	 */
	Configuracion find(Configuracion configuracion);

	/**
	 * Deletes a single row in the Configuracion table.
	 *
	 * @param configuracion
	 *            Configuracion
	 */
	void remove(Configuracion configuracion);

	/**
	 * Finds a list of rows in the Configuracion table.
	 *
	 * @param configuracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Configuracion>
	 */
	List<Configuracion> findAll(Configuracion configuracion, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Configuracion table using like.
	 *
	 * @param configuracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Configuracion>
	 */
	List<Configuracion> findAllLike(Configuracion configuracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Configuracion table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Configuracion filterConfiguracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Configuracion table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Configuracion>
	 */
	JQGridResponseDto<Configuracion> filter(Configuracion filterConfiguracion, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Configuracion table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param searchConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Configuracion>>
	 */
	List<TableRowDto<Configuracion>> search(Configuracion filterConfiguracion, Configuracion searchConfiguracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Configuracion table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Configuracion filterConfiguracion, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Configuracion table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Configuracion>>
	 */
	JQGridResponseDto<JerarquiaDto<Configuracion>> jerarquia(Configuracion filterConfiguracion,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Configuracion
	 * table.
	 *
	 * @param filterConfiguracion
	 *            Configuracion
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Configuracion>>
	 */
	JQGridResponseDto<JerarquiaDto<Configuracion>> jerarquiaChildren(Configuracion filterConfiguracion,
			JQGridRequestDto jqGridRequestDto);

	Integer comprobarConfigEventosRepetido(String codProcedureId, Integer idConfigEventos);

	void removeByCodProcedureId(String codProcedureId);

	List<Configuracion> findByCodProcedureId(String codProcedureId);

}
