<%@include file="/WEB-INF/includeTemplate.inc"%>	
<%@taglib prefix="tiles" uri="/WEB-INF/tld/tiles-jsp.tld"%>
<%@taglib prefix="form" uri="/WEB-INF/tld/spring-form.tld"%>

<section>
	<div id="documentosDetalle_feedback"></div>
	<div class="panel panel-default">	
	<div class="panel-heading "><spring:message code="plantillas.datosDocumentos"/></div>
		<div class="panel-body">	
			<form:form class="form-horizontal" modelAttribute="documento" method="post" id="documentosForm" enctype="multipart/form-data">
				<input type="hidden" id="idDocumento" name="idDocumento" value="${idDocumento}"/>				
				<form:input name="listaIdCampo" id="listaIdCampo" class="hidden" path="listaIdCampo"></form:input>
				
				<div class="row">
					<div class="col-xs-6 form-group">
						<label class="required"><spring:message code="plantillas.nombre"/></label>
						<form:input name="nombreDocumento" id="nombreDocumentoDetalle" class="form-control" path="nombreDocumento" maxlength="200"></form:input>
					</div>
					<div id="conNombre">
						<div class="col-xs-6 form-group">
							<label class="required"><spring:message code="plantillas.nombreArchivo"/></label>
							<form:input name="nombreArchivo" id="nombreArchivoDetalle" class="form-control" path="nombreArchivo"></form:input>
							<div class="colorAzul form-group col-xs-2"><a href="#" onclick="javascript:borrarFichero()"><i class="fa fa-window-close" aria-hidden="true"></i></a></div>
						</div>
					</div>
					<div id="sinNombre">
						<div class="col-xs-6 form-group">		
							<label class="required"><spring:message code="plantillas.fichero"/></label>	
							<div class="input-group form-group" id="adjuntoModalDocumentosUpload">
								<label class="input-group-btn">
						    		<span class="btn btn-primary ui-button ui-corner-all ui-widget" style="height:25px;padding:1px 5px 1px 5px;color:white"> Seleccionar archivo&hellip; 
						    			<input type="file" name="file" id="ficheroDetalle" style="display: none;" onchange="anadirNombreFichero()">
						            </span>
						        </label>
						        <input type="text" id="nombreFichero" readonly="readonly" onfocus="this.blur()" class="form-control blanco" readonly style="height:25px;width:100%;border-bottom: #ccc 1px solid !important"/>
							</div>	
						</div>
					</div>
				</div>			
				<div class="row">
					<div class="col-xs-4 form-group">
						<label><spring:message code="plantillas.observaciones"/></label>
						<form:textarea name="observaciones" id="observacionesDetalle" class="form-control" path="observaciones" maxlength="2000" style="resize: none;"></form:textarea>
					</div>
				</div>
			</form:form>
		</div>
	</div>	
	<div class="panel panel-default">	
		<div class="panel-body">
			<div class="panel panel-default">	
			<div class="panel-heading "><spring:message code="plantillas.busquedaObjetos"/></div>
				<div class="panel-body">
					<div id="CamposPlantilla_div" class="rup-table-container">		
						<div id="CamposPlantilla_feedback"></div>						<!-- Feedback de la tabla --> 
						<div id="CamposPlantilla_toolbar" class="oculto"></div>							<!-- Botonera de la tabla -->
						<form id="CamposPlantilla_filter_form">						<!-- Formulario de filtrado -->
							<div id="CamposPlantilla_filter_toolbar" class="oculto"></div>	<!-- Barra de herramientas del formulario de filtrado -->
							<fieldset id="CamposPlantilla_filter_fieldset" class="rup-table-filter-fieldset">
								<div class="formulario_columna_cnt">
									<!-- Campos del formulario de filtrado -->				
									<div class="row">
										<div class="col-xs-6 form-group">
											<label><spring:message code="plantillas.tipoObjeto"/></label>
											<select name="idTipoCampo" id="idTipoCampo_filter_table" class="form-control"></select>
										</div>
										<div class="col-xs-6 form-group">
											<label for="nombreCampo_filter_table" class="formulario_linea_label"><spring:message code="plantillas.nombre"/>:</label>
											<input type="text" name="nombreCampo" class="form-control" id="nombreCampo_filter_table"/>
										</div>
									</div>						
								<!-- Fin campos del formulario de filtrado -->
								</div>				
								<!-- Botonera del formulario de filtrado -->
								<div id="CamposPlantilla_filter_buttonSet" class="right_buttons">
									<!-- Enlace de limpiar -->
									<a id="CamposPlantilla_filter_cleanLink" href="javascript:void(0)" class="rup-enlaceCancelar"><spring:message code="clear" /></a>
									<!-- Botón de filtrado -->
									<input id="CamposPlantilla_filter_filterButton" type="button" class="ui-button ui-widget ui-state-default ui-corner-all right blanco" value='<spring:message code="filter" />' />
								</div> 
							</fieldset>
						</form>
						<div id="CamposPlantilla_grid_div">
							<!-- Tabla -->
							<table id="CamposPlantilla"></table>
							<!-- Barra de paginación -->
							<div id="CamposPlantilla_pager"></div>
						</div>
					</div>
				</div>
			</div>
			<div class="panel panel-default">	
			<div class="panel-heading "><spring:message code="plantillas.objetosDocumento"/></div>
				<div class="panel-body">
					<!-- TABLA EN LA QUE SE INSERTARAN LOS REGISTROS SELECCIONADOS  -->
					<div id="CamposPlantillaSelec_div" class="rup-table-container">
						<div id="CamposPlantillaSelec_feedback"></div>						<!-- Feedback de la tabla --> 
						<div id="CamposPlantillaSelec_toolbar" class="blanco"> <!-- Botonera de la tabla -->
							<button id="btnAddTablaSelecc" class="btn-circle"><i class="fa fa-file-o" aria-hidden="true"></i></button>
							<button id="btnBorrarTablaSelecc" class="btn-circle"><i class="fa fa-trash-o" aria-hidden="true"></i></button>
						</div>								
						<div id="CamposPlantillaSelec_grid_div">
							<!-- Tabla -->
							<table id="CamposPlantillaSelec"></table>
							<!-- Barra de paginación -->
							<div id="CamposPlantillaSelec_pager"></div>
						</div>	
					</div>	
				</div>
			</div>
		</div>
	</div>	
</section>