<%@include file="/WEB-INF/includeTemplate.inc"%>
<%@page import="java.util.*" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<section>
	<div id="space"></div>
	<div class="container">

		<div class="panel panel-default">
			<div class="panel-heading"><spring:message code="procedimientos.busqueda"/></div>
				<div id="tablaProcedimientosFeedback"></div>
			<div class="panel-body">
				<div id="tablaProcedimientos_div" class="rup-table-container">
					<div id="tablaProcedimientos_feedback" class="hidden"></div>
					<div id="tablaProcedimientos_filter_div" class="rup-table-container">
						<form:form commandName="procedimientos" id="tablaProcedimientos_filter_form"  method="POST">
							<div class="row">
								<div class="col-xs-4 form-group">
									<label for="direccionesComboFiltro"><spring:message code="procedimientos.direccion"/></label>
									<form:select path="direcciones.idDireccion" id="direccionesComboFiltro" class="form-control"></form:select>
								</div>
								<div class="col-xs-2">
									<label for="codProcedureIdFiltro"><spring:message code="procedimientos.codProcedureId" /></label>
									<input type="text" id="codProcedureIdFiltro" name="codProcedureId" class="form-control" />
								</div>
								<div class="col-xs-4 text-right">
									<button class="btn btn-default btn-circle" id="btnBuscarProcedimientos" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.buscar" />'><i class="fa fa-search"></i></button>
									<button class="btn btn-default btn-circle" id="btnLimpiarProcedimientos" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.limpiar" />'><i class="fa fa-eraser"></i></button>
								</div>
							</div>
							
							<div id="descripcionCastellanoFiltroDiv" class="row">
								<div class="col-xs-8">
									<label for="descripcionCastellanoFiltro"><spring:message code="procedimientos.descFiltro" /></label>
									<input type="text" id="descripcionCastellanoFiltro" name="descripcionCastellano" class="form-control" />
								</div>
							</div>
							
							<div id="descripcionEuskeraFiltroDiv" class="row">
								<div class="col-xs-8">
									<label for="descripcionEuskeraFiltro"><spring:message code="procedimientos.descFiltro" /></label>
									<input type="text" id="descripcionEuskeraFiltro" name="descripcionEuskera" class="form-control" />
								</div>
							</div>
							
						</form:form>
						<div id="tablaProcedimientos_toolbar" class="mitoolbar clearfix">
							<button id="btnCopy" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="procedimientos.copiar" />'><i class="fa fa-copy" aria-hidden="true"></i></button>
							<button id="btnAdd" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="procedimientos.nuevo" />'><i class="fa fa-file-o" aria-hidden="true"></i></button>
							<button id="btnModif" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="procedimientos.editar" />'><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>
							<button id="btnBorrar" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="procedimientos.borrar" />'><i class="fa fa-trash-o" aria-hidden="true"></i></button>
						</div>
						
						<div id="tablaProcedimientos_grid_div">
							<!-- Tabla -->
							<table id="tablaProcedimientos" class="table"></table>
							<!-- Barra de paginación -->
							<div id="tablaProcedimientos_pager"></div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div id="tablaProcedimientos_filter_toolbar" style="visibility: hidden;"></div>
</section>

<!-- MODAL DETALLE -->
<div class="modal" id="procedimientosModal">
	<div class="modal-body">
		<form:form id="procedimientosModalForm" modelAttribute="procedimientos">
			<div id="procedimientosModalFeedback"></div>
			<input type="hidden" id="idProcedimientoModal" name="idProcedimiento" />
			<div class="row">
				<div class="col-xs-4 validation-label-fix">
					<label for="direccionesCombo" class="required"><spring:message code="procedimientos.direccion" /></label>
					<select id="direccionesCombo" name="direcciones.idDireccion" class="form-control"></select>
				</div>
				<div class="col-xs-4">
					<label for="areasCombo"><spring:message code="procedimientos.area" /></label>
					<select id="areasCombo" name="areas.idArea" class="form-control"></select>
				</div>
				<div class="col-xs-4 validation-label-fix">
					<label><spring:message code="procedimientos.inspeccionable" /></label>
					<div class="custom-control custom-radio custom-control-inline validation-label-fix">
					  	<input id="inspeccionableSi" type="radio" class="custom-control-input" name="inspeccionable" value="true">
					  	<label for="inspeccionableSi" class="custom-control-label radioLabel"><spring:message code="procedimientos.radioSi"/></label>
					  	<input id="inspeccionableNo" type="radio" class="custom-control-input procedimientosModalML" name="inspeccionable" value="false">
					  	<label for="inspeccionableNo" class="custom-control-label radioLabel"><spring:message code="procedimientos.radioNo"/></label>
					</div>
				</div>
			</div>
			
			<div class="row procedimientosModalMT">
				<div class="form-group col-xs-12">
					<label for="descripcionCastellanoModal" class="required"><spring:message code="procedimientos.descEs" /></label>
					<input type="text" id="descripcionCastellanoModal" name="descripcionCastellano" class="form-control" />
				</div>
			</div>
			<div class="row">
				<div class="form-group col-xs-12">
					<label for="descripcionEuskeraModal" class="required"><spring:message code="procedimientos.descEu" /></label>
					<input type="text" id="descripcionEuskeraModal" name="descripcionEuskera" class="form-control" />
				</div>
			</div>
			
			<div class="row">
				<div class="col-xs-6">
					<label for="codProcedureId" class="required"><spring:message code="procedimientos.codProcedureId" /></label>
					<input type="text" id="codProcedureId" name="codProcedureId" class="form-control" />
				</div>
			</div>
			
			<div class="row">
				<div class="col-xs-6">
					<label for="aplicacionNegocioModal"><spring:message code="procedimientos.aplicacionNegocio" /></label>
					<input type="text" id="aplicacionNegocioModal" name="aplicacionNegocio" class="form-control" />
				</div>
			</div>
			
			<div class="row procedimientosModalMT">
				<div class="col-xs-12">
					<label for="camposTituloExpediente" class="required"><spring:message code="procedimientos.camposTituloExpediente" /></label>
					<textarea id="camposTituloExpediente" name="camposTituloExpediente" class="form-control" rows="5"></textarea>
				</div>
			</div>
		</form:form>
		
		<section id="sectionTablaConfiguracion" class="hidden">
			<div id="space"></div>
			<div class="panel panel-default">
				<div class="panel-heading"><spring:message code="procedimientos.accionesTelematicas"/></div>
					<div id="tablaConfiguracionFeedback"></div>
				<div class="panel-body">
					<div id="tablaConfiguracion_div" class="rup-table-container">
						<div id="tablaConfiguracion_feedback" class="hidden"></div>
						<div id="tablaConfiguracion_filter_div" class="rup-table-container">
							<form:form commandName="configuracion" id="tablaConfiguracion_filter_form"  method="POST" class="hidden">
								<form:input path="codProcedureId" id="codProcedureIdFilter" class="form-control"></form:input>
							</form:form>
							<div id="tablaConfiguracion_toolbar" class="mitoolbar clearfix">
								<button id="btnAddConfiguracion" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="accionTelematica.nueva" />'><i class="fa fa-file-o" aria-hidden="true"></i></button>
								<button id="btnModifConfiguracion" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="accionTelematica.editar" />'><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>
								<button id="btnBorrarConfiguracion" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="accionTelematica.borrar" />'><i class="fa fa-trash-o" aria-hidden="true"></i></button>
							</div>
							
							<div id="tablaConfiguracion_grid_div">
								<!-- Tabla -->
								<table id="tablaConfiguracion" class="table"></table>
								<!-- Barra de paginación -->
								<div id="tablaConfiguracion_pager"></div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div id="tablaConfiguracion_filter_toolbar" style="visibility: hidden;"></div>
		</section>
	</div>
		
	<div class="modal-footer">
		<div class="row">
			<div class="col-xs-12 form-group">
				<button type="submit" class="btn btn-primary" id="procedimientosModalGuardar"><spring:message code="save" /></button>
				<button class="btn btn-light" id="procedimientosModalCancelar"><spring:message code="cancel" /></button>
			</div>
		</div>
	</div>
</div>

<!-- MODAL COPIAR PROCEDIMIENTO -->
<div class="modal" id="copiarProcedimientoModal">
	<div class="modal-body">
		<div id="copiarProcedimientoModalFeedback"></div>
		<form:form id="copiarProcedimientoModalForm" modelAttribute="procedimientos">
			<div class="row">
				<div class="form-group col-xs-12">
					<label for="codProcedureIdCopiaModal" class="required"><spring:message code="procedimientos.codProcedureId" /></label>
					<input type="text" id="codProcedureIdCopiaModal" name="codProcedureId" class="form-control" />
				</div>
			</div>
		</form:form>
	</div>
	<div class="modal-footer">
		<div class="row">
			<div class="col-xs-12 form-group">
				<button class="btn btn-primary" id="copiarProcedimientoGuardar"><spring:message code="save" /></button>
				<button class="btn btn-light" id="copiarProcedimientoCancelar"><spring:message code="cancel" /></button>
			</div>
		</div>
	</div>
</div>

<!-- MODAL ASIGNAR ACCIÓN TELEMÁTICA -->
<div class="modal" id="accionTelematicaModal">
	<div class="modal-body">	
		<div id="accionTelematicaModalFeedback"></div>
		<form:form id="accionTelematicaModalForm" modelAttribute="configuracion">
			<input type="hidden" id="idConfiguracionModal" name="idConfiguracion" />
			<input type="hidden" id="codProcedureIdAccionTelematica" name="codProcedureId" />
			<div class="row">
				<div class="col-xs-12 form-group validation-label-fix">
					<label for="comboAccionesTelematicas" class="required"><spring:message code="accionTelematica.titulo"/></label>
					<select name="configEventos.idConfigEventos" id="comboAccionesTelematicas" class="form-control"></select>
				</div>
			</div>
			<div class="row">
				<div class="col-xs-12 form-group">
					<label for="plsqlTextarea" class="required"><spring:message code="accionTelematica.plsql"/></label>
					<textarea name="plsqlCarga" id="plsqlTextarea" class="form-control" rows="5"></textarea>
				</div>
			</div>
		</form:form>
	</div>
	<div class="modal-footer">
		<div class="row">
			<div class="col-xs-12 form-group">
				<button class="btn btn-primary" id="accionTelematicaModalGuardar"></button>
				<button class="btn btn-light" id="accionTelematicaModalCancelar"><spring:message code="cancel" /></button>
			</div>
		</div>
	</div>
</div>