package com.ejie.ab61.serviciosWeb;

import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.ParameterStyle;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.context.support.SpringBeanAutowiringSupport;

import com.ejie.ab61.exceptions.Ab61Exception;
import com.ejie.ab61.model.serviciosWeb.BusquedasWS;
import com.ejie.ab61.model.serviciosWeb.inicioOficio.DatosInicioOficio;
import com.ejie.ab61.model.serviciosWeb.inicioOficio.InicioOficioTitularWS;
import com.ejie.ab61.model.serviciosWeb.inicioOficio.InicioOficioWS;
import com.ejie.ab61.service.serviciosWeb.ServiciosWebService;

@WebService(serviceName = "ab61WebService", portName = "ab61WebServicePort", targetNamespace = "http://com.ejie.ab61.serviciosWeb")
@SOAPBinding(parameterStyle = ParameterStyle.WRAPPED)
public class WebServiceImpl extends SpringBeanAutowiringSupport {

	@Autowired
	ServiciosWebService serviciosWebService;

	@WebMethod
	public String generarExcelListados(@WebParam(name = "idListado") Integer idListado,
			@WebParam(name = "listaBusqueda") List<BusquedasWS> listaBusquedas,
			@WebParam(name = "aplicacion") String aplicacion) throws Ab61Exception {

		return serviciosWebService.generarExcelListados(idListado, listaBusquedas, aplicacion);
	}

	@WebMethod
	public String descargarDocumento(@WebParam(name = "idPlantilla") Integer idPlantilla,
			@WebParam(name = "procedureId") String procedureId, @WebParam(name = "foderId") String foderId,
			@WebParam(name = "aplicacion") String aplicacion) throws Ab61Exception {

		return serviciosWebService.descargarDocumento(idPlantilla, procedureId, foderId, aplicacion);

	}

	@WebMethod
	public String generarDocumento(@WebParam(name = "idPlantilla") Integer idPlantilla,
			@WebParam(name = "procedureId") String procedureId, @WebParam(name = "foderId") String foderId,
			@WebParam(name = "usuario") String usuario) throws Ab61Exception {

		return serviciosWebService.generarDocumento(idPlantilla, procedureId, foderId, usuario);

	}

	@WebMethod
	public String modificarDocumento(@WebParam(name = "idPlantilla") Integer idPlantilla,
			@WebParam(name = "procedureId") String procedureId, @WebParam(name = "foderId") String foderId,
			@WebParam(name = "usuario") String usuario) throws Ab61Exception {
		return serviciosWebService.modificarDocumento(idPlantilla, procedureId, foderId, usuario);

	}

	@WebMethod
	public String aportarDocumento(@WebParam(name = "idPlantilla") Integer idPlantilla,
			@WebParam(name = "procedureId") String procedureId, @WebParam(name = "folderId") String folderId,
			@WebParam(name = "n38Login") String n38Login, @WebParam(name = "usuario") String usuario)
			throws Ab61Exception {

		return serviciosWebService.aportarDocumento(idPlantilla, folderId, procedureId, n38Login, usuario);
	}

	@WebMethod
	public String eliminarDocumento(@WebParam(name = "idPlantilla") Integer idPlantilla,
			@WebParam(name = "foderId") String foderId, @WebParam(name = "procedureId") String procedureId)
			throws Ab61Exception {
		return serviciosWebService.eliminarDocumento(idPlantilla, foderId, procedureId);

	}

	@WebMethod
	public DatosInicioOficio generarInicioOficio(@WebParam(name = "inicioOficioWS") InicioOficioWS inicioOficioWS)
			throws Ab61Exception {
		return serviciosWebService.generarInicioOficio(inicioOficioWS);

	}

	@WebMethod
	public DatosInicioOficio generarInicioOficioTitular(
			@WebParam(name = "inicioOficioTitularWS") InicioOficioTitularWS inicioOficioTitularWS)
			throws Ab61Exception {
		return serviciosWebService.generarInicioOficioTitular(inicioOficioTitularWS);
	}

}
