var tipoGuardar;
var filaSeleccionadaConfigEventos;
var datosFilaConfigEventos;

jQuery(function($) {
	
	//Ocultar / mostrar opciones del menú
	$("#mnFichaExpediente").hide();
	$("#mnListados").hide();
	$("#mnMantenimientoTablas").show();
	$("#mnMantenimientoListados").show();
	$("#mnMantenimientoPlantillas").show();
	$("#mnMantenimientoModuloAdministrativo").show();
	$("#mnMantenimientoTablas").addClass("active");
	
	//Feedback tabla configuración de eventos
	$("#tablaConfigEventosFeedback").rup_feedback({
		gotoTop: false,
		block: false,
		closeLink: true
	});
	
	//Feedback modal detalle configuración de eventos
	$("#configEventosModalFeedback").rup_feedback({
		gotoTop: false,
		block: false,
		closeLink: true
	});
	
	//Modal detalle configuración de eventos
	$("#configEventosModal").rup_dialog({
		autoOpen: false,
		width: 700,
		modal: true,
		position: { my: "center center" },
		title: $.rup.i18n.app.configEventos.configurar,
		type: $.rup.dialog.DIV,
		close: function(){
			$("#configEventosModalForm")[0].reset();
		},
		open: function(){
			filaSeleccionadaConfigEventos = $("#tablaConfigEventos").rup_table("getSelectedRows")[0];
			datosFilaConfigEventos = $("#tablaConfigEventos").rup_table("getRowData", filaSeleccionadaConfigEventos);
			
			if(datosFilaConfigEventos.numeroConfiguraciones > 0 && tipoGuardar === "PUT"){
				$("#tipoEventoModal").prop("disabled", true);
				$("#configuracionModal").prop("disabled", true);
				$("#plateaTypeModal").prop("disabled", true);
				$("#plateaSubtypeModal").prop("disabled", true);
			} else{
				$("#tipoEventoModal").prop("disabled", false);
				$("#configuracionModal").prop("disabled", false);
				$("#plateaTypeModal").prop("disabled", false);
				$("#plateaSubtypeModal").prop("disabled", false);
			}
			
			desbloquearInterfaz();
		}
	});
	
	//TABLA CONFIGURACIÓN DE EVENTOS
	$("#tablaConfigEventos").rup_table({
		url: "/ab61WebAppWar/configEventos",
		headertitles: true,
		autowidth: true,
		colNames: [
				   '',
				   '',
				   $.rup.i18n.app.tablaMantenimientoConfigEventos.descripcion,
				   $.rup.i18n.app.tablaMantenimientoConfigEventos.tipoEvento,
				   $.rup.i18n.app.tablaMantenimientoConfigEventos.plateaType,
				   $.rup.i18n.app.tablaMantenimientoConfigEventos.plateaSubtype,
				   $.rup.i18n.app.tablaMantenimientoConfigEventos.configuracion
		          ],
      colModel: [{
				   name: "idConfigEventos",
				   label: "idConfigEventos",
				   hidden: true
			  },{
				   name: "numeroConfiguraciones",
				   label: "numeroConfiguraciones",
				   hidden: true
			  },{
				   name: ("eu" === $.rup_utils.get("language")) ? "descripcionEuskera" : "descripcionCastellano",
				   label: ("eu" === $.rup_utils.get("language")) ? "descripcionEuskera" : "descripcionCastellano",
				   align: "center"
			  },{
				   name: "tipoEvento",
				   label: "tipoEvento",
				   align: "center"
			  },{
				   name: "plateaType",
				   label: "plateaType",
				   align: "center"
			  },{
				   name: "plateaSubtype",
				   label: "plateaSubtype",
				   align: "center"
			  },{
				   name: "configuracion",
				   label: "configuracion",
				   align: "center"
			  }],
		model: "ConfigEventos",
		loadComplete:function (){
			$("#tablaConfigEventos").setSelection($("#tablaConfigEventos .jqgrow").attr("id"));
			if($("#tablaConfigEventos").rup_table("getDataIDs").length === 0){
				$("#btnModifConfigEventos").addClass("ui-widget ui-button-disabled ui-state-disabled");
				$("#btnBorrarConfigEventos").addClass("ui-widget ui-button-disabled ui-state-disabled");
			} else{
				$("#btnModifConfigEventos").removeClass("ui-widget ui-button-disabled ui-state-disabled");
				$("#btnBorrarConfigEventos").removeClass("ui-widget ui-button-disabled ui-state-disabled");
			}
		},
		usePlugins: [
			"responsive",
			"feedback",
			"toolbar",
			"filter"
		],
		multiselect: false,
		loadOnStartUp : true,
		primaryKey: "idConfigEventos",
		sortname: ("eu" === $.rup_utils.get("language")) ? "descripcionEuskera" : "descripcionCastellano",
		sortorder : "asc"
	});
	
	//Botón nueva configuración de eventos
	$("#btnAddConfigEventos").click(function(){
		bloquearInterfaz();
		tipoGuardar = "POST";
		$("#configEventosModal").rup_dialog("open");
	});
	
	//Botón editar congiguración de eventos
	$("#btnModifConfigEventos").click(function(){
		bloquearInterfaz();
		tipoGuardar = "PUT";
		recuperarConfigEventos();
	});
	
	//Botón eliminar configuración de eventos
	$("#btnBorrarConfigEventos").click(function(){
		
		filaSeleccionadaConfigEventos = $("#tablaConfigEventos").rup_table("getSelectedRows")[0];
		datosFilaConfigEventos = $("#tablaConfigEventos").rup_table("getRowData", filaSeleccionadaConfigEventos);
		
		if(datosFilaConfigEventos.numeroConfiguraciones > 0){
			$("#tablaConfigEventosFeedback").rup_feedback("set", $.rup.i18n.app.configEventos.registroSecundario, "alert")
		} else{
			$.rup_messages("msgConfirm", {
				title:  $.rup.i18n.app.configEventos.borrar,
				message: $.rup.i18n.app.configEventos.borrarConfirm,
				OKFunction: function(){
					bloquearInterfaz();
					$.ajax({
						url: "/ab61WebAppWar/configEventos/" + $("#tablaConfigEventos").rup_table("getGridParam", "selrow"),
						type: "DELETE",
						success: function(){
							$("#tablaConfigEventosFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.OK.datos_eliminados_OK, "ok");
							$("#tablaConfigEventos").trigger("reloadGrid");
							desbloquearInterfaz();
						},
						error: function(){
							$("#tablaConfigEventosFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_elimados_error, "error");
							desbloquearInterfaz();
						}
					});
				}
			});
		}
	});
	
	//Botón exportar a Excel configuración de eventos
	$("#btnExcelConfigEventos").click(function(){
		
		var numeroFilas = $("#tablaConfigEventos").rup_table("getDataIDs").length;
		if(numeroFilas === 0){
			$("#tablaConfigEventosFeedback").rup_feedback("set",$.rup.i18n.app.mensajes.tablaVaciaExport, "alert");
		}else{
			excelConfigEventos_handleReport();
		}
		
	});
	
	//Botón cancelar modal configuración de eventos
	$("#configEventosModalCancelar").click(function(){
		$("#configEventosModal").rup_dialog("close");
	});
	
	//Botón guardar configuración de eventos
	$("#configEventosModalGuardar").click(function(){
		bloquearInterfaz();
		$("#configEventosModalForm").rup_form({
			feedback: $("#configEventosModalFeedback"),
			url: "/ab61WebAppWar/configEventos",
			type: tipoGuardar,
			dataType: "json",
			validate: {
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: false,
				showFieldErrorsInFeedback: true,
				rules: {
					"tipoEvento" 			: { maxlength : 20 },
					"plateaType"	  		: { maxlength : 50 },
					"plateaSubtype"	  		: { maxlength : 64 },
					"configuracion"			: { number : true },
					"descripcionCastellano" : { maxlength : 250 },
					"descripcionEuskera"	: { maxlength : 250 },
				}
			},
			success: function(){
				$("#tablaConfigEventos").trigger("reloadGrid");
				$("#configEventosModal").rup_dialog("close");
				$("#tablaConfigEventosFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.OK.datos_guardados_OK, "ok");
			},
			error: function(){
				$("#configEventosModalFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_guardados_error, "error");
			}
		});
		
		$("#configEventosModalForm").submit();
		desbloquearInterfaz();
		
	});
	
});

//Recuperar ConfigEventos a editar
function recuperarConfigEventos(){
	$.ajax({
		type: "GET",
		url:"/ab61WebAppWar/configEventos/" + $("#tablaConfigEventos").rup_table("getGridParam", "selrow"),
		dataType:"json",
		success: function(data){
			$("#idConfigEventosModal").val(data.idConfigEventos);
			$("#tipoEventoModal").val(data.tipoEvento);
			$("#configuracionModal").val(data.configuracion);
			$("#plateaTypeModal").val(data.plateaType);
			$("#plateaSubtypeModal").val(data.plateaSubtype);
			$("#descripcionCastellanoModal").val(data.descripcionCastellano);
			$("#descripcionEuskeraModal").val(data.descripcionEuskera);
			$("#configEventosModal").rup_dialog("open");
			desbloquearInterfaz();
		},
		error: function(){
			$("#tablaConfigEventosFeedback").rup_feedback("set", $.rup.i18n.app.configEventos.recuperarConfigEventosError, "error");
			desbloquearInterfaz();
		}
	});
}

//Mostrar los resultados del Excel en el mismo orden en el que se ven en la tabla (Configuración de eventos)
function excelConfigEventos_handleReport(){
	var sord = $("#tablaConfigEventos").rup_table('getGridParam','sortorder'); 
	var sidx = $("#tablaConfigEventos").rup_table('getGridParam','sortname'); 
	window.open("/ab61WebAppWar/configEventos/xlsReport?"+$('#configEventos_Report').serialize()+"&sord="+sord+"&sidx="+sidx);
}