var tipoGuardar;

jQuery(function($) {
	
	//Ocultar / mostrar opciones del menú
	$("#mnFichaExpediente").hide();
	$("#mnListados").hide();
	$("#mnMantenimientoTablas").show();
	$("#mnMantenimientoListados").show();
	$("#mnMantenimientoPlantillas").show();
	$("#mnMantenimientoModuloAdministrativo").show();
	$("#mnMantenimientoTablas").addClass("active");
	
	//Feedback tabla parámetros de configuración
	$("#tablaParametrosConfigFeedback").rup_feedback({
		gotoTop: false,
		block: false,
		closeLink: true
	});
	
	//Feedback modal detalle parámetros de configuración
	$("#parametrosConfigModalFeedback").rup_feedback({
		gotoTop: false,
		block: false,
		closeLink: true
	});
	
	//Modal detalle parámetros de configuración
	$("#parametrosConfigModal").rup_dialog({
		autoOpen: false,
		width: 700,
		modal: true,
		position: { my: "center center" },
		title: $.rup.i18n.app.parametrosConfig.configurar,
		type: $.rup.dialog.DIV,
		close: function(){
			$("#parametrosConfigModalForm")[0].reset();
		},
		open: function(){
			desbloquearInterfaz();
		}
	});
	
	//TABLA PARÁMETROS DE CONFIGURACIÓN
	$("#tablaParametrosConfig").rup_table({
		url: "/ab61WebAppWar/parametrosConfig",
		headertitles: true,
		autowidth: true,
		colNames: [
				   '',
				   $.rup.i18n.app.tablaMantenimientoParametrosConfig.descripcion,
				   $.rup.i18n.app.tablaMantenimientoParametrosConfig.valor,
				   $.rup.i18n.app.tablaMantenimientoParametrosConfig.observaciones
		          ],
      colModel: [{
				   name: "idParametroConfig",
				   label: "idParametroConfig",
				   hidden: true
			  },{
				   name: "descripcion",
				   label: "descripcion",
				   align: "center"
			  },{
				   name: "valor",
				   label: "valor",
				   align: "center"
			  },{
				  name: "observaciones",
				  label: "observaciones",
				  align: "center"
			  }],
		model: "ParametrosConfig",
		loadComplete:function (){
			$("#tablaParametrosConfig").setSelection($("#tablaParametrosConfig .jqgrow").attr("id"));
			if($("#tablaParametrosConfig").rup_table("getDataIDs").length === 0){
				$("#btnModifParametrosConfig").addClass("ui-widget ui-button-disabled ui-state-disabled");
				$("#btnBorrarParametrosConfig").addClass("ui-widget ui-button-disabled ui-state-disabled");
			} else{
				$("#btnModifParametrosConfig").removeClass("ui-widget ui-button-disabled ui-state-disabled");
				$("#btnBorrarParametrosConfig").removeClass("ui-widget ui-button-disabled ui-state-disabled");
			}
		},
		usePlugins: [
			"responsive",
			"feedback",
			"toolbar",
			"filter"
		],
		multiselect: false,
		loadOnStartUp : true,
		primaryKey: "idParametroConfig",
		sortname: "idParametroConfig",
		sortorder : "desc"
	});
	
	//Botón nuevo parámetro de configuración
	$("#btnAddParametrosConfig").click(function(){
		bloquearInterfaz();
		tipoGuardar = "POST";
		$("#parametrosConfigModal").rup_dialog("open");
	});
	
	//Botón editar parámetro de configuración
	$("#btnModifParametrosConfig").click(function(){
		bloquearInterfaz();
		tipoGuardar = "PUT";
		recuperarParametrosConfig();
	});
	
	//Botón eliminar parámetro de configuración
	$("#btnBorrarParametrosConfig").click(function(){
		$.rup_messages("msgConfirm", {
			title: $.rup.i18n.app.parametrosConfig.borrar,
			message: $.rup.i18n.app.parametrosConfig.borrarConfirm,
			OKFunction: function(){
				bloquearInterfaz();
				$.ajax({
					url: "/ab61WebAppWar/parametrosConfig/" + $("#tablaParametrosConfig").rup_table("getGridParam", "selrow"),
					type: "DELETE",
					success: function(){
						$("#tablaParametrosConfigFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.OK.datos_eliminados_OK, "ok");
						$("#tablaParametrosConfig").trigger("reloadGrid");
						desbloquearInterfaz();
					},
					error: function(){
						$("#tablaParametrosConfigFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_elimados_error, "error");
						desbloquearInterfaz();
					}
				});
			}
		});
	});
	
	//Botón cancelar modal parametros de configuración
	$("#parametrosConfigModalCancelar").click(function(){
		$("#parametrosConfigModal").rup_dialog("close");
	});
	
	//Botón guardar parámetros de configuración
	$("#parametrosConfigModalGuardar").click(function(){
		bloquearInterfaz();
		$("#parametrosConfigModalForm").rup_form({
			feedback: $("#parametrosConfigModalFeedback"),
			url: "/ab61WebAppWar/parametrosConfig",
			type: tipoGuardar,
			dataType: "json",
			validate: {
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: false,
				showFieldErrorsInFeedback: true,
				rules: {
					"descripcion"  : { maxlength : 200 },
					"valor"		   : { maxlength : 200 },
					"observaciones": { maxlength : 500 }
				}
			},
			success: function(){
				$("#tablaParametrosConfig").trigger("reloadGrid");
				$("#parametrosConfigModal").rup_dialog("close");
				$("#tablaParametrosConfigFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.OK.datos_guardados_OK, "ok");
			},
			error: function(){
				$("#parametrosConfigModalFeedback").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_guardados_error, "error");
			}
		});
		
		$("#parametrosConfigModalForm").submit();
		desbloquearInterfaz();
		
	});
	
});

//Recuperar ParametrosConfig a editar
function recuperarParametrosConfig(){
	$.ajax({
		type: "GET",
		url: "/ab61WebAppWar/parametrosConfig/" + $("#tablaParametrosConfig").rup_table("getGridParam", "selrow"),
		dataType: "json",
		success: function(data){
			$("#idParametrosConfigModal").val(data.idParametroConfig);
			$("#descripcionModal").val(data.descripcion);
			$("#valorModal").val(data.valor);
			$("#observacionesModal").val(data.observaciones);
			$("#parametrosConfigModal").rup_dialog("open");
			desbloquearInterfaz();
		},
		error: function(){
			$("#tablaParametrosConfigFeedback").rup_feedback("set", $.rup.i18n.app.parametrosConfig.recuperarParametrosConfigError, "error");
			desbloquearInterfaz();
		}
	});
}