jQuery(function($) {

	$("#mnFichaExpediente").hide();
	$("#mnListados").hide();
	$("#mnMantenimientoTablas").show();
	$("#mnMantenimientoListados").show();
	$("#mnMantenimientoPlantillas").show();
	$("#mnMantenimientoModuloAdministrativo").show();
	
	
	$("#mnMantenimientoListados").addClass("active");
	
	$('#btnAdd').addClass("ui-widget ui-button-disabled ui-state-disabled");
	$('#btnModif').addClass("ui-widget ui-button-disabled ui-state-disabled");
	$('#btnBorrar').addClass("ui-widget ui-button-disabled ui-state-disabled");
	
	//COMBO PROCEDIMIENTOS
	$("#idProcedimiento").rup_combo({
		source: "/ab61WebAppWar/procedimientos",
		blank: "0",
		sourceParam: {
			label: "descripcionConCodProcedure",
			value: "idProcedimiento"
		},
		//CARGAR LA TABLA CON LA OPCION SELECCIONADA
		select: function() {
			$("#tbllistados").trigger("reloadGrid");		
			$('#btnAdd').removeClass("ui-widget ui-button-disabled ui-state-disabled");
		},onLoadSuccess : function() {
			if (null != $("#procedimientoRefrescar").val() && "" != $("#procedimientoRefrescar").val()) {
				$("#idProcedimiento").rup_combo("setRupValue", $("#procedimientoRefrescar").val());
				$('#btnAdd').removeClass("ui-widget ui-button-disabled ui-state-disabled");
				$("#tbllistados").trigger("reloadGrid");				
			}
		},
		width : $("#idProcedimiento").parent().width()
		//width: 500
	});
	
	//TABLA LISTADOS
	$("#tbllistados").rup_table({
		url: "/ab61WebAppWar/listados",
		headertitles: true,
		autowidth: true,
		colNames: [
				   '',
				   $.rup.i18n.app.tablaListados.descripcion
		          ],
      colModel: [{
				   name: "idRelLisPro",
				   label: "idRelLisPro",
				   hidden: true
			  },{
				  name: ("eu" === $.rup_utils.get("language")) ? "descripcionEuskera" : "descripcionCastellano",
				   label: "descripcionCastellano",				   
				   width: 150
			  }],
		model: "RelLisPro",
		loadComplete:function (){
			 $("#tbllistados").setSelection($("#tbllistados .jqgrow").attr("id"));	
			 if ($("#tbllistados .jqgrow").attr("id") === undefined)
			 {
				 $('#btnModif').addClass("ui-widget ui-button-disabled ui-state-disabled");
				 $('#btnBorrar').addClass("ui-widget ui-button-disabled ui-state-disabled");
			 }
			 else
			 {
				 $('#btnModif').removeClass("ui-widget ui-button-disabled ui-state-disabled");
				 $('#btnBorrar').removeClass("ui-widget ui-button-disabled ui-state-disabled");
			 }
		},
		usePlugins: [
			"responsive",
			"feedback",
			"toolbar",
			"filter"
		],
    	core : {
			showOperations : {
				"clone" : false
			}
    	},
		multiselect: false,
		loadOnStartUp : false,
		primaryKey: "idRelLisPro",
		sortorder : "asc"
	});
	
		
	$('#btnModif').on("click",function () {
		abrirDialog("/ab61WebAppWar/listados/modificar/" + $("#tbllistados").rup_table("getGridParam", "selrow") +"/"+ $("#idProcedimiento").val());
	});
	$('#btnAdd').on("click",function () {
		abrirDialog("/ab61WebAppWar/listados/anyadir/" + $("#idProcedimiento").val());
	});
	$('#btnBorrar').on("click",function () {
		bloquearInterfaz();
		$.ajax({
	        url: "/ab61WebAppWar/listados/"+$("#tbllistados").rup_table("getGridParam", "selrow"),
	        type: "DELETE",
	        success: function() {
	        	$("#id_capa").rup_feedback({ gotoTop : true, block : false, closeLink : true });
				$("#id_capa").rup_feedback("set",$.rup.i18n.app.mensajes.OK.datos_eliminados_OK, "ok");
				$("#tbllistados").trigger("reloadGrid");
				desbloquearInterfaz();
	        },
	        error: function() {
	        	$("#id_capa").rup_feedback({ gotoTop : true, block : false, closeLink : true });
	        	$("#id_capa").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_elimados_error, "error");
	        	desbloquearInterfaz();
	        }
	    });
	});
});

function abrirDialog(urlDestino) {
	 $("#tbllistados_detail_div").rup_dialog({
		type: $.rup.dialog.AJAX,
		url: urlDestino ,
		autoOpen: true,
		modal: true,
		width:550,
		resizable: true,
		closeOnEscape:false,
		ajaxOptions: {
			success: function (){
				desbloquearInterfaz();
			}
		}, 
		title: $.rup.i18n.app.tablaParametro.agregarRegistro,
		buttons: [{
			text: $.rup.i18n.app.aceptar,
			click: function () { 
					guardarListado();
				},
			},
			{
				text: $.rup.i18n.app.cerrar,
				btnType: $.rup.dialog.LINK,
				click: function () {
					$("#tbllistados_detail_div").rup_dialog("close");
					refrescarPagina('listados', $("#idProcedimiento").val());
				}
			}
		]
	});	
}

function guardarListado(){
	$("#listadosForm").rup_form({
		url:"/ab61WebAppWar/listados/modif",
		type : "POST",
		dataType : 'json',
		success:function(data){
			$("#listados_feedback").rup_feedback({ gotoTop : true, block : false, closeLink : true });
			$("#listados_feedback").rup_feedback("set",$.rup.i18n.app.mensajes.OK.datos_guardados_OK, "ok");
			$("#tbllistados").trigger("reloadGrid");	
			$("#idListado").val(data.idListado);
			$("#idListadoFormListados").val(data.idListado);
			
       		$("#tbllistados_detail_div").rup_dialog("close");
       		desbloquearInterfaz();
		},
		error : function(){
			$("#listados_feedback").rup_feedback({ gotoTop : true, block : false, closeLink : true });
        	$("#listados_feedback").rup_feedback("set", $.rup.i18n.app.mensajes.error.datos_guardados_error, "error");        	
			desbloquearInterfaz();
		}
	});
	bloquearInterfaz();
	$("#listadosForm").submit();
}
