jQuery(function($){

	$("#mnFichaExpediente").hide();
	$("#mnListados").hide();
	$("#mnMantenimientoTablas").show();
	$("#mnMantenimientoListados").show();
	$("#mnMantenimientoPlantillas").show();
	$("#mnMantenimientoModuloAdministrativo").show();
	
	$("#mnMantenimientoPlantillas").addClass("active");
	
	$("#tiposPlantilla").rup_table({
		
		url: "/ab61WebAppWar/tiposplantilla",
		colNames: [
			"idTipoPlantilla",
			$.rup.i18n.app.tablaMantenimientoTiposPlantilla.descripcion,
			$.rup.i18n.app.tablaMantenimientoTiposPlantilla.taskId,
			$.rup.i18n.app.tablaMantenimientoTiposPlantilla.proceedingId,
			$.rup.i18n.app.tablaMantenimientoTiposPlantilla.taskType,
			$.rup.i18n.app.tablaMantenimientoTiposPlantilla.documentroleId,
			"documentroleNameCas",
			"documentroleNameEus"			
		],
		colModel: [
			{ 	
				name: "idTipoPlantilla", 
			 	label: "idTipoPlantilla",
				hidden: true
			},
			{ 	
				name: (("eu"==$.rup_utils.get("language")) ? "descripcionEuskera": "descripcionCastellano"),
				label: (("eu"==$.rup_utils.get("language")) ? "descripcionEuskera": "descripcionCastellano"),
				align: "left", 
				width: 150, 
				hidden: false 
			},
			{ 	
				name: "taskId",
				label: "taskId",
				align: "left", 
				width: 150, 
				
			},
			{ 	
				name: "proceedingId",
				label: "proceedingId",
				align: "left", 
				width: 150, 
				
			},
			{ 	
				name: "taskType",
				label: "taskType",
				align: "left", 
				width: 150, 
				
			},
			{ 	
				name: "documentroleId",
				label: "documentroleId",
				align: "left", 
				width: 150, 
	
			},
			{ 	
				name: "documentroleNameCas",
				label: "documentroleNameCas",
				align: "left", 
				width: 150, 
				hidden: true 
			},
			{ 	
				name: "documentroleNameEus",
				label: "documentroleNameEus",
				align: "left", 
				width: 150, 
				hidden: true 
			}
        ],

        model:"TiposPlantilla",
        usePlugins:[
			"formEdit",
        	"feedback",
			"toolbar",
        	"responsive",
        	"report"
         	],
		primaryKey: "idTipoPlantilla",
		sortname: "idTipoPlantilla",
		sortorder: "asc",
    	core : {
			showOperations : {
				"clone" : false
			}
    	},		
		loadOnStartUp: true,
		rowNum:20,
        formEdit:{
        	detailForm: "#tiposPlantilla_detail_div",
			fillDataMethod: "clientSide",
         	validate:{ 
    			rules:{
    				"descripcionCastellano":{
						required: true,
						maxlength : 100
    					},
    				"descripcionEuskera":{
						required: true,
						maxlength : 100
    					},
        			"taskId":{
   						required: false,
   						maxlength : 100
       					},
        			"proceedingId":{
   						required: false,
   						maxlength : 100
       					},
            		"taskType":{
       					required: false,
       					maxlength : 50
           			},
        			"title":{
   						required: false,
   						maxlength : 100
       					},
        			"documentroleId":{
   						required: false,
   						maxlength : 100
       					},
        			"documentroleNameEus":{
   						required: false,
   						maxlength : 200
       					},
        			"documentroleNameCas":{
   						required: false,
   						maxlength : 200
       					}    					
    				}
    		}
        },
        report: {
 			buttons:[
 				{id:"reports", i18nCaption:"INFORMES", right:true,
 					buttons:[
 						{ i18nCaption:"XLS", 
 							url: "../tiposplantilla/xlsReport",
 							css : "fa fa-file-excel-o",
 						}
 					 ]
 				}
 			],			
 		},
	});
	
	
	$("#tiposPlantilla").on("jqGridAddEditClickSubmit", function(rowid,callback,url,op){

		$("#id_capa").rup_feedback({ gotoTop : true, block : false, closeLink : true });
		if(op=="edit"){
			$("#id_capa").rup_feedback("set", $.rup.i18n.app.mensajes.datos_modificado, "ok");
		}else{
			$("#id_capa").rup_feedback("set", $.rup.i18n.app.mensajes.datos_ok, "ok");
		}
	});
	
	$("#tiposPlantilla").on("rupTableAfterDelete", function(data, textStatus, xhr){
		
		$("#id_capa").rup_feedback({ gotoTop : true, block : false, closeLink : true });
		$("#id_capa").rup_feedback("set", $.rup.i18n.app.mensajes.datos_borrado, "ok");

	});
	
	
	$('[id = tiposPlantilla_toolbar##btnAdd]').rup_tooltip({
		content:{
			text:$.rup.i18n.app.anadir
		},
		position:{
			my: 'bottom center',
			at: 'top center',
		}
	});		
	
	$('[id = tiposPlantilla_toolbar##btnEdit]').rup_tooltip({
		content:{
			text:$.rup.i18n.app.editar
		},
		position:{
			my: 'bottom center',
			at: 'top center',
		}
	});	
	
	$('[id = tiposPlantilla_toolbar##btnDelete]').rup_tooltip({
		content:{
			text:$.rup.i18n.app.eliminar
		},
		position:{
			my: 'bottom center',
			at: 'top center',
		}
	});	
});