jQuery(function($){
	desbloquearInterfaz();
	// Creamos el área de mensajes dentro de la tabla de incidentes
	$("#feedbackMensajesParticipantes").rup_feedback({
		type : "ok",
		closeLink : true,
		block : false,
		gotoTop : false
	});

	$("#idComboSexo").rup_combo({
		blank:"",
		source: "/ab61WebAppWar/sexos/verValorCombo",
		sourceParam: {
		    label: (("eu"==$.rup_utils.get("language")) ? "descripcionEuskera": "descripcionCastellano"),
			value: "idSexo"
		},
		width : 200
	});
	//poner value del input cero a vacio
	 if(undefined == $("#idComboSexo").val()){
		 $("#idComboSexo").val(0);
	 }
	$("#idComboTipoDocumentoParticipante").rup_combo({
		blank:"",
		source : "/ab61WebAppWar/tiposdocumento/verValorCombo",
		sourceParam : {
			label : (("eu" == $.rup_utils.get("language")) ? "descripcionEuskera"
					: "descripcionCastellano"),
			value : "idTipoDocumento"
		},
		width : 200,
		select: function(){
			cambiarObligatorios();
		}
	});
	
	$("#formParticipantesModal").rup_form({
		url : "/ab61WebAppWar/solicitantes",
		type : "POST",
		dataType : 'json',
		success : function(resultado) {
			$("#feedbackMensajesParticipantes").rup_feedback("set",$.rup.i18n.app.mensajes.OK.datos_guardados_OK,"ok");
			bloquearInterfaz();
			window.parent.accederMenu('relexpter');
		},
		error : function(result, ajaxOptions, thrownError) {
			$("#feedbackMensajesParticipantes").rup_feedback("set",$.rup.i18n.app.mensajes.error.datos_guardados_error,"error");
			//bloquearInterfaz();
			//window.parent.accederMenu('relexpter');
		},
		validate : {
			
			focusCleanup: true,
			focusInvalid: false,
			onkeyup: false,
			onclick: false,
			rules : {
				"numero" : {
					maxlength : 12
				},
				"idComboTipoDocumento" : {
					required : true
				},
				"nombre" : {
					maxlength : 260
				},
				"apellido1" : {
					maxlength : 260
				},
				"apellido2" : {
					maxlength : 260
				},
				"porcentajeParticipacion" : {
					number : true
				}
			}
		}
	});
	$("#btnGuardar").click(function() {
		var numeroIdentificativo = validarDNICIFNIEPASAPORTEModal($("#numeroParticipante").val(),$("#idComboTipoDocumentoParticipante").val())
		if (numeroIdentificativo) {
			$("#formParticipantesModal").submit();
		}else{
			$("#feedbackMensajesParticipantes").rup_feedback("set",$.rup.i18n.app.validaciones.participantes.numero, "error");
		}
	});
	function cambiarObligatorios(){
		var apellido1 = $("#apellido1");
		var apellido2 = $("#apellido2");
		var sexo = $("#idComboSexo");
		switch($("#idComboTipoDocumentoParticipante").val()) {
			case "1":
				//DNI
				apellido1.attr("required","required");
				$("#apellido1Div").show();
				apellido2.attr("required","required");
				$("#apellido2Div").show();
				sexo.attr("required","required");
				$("#sexoDiv").show();
				break;
			case "2":
				//CIF
				apellido1.removeAttr("required");
				$("#apellido1Div").hide();
				apellido2.removeAttr("required");
				$("#apellido2Div").hide();
				sexo.removeAttr("required");
				$("#sexoDiv").hide();
				break;
			case "3": case "4": case "5":
				//NIE PASAPORTE OTROS
				apellido1.removeAttr("required");
				$("#apellido1Div").hide();
				apellido2.removeAttr("required");
				$("#apellido2Div").hide();
				sexo.attr("required","required");
				$("#sexoDiv").show();
				break;
			default:
				return true;
		}
	}
	function validateDNIModal(dni) {
		var lockup = 'TRWAGMYFPDXBNJZSQVHLCKE';
		var valueDni = dni.substr(0, dni.length - 1);
		var letra = dni.substr(dni.length - 1, 1).toUpperCase();

		if (lockup.charAt(valueDni % 23) == letra){
			return true;
		}
		return false;
	}

	function validatePASAPORTEModal(pasaporte) {
		if (!/^[a-z]{3}[0-9]{6}[a-z]?$/i.test(pasaporte)){
			return true;
		}
		return false;
	}

	function validateCIFModal(cif) {
		cif = cif.toUpperCase();
		if (!cif || cif.length !== 9) {
			return false;
		}
		var letters = [ 'J', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I' ];
		var digits = cif.substr(1, cif.length - 2);
		var letter = cif.substr(0, 1);
		var control = cif.substr(cif.length - 1);
		var sum = 0;
		var i;
		var digit;

		if (!letter.match(/[A-Z]/)) {
			return false;
		}
		for (i = 0; i < digits.length; ++i) {
			digit = parseInt(digits[i]);

			if (isNaN(digit)) {
				return false;
			}

			if (i % 2 === 0) {
				digit *= 2;
				if (digit > 9) {
					digit = parseInt(digit / 10) + (digit % 10);
				}
				sum += digit;
			} else {
				sum += digit;
			}
		}
		sum %= 10;
		if (sum !== 0) {
			digit = 10 - sum;
		} else {
			digit = sum;
		}

		if (letter.match(/[ABEH]/)) {
			return String(digit) === control;
		}
		if (letter.match(/[NPQRSW]/)) {
			return letters[digit] === control;
		}

		return String(digit) === control || letters[digit] === control;
	}
	function validateNIEModal(nie) {
		"use strict";
		nie = nie.toUpperCase();
		 // Basic format test
		 if ( !nie.match('((^[A-Z]{1}[0-9]{7}[A-Z0-9]{1}$|^[T]{1}[A-Z0-9]{8}$)|^[0-9]{8}[A-Z]{1}$)') ) {
		  return false;
		 }
		 // Test NIE
		 //T
		 if ( /^[T]{1}/.test( nie ) ) {
		  return ( nie[ 8 ] === /^[T]{1}[A-Z0-9]{8}$/.test( nie ) );
		 }
		 //XYZ
		 if ( /^[XYZ]{1}/.test(nie)) {
		  return (
			nie[8] === "TRWAGMYFPDXBNJZSQVHLCKE".charAt(
			  nie.replace( 'X', '0' )
		     .replace( 'Y', '1' )
		     .replace( 'Z', '2' )
		     .substring( 0, 8 ) % 23
		   )
		  );
		 }
	}

	function validarDNICIFNIEPASAPORTEModal(value,tipoDocumento) {
		if (null != value && value != "") {
			value = value.toUpperCase();
			// compruebo que tipo de documento es
			switch (tipoDocumento) {
			case "1":
				return validateDNIModal(value);
			case "2":
				return validateCIFModal(value);
			case "3":
				return validateNIEModal(value);
			case "4":
				return validatePASAPORTEModal(value);
			default:
				return true; // si no ha elegido el tipo
			}
		}
		return true;
	}
});
